#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Mon Apr  3 14:03:38 2023

@author: meng
"""

#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Fri Mar 31 23:02:34 2023

@author: meng
"""



import nolds
from scipy.interpolate import griddata

from collections import Counter
import os
os.environ['PROJ_LIB'] = r'/home/meng/anaconda3/pkgs/proj-7.2.0-h8b9fe22_0/share/proj'
from matplotlib import colors 
from numpy.random import multivariate_normal 
import seaborn as sns
import pandas as pd
import matplotlib.pyplot as plt
import numpy as np
from scipy import stats
from matplotlib.ticker import MultipleLocator, FormatStrFormatter 
from scipy.stats.stats import pearsonr
from mpl_toolkits.basemap import Basemap, addcyclic, shiftgrid
from numpy import random, histogram2d, diff
import matplotlib.pyplot as plt
from scipy.interpolate import interp2d
import math
from matplotlib.ticker import (MultipleLocator, FormatStrFormatter,
                               AutoMinorLocator)
from scipy.stats import rankdata
    
from scipy.stats import gaussian_kde

import matplotlib as mpl
    
import glob
import seaborn as sns
def logistic(x,mu):
	y = mu*x*(1.0-x)
	return y 
def chaost(n1,n2,x0,mu):
    x=x0
    z=np.linspace(0.0,1.0,n2-n1)
    for i in range(0,n1):
        x=logistic(x,mu)
    for i in range(n1,n2):
        x=logistic(x,mu)
        z[i-n1]=x
    return z

def autoca(x,tau,l):
    z=[]
    for t in range(-tau,0):
        x1=x[tau:l+tau]
        x2=x[tau-t:l-t+tau]
        r=pearsonr(x1,x2)[0]
        z.append(abs(r))
    for t in range(0,tau):
        x1=x[tau-t:l+tau-t]
        x2=x[tau:l+tau]
        r=pearsonr(x1,x2)[0]
        z.append(abs(r))
    w=(1-np.mean(z))/np.std(z)
    return z
def autowa(x,tau,l):
    xx=autoca(x,tau,l)
    a=(1-np.mean(xx))/np.std(xx)
    return a
    
def pdswelch(x,fs): 
        
    from scipy import signal
    import numpy as np
    import matplotlib.pyplot as plt
    m=fs
    f, Pxx_den = signal.welch(x, fs, nperseg=m)
   # print (sum(Pxx_den))
    return f,Pxx_den/sum(Pxx_den)


def autow_ice():
    
    path='/home/meng/bak_bupt/newproj/data'
    tmpI=np.loadtxt(path+'/era5ice2.5d_ano_1979to2019_nonzero.ano')   

    monthds=[0,31,59,90,120,151,181,212,243,273,304,334,365]
    months=[31,28,31,30,31,30,31,31,30,31,30,31]
    N=14965
    a=10000
    T=np.reshape(tmpI,(377,N))
    regrid=np.loadtxt(path+'/nonzeroicenodes.dat')
    outfile=open(path+'/autow_northpole.dat','w')
    trendx0=pow(np.arange(N)/N,0.5)*a
    trendx1=pow(np.arange(N)/N,1)*a
    trendx2=pow(np.arange(N)/N,2)*a
    xr=np.arange(N)/N
    trendx3=np.sin(2*np.pi*xr*40)*1
    trendx4=np.sin(2*np.pi*xr*500)*1
   
    
    for year in range(1980,2020):
        if(year==2019):
            monx=12
        else:
            monx=13
        for month in range(1,monx):
            tau=10
            l=months[month-1]
            s1=365*(year-1979)+monthds[month-1]-tau
            s2=s1+l+2*tau  
            dataV=T[0][s1:s2]
            z=autowa(dataV,tau,l)
            z1=autowa(dataV+trendx0[s1:s2],tau,l)
            z2=autowa(dataV+trendx1[s1:s2],tau,l)
            z3=autowa(dataV+trendx2[s1:s2],tau,l)
            z4=autowa(dataV+trendx3[s1:s2],tau,l)
            z5=autowa(dataV+trendx4[s1:s2],tau,l)

            if(math.isnan(z) is True):
                print (node,year,month,z)
            outfile.write('%d %d %.6f %.6f %.6f %.6f %.6f %.6f\n'%(year,month,z,z1,z2,z3,z4,z5))
            outfile.flush()
    outfile.close()
            
                        
    data=np.loadtxt(path+'/autow_northpole.dat')



def mix_test():
    N=2000
    a=0
    for i in range(12):
        a+=pow(np.sin(2*np.pi*i/12),2)/12
    
    x=a*np.sin(2*np.pi*np.arange(N)/12)
    
    b=np.sqrt(3)
    y=np.random.uniform(-b,b,N)
    wx=[]
    px=np.arange(0,1,0.01)
    m=len(px)
    
    sn=10
    fs=18
    tau=10
    l=10
    
    wx0=[]
    sampx0=[]
    psdx0=[]
    for p in px:
            ratio=int(N*p)
            
            z1=np.zeros(N-ratio)
            z2=np.ones(ratio)
            z=list(z1)+list(z2)
            wx=[]
            sampx=[]
            psdx=[]
            for st in range(sn):        
                np.random.shuffle(z)
                z=np.array(z)
                y=np.array(y)
                x=np.array(x)
                
                mix=(1-z)*x+z*y
                trend=pow(np.arange(N)/N,1)*10000
                trendx=mix+trend
                w=autowa(trendx,tau,l)
                s=nolds.sampen(trendx[:l])    
                p1,p2=pdswelch(trendx[:l],fs)
                psd=sum(p1*p2)
                wx.append(w)
                sampx.append(s)
                psdx.append(psd)
            wx0.append(np.mean(wx))
            sampx0.append(np.mean(sampx))
            psdx0.append(np.mean(psdx))



def logistx_test():
    murange=np.arange(3.4,4,0.01)
    m=len(murange)
    sn=100
    tau=10
    l=30
    N=1500
    fs=18
    wx0=[]
    psdx0=[]
    sampx0=[]
    for mu in murange:


        wx=[]
        sampx=[]
        psdx=[]
        
        for times in range(sn):
            x0=np.random.choice(1000)/1000        
            logistx=chaost(500,500+N,x0,mu)           
            trendx=0*pow(np.arange(N)/N,2)
            newx=logistx+trendx
            w=autowa(newx,tau,l)
            wx.append(w)
            s=nolds.sampen(newx[:l])
            sampx.append(s)
            p1,p2=pdswelch(newx[:l],fs)
            psd=sum(p1*p2)
            psdx.append(psd)
            # la=nolds.lyap_r(newx[:l])
            # lyapx.append(la)
        wx0.append(np.mean(wx))
        sampx0.append(np.mean(sampx))
        psdx0.append(np.mean(psdx))
############################################################################################################################



def mix_test():
    N=2000
    a=0
    for i in range(12):
        a+=pow(np.sin(2*np.pi*i/12),2)/12
    
    x=a*np.sin(2*np.pi*np.arange(N)/12)
    
    b=np.sqrt(3)
    y=np.random.uniform(-b,b,N)
    wx=[]
    px=np.arange(0,1,0.01)
    m=len(px)
    
    sn=10
    fs=18
    tau=10
    l=30
    
    wx0=[]
    sampx0=[]
    psdx0=[]
    for p in px:
            ratio=int(N*p)
            
            z1=np.zeros(N-ratio)
            z2=np.ones(ratio)
            z=list(z1)+list(z2)
            wx=[]
            sampx=[]
            psdx=[]
            for st in range(sn):        
                np.random.shuffle(z)
                z=np.array(z)
                y=np.array(y)
                x=np.array(x)
                
                mix=(1-z)*x+z*y
                trend=pow(np.arange(N)/N,1)*10000
                trendx=mix+trend
                w=autowa(trendx,tau,l)
                s=nolds.sampen(trendx[:l])    
                p1,p2=pdswelch(trendx[:l],fs)
                psd=sum(p1*p2)
                wx.append(w)
                sampx.append(s)
                psdx.append(psd)
            wx0.append(np.mean(wx))
            sampx0.append(np.mean(sampx))
            psdx0.append(np.mean(psdx))



def logistx_test():
    murange=np.arange(3.4,4,0.01)
    m=len(murange)
    sn=100
    tau=20
    l=20
    N=1500
    fs=18
    wx0=[]
   # psdx0=[]
   # sampx0=[]
    for mu in murange:


        wx=[]
        sampx=[]
        psdx=[]
        
        for times in range(sn):
            x0=np.random.choice(1000)/1000        
            logistx=chaost(500,500+N,x0,mu)           
            trendx=1000*pow(np.arange(N)/N,2)
            newx=logistx+trendx
            w=autowa(newx,tau,l)
            wx.append(w)
            s=nolds.sampen(newx[:l])
            sampx.append(s)
            p1,p2=pdswelch(newx[:l],fs)
            psd=sum(p1*p2)
            psdx.append(psd)
            # la=nolds.lyap_r(newx[:l])
            # lyapx.append(la)
        wx0.append(np.mean(wx))
        #sampx0.append(np.mean(sampx))
       # psdx0.append(np.mean(psdx))





def mix_test():
    N=2000
    a=0
    for i in range(12):
        a+=pow(np.sin(2*np.pi*i/12),2)/12
    
    x=a*np.sin(2*np.pi*np.arange(N)/12)
    
    b=np.sqrt(3)
    y=np.random.uniform(-b,b,N)
    wx=[]
    px=np.arange(0,1,0.01)
    m=len(px)
    
    sn=10
    fs=18
    tau=10
    l=30
    
    wx0=[]
   # sampx0=[]
   # psdx0=[]
    for p in px:
            ratio=int(N*p)
            
            z1=np.zeros(N-ratio)
            z2=np.ones(ratio)
            z=list(z1)+list(z2)
            wx=[]
            sampx=[]
            psdx=[]
            for st in range(sn):        
                np.random.shuffle(z)
                z=np.array(z)
                y=np.array(y)
                x=np.array(x)
                
                mix=(1-z)*x+z*y
                
                xr=np.arange(N)/N
                trend=np.sin(2*np.pi*xr*10)*10
                trendx=mix+trend
                w=autowa(trendx,tau,l)
                s=nolds.sampen(trendx[:l])    
                p1,p2=pdswelch(trendx[:l],fs)
                psd=sum(p1*p2)
                wx.append(w)
                sampx.append(s)
                psdx.append(psd)
            wx0.append(np.mean(wx))
           # sampx0.append(np.mean(sampx))
           # psdx0.append(np.mean(psdx))



def logistx_test():
    murange=np.arange(3.4,4,0.01)
    m=len(murange)
    sn=100
    tau=10
    l=30
    N=1500
    fs=18
    wx0=[]
    psdx0=[]
    sampx0=[]
    for mu in murange:


        wx=[]
        sampx=[]
        psdx=[]
        
        for times in range(sn):
            x0=np.random.choice(1000)/1000        
            logistx=chaost(500,500+N,x0,mu) 
            xr=np.arange(N)/N
            trendx=np.sin(2*np.pi*xr*10)*1
            newx=logistx+trendx
            w=autowa(newx,tau,l)
            wx.append(w)
            s=nolds.sampen(newx[:l])
            sampx.append(s)
            p1,p2=pdswelch(newx[:l],fs)
            psd=sum(p1*p2)
            psdx.append(psd)
            # la=nolds.lyap_r(newx[:l])
            # lyapx.append(la)
        wx0.append(np.mean(wx))
        sampx0.append(np.mean(sampx))
        psdx0.append(np.mean(psdx))











###########################################################################################



xaxis=np.arange(3,4,0.1)
xaxis=[3.5,3.7,3.8]
mux=[]
for i in xaxis:
    mu=i
    n1=500
    n2=3000
    x0=0.1
    logistx=chaost(n1,n2,x0,mu)
    wx=[]
    dfax=[]
    sampx=[]
    axx=np.arange(10,1000,10)
    for a in axx:
        tau=5
        l=a
        w=autowa(logistx,tau,l)
        wx.append(w)
        #dfax.append(nolds.dfa(newx[:l]))
        #sampx.append(nolds.sampen(newx[:l]))
       # mux.append(mu)
    plt.plot(axx,wx,'o--')
    
    
    #plt.plot(np.log(axx[:]),np.log(wx[:]))












n1=0
n2=50
x=0.05
mu=3.1
logistx=chaost(n1,n2,x,mu)
#plt.plot(logistx,'o--')
y=np.fft.fft(logistx)
plt.plot(y)




dfax=[]
lyapx=[]
sampx=[]
wx=[]



tau=10
l=30
xaxis=np.arange(3,4,0.1)
xaxis=[3.5,3.7,3.8]
mux=[]
for i in xaxis:
    mu=i
    n1=500
    n2=2000
    x0=0.1
    logistx=chaost(n1,n2,x0,mu)
    wx=[]
    dfax=[]
    sampx=[]
    axx=np.arange(0,50,0.1)
    for a in axx:
        b=1
        trendx=linearx(a,b,n2-n1)
        newx=logistx+trendx
        w=autowa(newx,tau,l)
        wx.append(w)
        #dfax.append(nolds.dfa(newx[:l]))
        #sampx.append(nolds.sampen(newx[:l]))
       # mux.append(mu)
   # plt.plot(axx,wx)
    plt.plot(np.log(axx[:]),np.log(wx[:]))
    
wx=[]    
newx0=[]
for i in range(n2-n1):
    newx0.append(np.random.choice(n2-n1)/(n2-n1))
for a in axx:
    b=1
    trendx=linearx(a,b,n2-n1)
    newx=newx0+trendx
    w=autowa(newx,tau,l)
    wx.append(w)
#plt.plot(axx,wx)
plt.plot(np.log(axx),np.log(wx))





tau=10
l=1000
xaxis=np.arange(3,4,0.1)
xaxis=[3.5,3.7,3.8]
mux=[]
for i in xaxis:
    mu=i
    n1=500
    n2=2000
    x0=0.1
    logistx=chaost(n1,n2,x0,mu)
    wx=[]
    dfax=[]
    sampx=[]
    axx=np.arange(0,1000,1)
    for a in axx:
        b=5
        trendx=sinx(a,b,n2-n1)
        newx=logistx+trendx
        w=autowa(newx,tau,l)
        wx.append(w)
       # dfax.append(nolds.dfa(newx[:l],order=2))
        sampx.append(nolds.sampen(newx[:l]))
       # mux.append(mu)
   # plt.plot(axx,wx)
    plt.plot(np.log(axx[:]),np.log(sampx[:]))
    
wx=[]   
sampx=[] 
newx0=[]
for i in range(n2-n1):
    newx0.append(np.random.choice(n2-n1)/(n2-n1))
for a in axx:
    b=5
    trendx=sinx(a,b,n2-n1)
    newx=newx0+trendx
    w=autowa(newx,tau,l)
    wx.append(w)
    sampx.append(nolds.sampen(newx[:l]))

#plt.plot(axx,wx)
plt.plot(np.log(axx),np.log(wx))









wx=np.array(wx)
sampx=np.array(sampx)
plt.plot(mux,wx/2.5,'o--')
plt.plot(xaxis,sampx,'o--')

mu=3.65

logistx=chaost(n1,n2,x0,mu)

x1=logistx+np.arange(1500)*0

a=autowa(x1,tau*10,l*10)

print (a)



N=2000
a=0
for i in range(12):
    a+=pow(np.sin(2*np.pi*i/12),2)/12

x=a*np.sin(2*np.pi*np.arange(N)/12)

b=np.sqrt(3)
y=np.random.uniform(-b,b,N)
wx=[]
px=np.arange(0,1,0.01)
for l in range(10,1000,10):
    tau=10
    p=0.1
    ratio=int(N*p)
    
    z1=np.zeros(N-ratio)
    z2=np.ones(ratio)
    z=list(z1)+list(z2)
    np.random.shuffle(z)
    z=np.array(z)
    y=np.array(y)
    x=np.array(x)
    
    mix=(1-z)*x+z*y
    trend=np.arange(N)*10
    trendx=mix+trend
    w=autowa(trendx,tau,l)
    s=nolds.sampen(trendx[:l])
    print (p,w)
    wx.append(w)
plt.plot(wx[:])

wx=[]
px=np.arange(0,1,0.01)
for l in range(10,1000,10):
    tau=10
    p=0.9
    ratio=int(N*p)
    
    z1=np.zeros(N-ratio)
    z2=np.ones(ratio)
    z=list(z1)+list(z2)
    np.random.shuffle(z)
    z=np.array(z)
    y=np.array(y)
    x=np.array(x)
    
    mix=(1-z)*x+z*y
    trend=np.arange(N)*10
    trendx=mix+trend
    w=autowa(trendx,tau,l)
    s=nolds.sampen(trendx[:l])
    print (p,w)
    wx.append(w)
plt.plot(wx[:])



