#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Wed Apr 12 14:25:01 2023

@author: meng
"""

#!/usr/bin/env python2
# -*- coding: utf-8 -*-
"""
Created on Mon Jul 22 14:18:11 2019

@author: jingfang
"""
from netCDF4 import Dataset
import numpy as np
import glob
from matplotlib.ticker import MultipleLocator, FormatStrFormatter 
from scipy.stats.stats import pearsonr
from mpl_toolkits.basemap import Basemap, addcyclic, shiftgrid
from numpy import random, histogram2d, diff
import os
os.environ['PROJ_LIB'] = r'/home/jingfang/anaconda2/share/proj'
from scipy import signal
import matplotlib
#matplotlib.use('Agg')  # Or any other X11 back-end
from mpl_toolkits.basemap import Basemap, addcyclic, shiftgrid
#from mpl_toolkits.basemap import Basemap
import numpy as np
import matplotlib.pyplot as plt
from matplotlib.patches import Polygon
import math
from numpy import random

import pandas as pd
import seaborn as sns
import matplotlib.pyplot as plt
from scipy import stats

from scipy.interpolate import interp2d
from matplotlib.colors import LogNorm    
from scipy.stats.stats import pearsonr

from netCDF4 import Dataset

from scipy.stats import rankdata

from scipy.stats import gaussian_kde

import glob

import seaborn as sns
from scipy.interpolate import griddata


def divide_arctic():
    path='/home/meng/bak_bupt/newproj/data/'
    dataa=np.loadtxt(path+'iceage_1985_week22.dat')
    regrid=np.loadtxt(path+'nonzeroicenodes.dat')
    
    lats0=np.array(regrid[:,1])
    lons0=np.array(regrid[:,2])
    
    lats1=np.array(dataa[:,0])
    lons1=np.array(dataa[:,1])


    # outfile=open(path+'divide_arctic_iceage_12.dat','w')

    # lats=lats1
    # lons=lons1
    # age=dataa[:,2]
    # nodes=np.where(age<20)[0]
    # lats=lats1[nodes]
    # lons=lons1[nodes]
    # z=np.zeros(len(lats))
    # z0=np.zeros(len(lats))
    outfile=open(path+'divide_arctic_12.dat','w')
    lats=lats0
    lons=lons0    
    z=np.zeros(len(lats))
    z0=np.zeros(len(lats))
    nodes=np.arange(377)
    for i in range(len(nodes)):
        k=int(nodes[i])
        z0[i]=k
        lat=lats[i]
        lon=lons[i]
        if(lon>=0):
            lon=lon
        else:
            lon=360+lon
        if(lat<=60 and 120<lon<165):
            z[i]=1

        if(lat<=65 and 165<=lon<=200):
            z[i]=2

        if(50<lat<=65 and 260<=lon<=292.5):
            z[i]=3

        if(lat<=65 and 292.5<=lon<=315) or (65<lat<=80 and 280<=lon<=310):# or (lat<=50 and lon>=305):
            z[i]=4

        if(60<=lat<=80 and 315<lon<=360) or (70<=lat<=80 and lon<=25):
            z[i]=5
        if(60<lat<=80 and 25<lon<=100):
            z[i]=6
        if(lat>80):
            z[i]=7
        if(65<lat<=80 and 235<=lon<=280):
            z[i]=8
        if(65<=lat<=80 and 180<=lon<=210):
            z[i]=10
        if(65<=lat<=80 and 210<=lon<=235):
            z[i]=9            
        if(65<=lat<=80 and 100<lon<140):
            z[i]=12
        if(65<=lat<=80 and 140<=lon<180):
            z[i]=11
    for i in range(len(lats)):
        outfile.write('%d %d %.1f %.1f \n'%(z0[i],z[i],lats[i],lons[i]))
        outfile.flush()
    outfile.close()

def scattermap():
    fig=plt.figure()
    ax=fig.add_axes([0.1,0.1,0.8,0.8])   
    m = Basemap(projection='npstere',boundinglat=45,lon_0=270,resolution='l')
      
    m.drawcoastlines(linewidth = 1)
    m.drawlsmask(land_color='darkseagreen',ocean_color='k',lakes=True)
    m.drawparallels(np.arange(-80.,81.,20.))
    m.drawmeridians(np.arange(-180.,181.,20.))
    path='/home/meng/bak_bupt/newproj/data/'

    data=np.loadtxt(path+'divide_arctic_iceage_12.dat')
    nodes=np.where(data[:,1]>0)[0]
    lats1=data[:,2][nodes]
    lonsx=data[:,3][nodes]
    lons1=[]
    for i in range(len(lonsx)):
        lon=lonsx[i]
        if(lon>=0):
            lon=lon
        else:
            lon=360+lon
        lons1.append(lon)
    lats1=np.array(lats1)
    lons1=np.array(lons1)
    x, y = m(lons1,lats1)
    color=data[:,1][nodes]
    
    m.scatter(x,y,1,marker='o',c=color,cmap='tab20')
 #   m.scatter(x,y,1000,marker='o',c=color.map('colors'))

    data=np.loadtxt(path+'divide_arctic_12.dat')
    nodes=np.where(data[:,1]>0)[0]
    lats1=data[:,2][nodes]
    lonsx=data[:,3][nodes]
    lons1=[]
    for i in range(len(lonsx)):
        lon=lonsx[i]
        if(lon>=0):
            lon=lon
        else:
            lon=360+lon
        lons1.append(lon)
    lats1=np.array(lats1)
    lons1=np.array(lons1)
    x, y = m(lons1,lats1)
    x, y = m(lons1,lats1)
        
    m.scatter(x,y,250,facecolors='none', edgecolors='r',marker='o')



    ax.annotate('1', xy=(0.15, 0.7), xycoords='axes fraction', fontsize=64 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='w',
                    ha='left', va='bottom')
    ax.annotate('2', xy=(0.15, 0.48), xycoords='axes fraction', fontsize=64 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='w',
                    ha='left', va='bottom')
    ax.annotate('3', xy=(0.5, 0.15), xycoords='axes fraction', fontsize=64 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='w',
                    ha='left', va='bottom')
    ax.annotate('4', xy=(0.7, 0.18), xycoords='axes fraction', fontsize=64 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='w',
                    ha='left', va='bottom')
    ax.annotate('5', xy=(0.65, 0.45), xycoords='axes fraction', fontsize=64 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='w',
                    ha='left', va='bottom')
    ax.annotate('6', xy=(0.55, 0.62), xycoords='axes fraction', fontsize=64 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='w',
                    ha='left', va='bottom')
    ax.annotate('7', xy=(0.48, 0.48), xycoords='axes fraction', fontsize=64 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='w',
                    ha='left', va='bottom')
    ax.annotate('8', xy=(0.44, 0.35), xycoords='axes fraction', fontsize=64 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='w',
                    ha='left', va='bottom')
    ax.annotate('9', xy=(0.36, 0.38), xycoords='axes fraction', fontsize=64 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='w',
                    ha='left', va='bottom')
    ax.annotate('10', xy=(0.3, 0.45), xycoords='axes fraction', fontsize=64 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='w',
                    ha='left', va='bottom')
    ax.annotate('11', xy=(0.31, 0.53), xycoords='axes fraction', fontsize=64 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='w',
                    ha='left', va='bottom')
    ax.annotate('12', xy=(0.39, 0.6), xycoords='axes fraction', fontsize=64 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='w',
                    ha='left', va='bottom')
    figure = plt.gcf() # get current figure
        # 
    figure.set_size_inches(24, 20)
    
    
    #ax.set_title('Great Circle from New York to London')
    #plt.show()
    plt.savefig("/home/meng/bak_bupt/newproj/fig/nodes_iceage_12.pdf",format='pdf',dpi=300,bbox_inches='tight')
    
    
def rereaddata():  
    path='/home/meng/bak_bupt/newproj/data/'
    datax=np.loadtxt(path+'availnodes.dat')
    nodes=[int(i) for i in datax[:,0]]
    psd=np.loadtxt(path+'psd_sum_ICE.dat')#reshape(377,480)
    N=377
    psdxx=np.reshape(psd,(N,480))

    acf=np.loadtxt(path+'autocorr_abs_ice.dat')#reshape(480,377)
    N=377
    acfxx=np.reshape(acf,(480,N))
    
    months=[12*n+5 for n in range(6,40)]
    
    icen=np.loadtxt(path+'divide_arctic_12.dat')

    outfile=open(path+'acf_regions_12.dat','w')
    for i in range(1,13):
        nodess=np.where(icen[:,1]==i)[0]
        for k in months:

            a=[]
            for j in nodess:
                if(acfxx[k,j]>0):
                   a.append(acfxx[k,j])
            
            outfile.write('%.6f \n'%(np.mean(a)))
            outfile.flush()
    outfile.close()

    outfile=open(path+'psd_regions_12.dat','w')
    for i in range(1,13):
        nodess=np.where(icen[:,1]==i)[0]
        for k in months:

            a=[]
            for j in nodess:
                if(psdxx[j,k]>0):
                   a.append(psdxx[j,k])
            
            outfile.write('%.6f \n'%(np.mean(a)))
            outfile.flush()
    outfile.close()




    iceagen=np.loadtxt(path+'divide_arctic_iceage_12.dat')

    outfile=open(path+'iceage_regions_12.dat','w')
    
    for year in range(1986,2020):
        print (year)
        files=glob.glob(path+"iceage/iceage_nh_12.5km_"+str(year)+"0101_"+str(year)+"1231_v4.1.nc")
        #data=Dataset('/home/meng/bupt_data/data/iceage/iceage_nh_12.5km_19840101_19841231_v4.1.nc','r',format='NETCDF4')
        #data=Dataset('/home/meng/bupt_data/data/seaice/iceage/iceage_nh_12.5km_19840101_19841231_v4.1.nc','r',format='NETCDF4')
        data=Dataset(files[0],'r')
        iceage=data.variables['age_of_sea_ice'][:]
        lats=data.variables['latitude'][:]
        lons=data.variables['longitude'][:]
        for i in range(1,13):
            sets=np.where(iceagen[:,1]==i)[0]
            nodess=iceagen[:,0][sets]
            z=[]
            aa=0
            for j in nodess:
                a=j/722
                b=j%722
                a=int(a)
                b=int(b)
               # print (lats[a,b],lons[a,b],iceage[0,a,b])
                z.append(np.mean(iceage[22:26,a,b]))
            outfile.write('%.6f \n'%(np.mean(z)))
            outfile.flush()
    outfile.close()




    iceagen=np.loadtxt(path+'divide_arctic_iceage_12.dat')

    outfile=open(path+'iceage_regions_fresh_12.dat','w')
    
    for year in range(1986,2020):
        print (year)
        files=glob.glob(path+"iceage/iceage_nh_12.5km_"+str(year)+"0101_"+str(year)+"1231_v4.1.nc")
        #data=Dataset('/home/meng/bupt_data/data/iceage/iceage_nh_12.5km_19840101_19841231_v4.1.nc','r',format='NETCDF4')
        #data=Dataset('/home/meng/bupt_data/data/seaice/iceage/iceage_nh_12.5km_19840101_19841231_v4.1.nc','r',format='NETCDF4')
        data=Dataset(files[0],'r')
        iceage=data.variables['age_of_sea_ice'][:]
        lats=data.variables['latitude'][:]
        lons=data.variables['longitude'][:]
        for i in range(1,13):
            sets=np.where(iceagen[:,1]==i)[0]
            nodess=iceagen[:,0][sets]
            z=0
            w=0
            u=0
            z1=0
            for j in nodess:
                a=j/722
                b=j%722
                a=int(a)
                b=int(b)
                y=np.where(iceage[22:26,a,b]<2)[0]
                if(len(y)>2):
                    z+=1
                y1=np.where(iceage[22:26,a,b]==1)[0]
                if(len(y1)>2):
                    w+=1
                y1=np.where(iceage[22:26,a,b]<3)[0]
                if(len(y1)>2):
                    u+=1
                y2=np.where(iceage[22:26,a,b]>2)[0]
                y3=np.where(iceage[22:26,a,b][y2]<17)[0]
                if(len(y3)>=1):
                    z1+=1
                
               # print (lats[a,b],lons[a,b],iceage[0,a,b])
            outfile.write('%.6f %.6f %.6f %.6f \n'%(z/len(sets),w/len(sets),u/len(sets),z1/len(sets)))
            outfile.flush()
    outfile.close()



 
def plot_indexes():
    data0=np.loadtxt(path+'iceage_regions_12.dat')
    icex0=np.reshape(data0,(34,12))
            
    data1=np.loadtxt(path+'iceage_regions_fresh_12.dat',)
    icex1=np.reshape(data1[:,0],(34,12))

    icex2=np.reshape(data1[:,1],(34,12))


    data2=np.loadtxt(path+'psd_regions.dat')
    psdx=np.reshape(data2,(12,34))
    
    data3=np.loadtxt(path+'acf_regions.dat')    
    acfx=np.reshape(data3,(12,34))
    
    def vx(x):
        a=np.mean(x)
        b=max(x)
        c=np.std(x)
        y=x/(c)
        return y
    
    
    iceagen=np.loadtxt(path+'divide_arctic_iceage_12.dat')
    
    ax=plt.subplot2grid((3,4), (0,0))
    i=0
    xmajorLocator = MultipleLocator(8) #将x主刻度标签设置为20的倍数
    xmajorFormatter = FormatStrFormatter('%d') #设置x轴标签文本的格式
    ymajorLocator = MultipleLocator(0.2) #将y轴主刻度标签设置为0.5的倍数
    ymajorFormatter = FormatStrFormatter('%.1f') #设置y轴标签文本的格式
    #设置主刻度标签的位置,标签文本的格式
    ax.xaxis.set_major_locator(xmajorLocator)
    ax.xaxis.set_major_formatter(xmajorFormatter)
    ax.yaxis.set_major_locator(ymajorLocator)
    ax.yaxis.set_major_formatter(ymajorFormatter)
    
    #修改次刻度
    xminorLocator = MultipleLocator(1) #将x轴次刻度标签设置为5的倍数
    yminorLocator = MultipleLocator(0.1) #将此y轴次刻度标签设置为0.1的倍数
    #设置次刻度标签的位置,没有标签文本格式
    ax.xaxis.set_minor_locator(xminorLocator)
    ax.yaxis.set_minor_locator(yminorLocator) 
    ax.tick_params(which='both', width=2)
    ax.tick_params(which='major', length=9)  
    ax.tick_params(which='minor',length=5)
    #plt.plot(taux,dpn,'k--',label='globe')
   

    plt.xticks(fontsize=26)
    plt.yticks(fontsize=26)
   # plt.xlabel('$Year$',fontsize=28)
    
    plt.ylim(-0.1,1.1)
    murange=np.arange(34)+1986
    
    sets=np.where(iceagen[:,1]==i+1)[0]
        
   # plt.scatter(murange,wl1000[:,2], s=100, facecolors='none', edgecolors='#ef476f',label='b=2')
    plt.plot(murange,icex1[:,i],color='gray',label='iceage')
    plt.plot(murange,acfx[i]/max(data3),color='#8cdcda',label='$W_{ACF}$')  
    plt.plot(murange,psdx[i]/max(data2),color='#f16a70',label='$W_{PS}$')
    
    



    plt.title('Sea of Okhotsk',fontsize=32)
    
    plt.annotate('a', xy=(-0.1,1.05), xycoords='axes fraction', fontsize=32, weight='bold',
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom')  
    
    ax=plt.subplot2grid((3,4), (0,1))
    i=1
    xmajorLocator = MultipleLocator(8) #将x主刻度标签设置为20的倍数
    xmajorFormatter = FormatStrFormatter('%d') #设置x轴标签文本的格式
    ymajorLocator = MultipleLocator(0.2) #将y轴主刻度标签设置为0.5的倍数
    ymajorFormatter = FormatStrFormatter('%.1f') #设置y轴标签文本的格式
    #设置主刻度标签的位置,标签文本的格式
    ax.xaxis.set_major_locator(xmajorLocator)
    ax.xaxis.set_major_formatter(xmajorFormatter)
    ax.yaxis.set_major_locator(ymajorLocator)
    ax.yaxis.set_major_formatter(ymajorFormatter)
    
    #修改次刻度
    xminorLocator = MultipleLocator(1) #将x轴次刻度标签设置为5的倍数
    yminorLocator = MultipleLocator(0.1) #将此y轴次刻度标签设置为0.1的倍数
    #设置次刻度标签的位置,没有标签文本格式
    ax.xaxis.set_minor_locator(xminorLocator)
    ax.yaxis.set_minor_locator(yminorLocator) 
    ax.tick_params(which='both', width=2)
    ax.tick_params(which='major', length=9)  
    ax.tick_params(which='minor',length=5)
    #plt.plot(taux,dpn,'k--',label='globe')
   

    plt.xticks(fontsize=26)
    plt.yticks(fontsize=26)
   # plt.xlabel('$Year$',fontsize=28)
    plt.ylim(-0.1,1.1)
    
    
    murange=np.arange(34)+1986
    
    sets=np.where(iceagen[:,1]==i+1)[0]
        
    plt.plot(murange,icex1[:,i],color='gray',label='iceage')
    plt.plot(murange,acfx[i]/max(data3),color='#8cdcda',label='$W_{ACF}$')  
    plt.plot(murange,psdx[i]/max(data2),color='#f16a70',label='$W_{PS}$')
    

    plt.title('Bering Sea',fontsize=32)
    
    plt.annotate('b', xy=(-0.1,1.05), xycoords='axes fraction', fontsize=32, weight='bold',
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom') 


    ax=plt.subplot2grid((3,4), (0,2))
    i=2
    xmajorLocator = MultipleLocator(8) #将x主刻度标签设置为20的倍数
    xmajorFormatter = FormatStrFormatter('%d') #设置x轴标签文本的格式
    ymajorLocator = MultipleLocator(0.2) #将y轴主刻度标签设置为0.5的倍数
    ymajorFormatter = FormatStrFormatter('%.1f') #设置y轴标签文本的格式
    #设置主刻度标签的位置,标签文本的格式
    ax.xaxis.set_major_locator(xmajorLocator)
    ax.xaxis.set_major_formatter(xmajorFormatter)
    ax.yaxis.set_major_locator(ymajorLocator)
    ax.yaxis.set_major_formatter(ymajorFormatter)
    
    #修改次刻度
    xminorLocator = MultipleLocator(1) #将x轴次刻度标签设置为5的倍数
    yminorLocator = MultipleLocator(0.1) #将此y轴次刻度标签设置为0.1的倍数
    #设置次刻度标签的位置,没有标签文本格式
    ax.xaxis.set_minor_locator(xminorLocator)
    ax.yaxis.set_minor_locator(yminorLocator) 
    ax.tick_params(which='both', width=2)
    ax.tick_params(which='major', length=9)  
    ax.tick_params(which='minor',length=5)
    #plt.plot(taux,dpn,'k--',label='globe')
   

    plt.xticks(fontsize=26)
    plt.yticks(fontsize=26)
   # plt.xlabel('$Year$',fontsize=28)
    plt.ylim(-0.1,1.1)
    
    
    murange=np.arange(34)+1986
    
    sets=np.where(iceagen[:,1]==i+1)[0]
        
    plt.plot(murange,icex1[:,i],color='gray',label='iceage')
    plt.plot(murange,acfx[i]/max(data3),color='#8cdcda',label='$W_{ACF}$')  
    plt.plot(murange,psdx[i]/max(data2),color='#f16a70',label='$W_{PS}$')
    

    plt.title('Hudson Bay',fontsize=32)
    
    plt.annotate('c', xy=(-0.1,1.05), xycoords='axes fraction', fontsize=32, weight='bold',
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom')  
    
    ax=plt.subplot2grid((3,4), (0,3))
    i=3
    xmajorLocator = MultipleLocator(8) #将x主刻度标签设置为20的倍数
    xmajorFormatter = FormatStrFormatter('%d') #设置x轴标签文本的格式
    ymajorLocator = MultipleLocator(0.2) #将y轴主刻度标签设置为0.5的倍数
    ymajorFormatter = FormatStrFormatter('%.1f') #设置y轴标签文本的格式
    #设置主刻度标签的位置,标签文本的格式
    ax.xaxis.set_major_locator(xmajorLocator)
    ax.xaxis.set_major_formatter(xmajorFormatter)
    ax.yaxis.set_major_locator(ymajorLocator)
    ax.yaxis.set_major_formatter(ymajorFormatter)
    
    #修改次刻度
    xminorLocator = MultipleLocator(1) #将x轴次刻度标签设置为5的倍数
    yminorLocator = MultipleLocator(0.1) #将此y轴次刻度标签设置为0.1的倍数
    #设置次刻度标签的位置,没有标签文本格式
    ax.xaxis.set_minor_locator(xminorLocator)
    ax.yaxis.set_minor_locator(yminorLocator) 
    ax.tick_params(which='both', width=2)
    ax.tick_params(which='major', length=9)  
    ax.tick_params(which='minor',length=5)
    #plt.plot(taux,dpn,'k--',label='globe')
   

    plt.xticks(fontsize=26)
    plt.yticks(fontsize=26)
   # plt.xlabel('$Year$',fontsize=28)
    plt.ylim(-0.1,1.1)
    
    
    murange=np.arange(34)+1986
    
    sets=np.where(iceagen[:,1]==i+1)[0]
        
    plt.plot(murange,icex1[:,i],color='gray',label='Ratio of Fresh Ice')
    plt.plot(murange,acfx[i]/max(data3),color='#8cdcda',label='$W_{ACF}$')  
    plt.plot(murange,psdx[i]/max(data2),color='#f16a70',label='$W_{PS}$')
    

    plt.title('Baffin Bay',fontsize=32)
    plt.legend(fontsize=32,loc=1,bbox_to_anchor=(1.0,1.7))
    
    plt.annotate('d', xy=(-0.1,1.05), xycoords='axes fraction', fontsize=32, weight='bold',
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom') 
    
    
    ax=plt.subplot2grid((3,4), (1,0))
    i=4
    xmajorLocator = MultipleLocator(8) #将x主刻度标签设置为20的倍数
    xmajorFormatter = FormatStrFormatter('%d') #设置x轴标签文本的格式
    ymajorLocator = MultipleLocator(0.2) #将y轴主刻度标签设置为0.5的倍数
    ymajorFormatter = FormatStrFormatter('%.1f') #设置y轴标签文本的格式
    #设置主刻度标签的位置,标签文本的格式
    ax.xaxis.set_major_locator(xmajorLocator)
    ax.xaxis.set_major_formatter(xmajorFormatter)
    ax.yaxis.set_major_locator(ymajorLocator)
    ax.yaxis.set_major_formatter(ymajorFormatter)
    
    #修改次刻度
    xminorLocator = MultipleLocator(1) #将x轴次刻度标签设置为5的倍数
    yminorLocator = MultipleLocator(0.1) #将此y轴次刻度标签设置为0.1的倍数
    #设置次刻度标签的位置,没有标签文本格式
    ax.xaxis.set_minor_locator(xminorLocator)
    ax.yaxis.set_minor_locator(yminorLocator) 
    ax.tick_params(which='both', width=2)
    ax.tick_params(which='major', length=9)  
    ax.tick_params(which='minor',length=5)
    #plt.plot(taux,dpn,'k--',label='globe')
   

    plt.xticks(fontsize=26)
    plt.yticks(fontsize=26)
   # plt.xlabel('$Year$',fontsize=28)
    plt.ylim(-0.1,1.1)
    
    
    murange=np.arange(34)+1986
    
    sets=np.where(iceagen[:,1]==i+1)[0]
        
    plt.plot(murange,icex1[:,i],color='gray',label='iceage')
    plt.plot(murange,acfx[i]/max(data3),color='#8cdcda',label='$W_{ACF}$')  
    plt.plot(murange,psdx[i]/max(data2),color='#f16a70',label='$W_{PS}$')
    
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,icex1[:,i])
    icey=slope*murange+intercept
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,psdx[i]/max(data2))
    psdy=slope*murange+intercept
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,acfx[i]/max(data3))
    acfy=slope*murange+intercept
  #  plt.plot(murange,acfy,'--',color='b')
    plt.plot(murange,psdy,'--',color='r')
    plt.plot(murange,icey,'--',color='k')
    plt.title('Greenland Sea',fontsize=32)
    
    plt.annotate('e', xy=(-0.1,1.05), xycoords='axes fraction', fontsize=32, weight='bold',
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom')     


    ax=plt.subplot2grid((3,4), (1,1))
    i=5
    xmajorLocator = MultipleLocator(8) #将x主刻度标签设置为20的倍数
    xmajorFormatter = FormatStrFormatter('%d') #设置x轴标签文本的格式
    ymajorLocator = MultipleLocator(0.2) #将y轴主刻度标签设置为0.5的倍数
    ymajorFormatter = FormatStrFormatter('%.1f') #设置y轴标签文本的格式
    #设置主刻度标签的位置,标签文本的格式
    ax.xaxis.set_major_locator(xmajorLocator)
    ax.xaxis.set_major_formatter(xmajorFormatter)
    ax.yaxis.set_major_locator(ymajorLocator)
    ax.yaxis.set_major_formatter(ymajorFormatter)
    
    #修改次刻度
    xminorLocator = MultipleLocator(1) #将x轴次刻度标签设置为5的倍数
    yminorLocator = MultipleLocator(0.1) #将此y轴次刻度标签设置为0.1的倍数
    #设置次刻度标签的位置,没有标签文本格式
    ax.xaxis.set_minor_locator(xminorLocator)
    ax.yaxis.set_minor_locator(yminorLocator) 
    ax.tick_params(which='both', width=2)
    ax.tick_params(which='major', length=9)  
    ax.tick_params(which='minor',length=5)
    #plt.plot(taux,dpn,'k--',label='globe')
   

    plt.xticks(fontsize=26)
    plt.yticks(fontsize=26)
   # plt.xlabel('$Year$',fontsize=28)
    plt.ylim(-0.1,1.1)
    
    
    murange=np.arange(34)+1986
    
    sets=np.where(iceagen[:,1]==i+1)[0]
        
    plt.plot(murange,icex1[:,i],color='gray',label='iceage')
    plt.plot(murange,acfx[i]/max(data3),color='#8cdcda',label='$W_{ACF}$')  
    plt.plot(murange,psdx[i]/max(data2),color='#f16a70',label='$W_{PS}$')
    
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,icex1[:,i])
    icey=slope*murange+intercept
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,psdx[i]/max(data2))
    psdy=slope*murange+intercept
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,acfx[i]/max(data3))
    acfy=slope*murange+intercept
   # plt.plot(murange,acfy,'--',color='b')
   # plt.plot(murange,psdy,'--',color='r')
    plt.plot(murange,icey,'--',color='k')
    plt.title('Barents-Kara Sea',fontsize=32)
    
    plt.annotate('f', xy=(-0.1,1.05), xycoords='axes fraction', fontsize=32, weight='bold',
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom') 


    ax=plt.subplot2grid((3,4), (1,2))
    i=6
    xmajorLocator = MultipleLocator(8) #将x主刻度标签设置为20的倍数
    xmajorFormatter = FormatStrFormatter('%d') #设置x轴标签文本的格式
    ymajorLocator = MultipleLocator(0.2) #将y轴主刻度标签设置为0.5的倍数
    ymajorFormatter = FormatStrFormatter('%.1f') #设置y轴标签文本的格式
    #设置主刻度标签的位置,标签文本的格式
    ax.xaxis.set_major_locator(xmajorLocator)
    ax.xaxis.set_major_formatter(xmajorFormatter)
    ax.yaxis.set_major_locator(ymajorLocator)
    ax.yaxis.set_major_formatter(ymajorFormatter)
    
    #修改次刻度
    xminorLocator = MultipleLocator(1) #将x轴次刻度标签设置为5的倍数
    yminorLocator = MultipleLocator(0.1) #将此y轴次刻度标签设置为0.1的倍数
    #设置次刻度标签的位置,没有标签文本格式
    ax.xaxis.set_minor_locator(xminorLocator)
    ax.yaxis.set_minor_locator(yminorLocator) 
    ax.tick_params(which='both', width=2)
    ax.tick_params(which='major', length=9)  
    ax.tick_params(which='minor',length=5)
    #plt.plot(taux,dpn,'k--',label='globe')
   

    plt.xticks(fontsize=26)
    plt.yticks(fontsize=26)
   # plt.xlabel('$Year$',fontsize=28)
    plt.ylim(-0.1,1.1)
    
    
    murange=np.arange(34)+1986
    
    sets=np.where(iceagen[:,1]==i+1)[0]
        
    plt.plot(murange,icex1[:,i],color='gray',label='iceage')
    plt.plot(murange,acfx[i]/max(data3),color='#8cdcda',label='$W_{ACF}$')  
    plt.plot(murange,psdx[i]/max(data2),color='#f16a70',label='$W_{PS}$')
    
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,icex1[:,i])
    icey=slope*murange+intercept
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,psdx[i]/max(data2))
    psdy=slope*murange+intercept
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,acfx[i]/max(data3))
    acfy=slope*murange+intercept
    plt.plot(murange,acfy,'--',color='b')
    plt.plot(murange,psdy,'--',color='r')
    plt.plot(murange,icey,'--',color='k')
    plt.title('Central Arctic',fontsize=32)
    
    plt.annotate('g', xy=(-0.1,1.05), xycoords='axes fraction', fontsize=32, weight='bold',
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom') 

    ax=plt.subplot2grid((3,4), (1,3))
    i=7
    xmajorLocator = MultipleLocator(8) #将x主刻度标签设置为20的倍数
    xmajorFormatter = FormatStrFormatter('%d') #设置x轴标签文本的格式
    ymajorLocator = MultipleLocator(0.2) #将y轴主刻度标签设置为0.5的倍数
    ymajorFormatter = FormatStrFormatter('%.1f') #设置y轴标签文本的格式
    #设置主刻度标签的位置,标签文本的格式
    ax.xaxis.set_major_locator(xmajorLocator)
    ax.xaxis.set_major_formatter(xmajorFormatter)
    ax.yaxis.set_major_locator(ymajorLocator)
    ax.yaxis.set_major_formatter(ymajorFormatter)
    
    #修改次刻度
    xminorLocator = MultipleLocator(1) #将x轴次刻度标签设置为5的倍数
    yminorLocator = MultipleLocator(0.1) #将此y轴次刻度标签设置为0.1的倍数
    #设置次刻度标签的位置,没有标签文本格式
    ax.xaxis.set_minor_locator(xminorLocator)
    ax.yaxis.set_minor_locator(yminorLocator) 
    ax.tick_params(which='both', width=2)
    ax.tick_params(which='major', length=9)  
    ax.tick_params(which='minor',length=5)
    #plt.plot(taux,dpn,'k--',label='globe')
   

    plt.xticks(fontsize=26)
    plt.yticks(fontsize=26)
   # plt.xlabel('$Year$',fontsize=28)
    plt.ylim(-0.1,1.1)
    
    
    murange=np.arange(34)+1986
    
    sets=np.where(iceagen[:,1]==i+1)[0]
        
    plt.plot(murange,icex1[:,i],color='gray',label='iceage')
    plt.plot(murange,acfx[i]/max(data3),color='#8cdcda',label='$W_{ACF}$')  
    plt.plot(murange,psdx[i]/max(data2),color='#f16a70',label='$W_{PS}$')
    
  
    plt.title('Canadian Arctic',fontsize=32)
    
    plt.annotate('h', xy=(-0.1,1.05), xycoords='axes fraction', fontsize=32, weight='bold',
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom') 

    ax=plt.subplot2grid((3,4), (2,0))
    i=8
    xmajorLocator = MultipleLocator(8) #将x主刻度标签设置为20的倍数
    xmajorFormatter = FormatStrFormatter('%d') #设置x轴标签文本的格式
    ymajorLocator = MultipleLocator(0.2) #将y轴主刻度标签设置为0.5的倍数
    ymajorFormatter = FormatStrFormatter('%.1f') #设置y轴标签文本的格式
    #设置主刻度标签的位置,标签文本的格式
    ax.xaxis.set_major_locator(xmajorLocator)
    ax.xaxis.set_major_formatter(xmajorFormatter)
    ax.yaxis.set_major_locator(ymajorLocator)
    ax.yaxis.set_major_formatter(ymajorFormatter)
    
    #修改次刻度
    xminorLocator = MultipleLocator(1) #将x轴次刻度标签设置为5的倍数
    yminorLocator = MultipleLocator(0.1) #将此y轴次刻度标签设置为0.1的倍数
    #设置次刻度标签的位置,没有标签文本格式
    ax.xaxis.set_minor_locator(xminorLocator)
    ax.yaxis.set_minor_locator(yminorLocator) 
    ax.tick_params(which='both', width=2)
    ax.tick_params(which='major', length=9)  
    ax.tick_params(which='minor',length=5)
    #plt.plot(taux,dpn,'k--',label='globe')
   

    plt.xticks(fontsize=26)
    plt.yticks(fontsize=26)
   # plt.xlabel('$Year$',fontsize=28)
    plt.ylim(-0.1,1.1)
    
    
    murange=np.arange(34)+1986
    
    sets=np.where(iceagen[:,1]==i+1)[0]
        
    plt.plot(murange,icex1[:,i],color='gray',label='iceage')
    plt.plot(murange,acfx[i]/max(data3),color='#8cdcda',label='$W_{ACF}$')  
    plt.plot(murange,psdx[i]/max(data2),color='#f16a70',label='$W_{PS}$')
    
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,icex1[:,i])
    icey=slope*murange+intercept
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,psdx[i]/max(data2))
    psdy=slope*murange+intercept
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,acfx[i]/max(data3))
    acfy=slope*murange+intercept
    #plt.plot(murange,acfy,'--',color='b')
   # plt.plot(murange,psdy,'--',color='r')
    plt.plot(murange,icey,'--',color='k')
    plt.title('Beaufort Sea',fontsize=32)
    
    plt.annotate('i', xy=(-0.1,1.05), xycoords='axes fraction', fontsize=32, weight='bold',
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom') 

    ax=plt.subplot2grid((3,4), (2,1))
    i=9
    xmajorLocator = MultipleLocator(8) #将x主刻度标签设置为20的倍数
    xmajorFormatter = FormatStrFormatter('%d') #设置x轴标签文本的格式
    ymajorLocator = MultipleLocator(0.2) #将y轴主刻度标签设置为0.5的倍数
    ymajorFormatter = FormatStrFormatter('%.1f') #设置y轴标签文本的格式
    #设置主刻度标签的位置,标签文本的格式
    ax.xaxis.set_major_locator(xmajorLocator)
    ax.xaxis.set_major_formatter(xmajorFormatter)
    ax.yaxis.set_major_locator(ymajorLocator)
    ax.yaxis.set_major_formatter(ymajorFormatter)
    
    #修改次刻度
    xminorLocator = MultipleLocator(1) #将x轴次刻度标签设置为5的倍数
    yminorLocator = MultipleLocator(0.1) #将此y轴次刻度标签设置为0.1的倍数
    #设置次刻度标签的位置,没有标签文本格式
    ax.xaxis.set_minor_locator(xminorLocator)
    ax.yaxis.set_minor_locator(yminorLocator) 
    ax.tick_params(which='both', width=2)
    ax.tick_params(which='major', length=9)  
    ax.tick_params(which='minor',length=5)
    #plt.plot(taux,dpn,'k--',label='globe')
   

    plt.xticks(fontsize=26)
    plt.yticks(fontsize=26)
   # plt.xlabel('$Year$',fontsize=28)
    plt.ylim(-0.1,1.1)
    
    
    murange=np.arange(34)+1986
    
    sets=np.where(iceagen[:,1]==i+1)[0]
        
    plt.plot(murange,icex1[:,i],color='gray',label='iceage')
    plt.plot(murange,acfx[i]/max(data3),color='#8cdcda',label='$W_{ACF}$')  
    plt.plot(murange,psdx[i]/max(data2),color='#f16a70',label='$W_{PS}$')
    
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,icex1[:,i])
    icey=slope*murange+intercept
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,psdx[i]/max(data2))
    psdy=slope*murange+intercept
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,acfx[i]/max(data3))
    acfy=slope*murange+intercept
   # plt.plot(murange,acfy,'--',color='b')
    plt.plot(murange,psdy,'--',color='r')
    plt.plot(murange,icey,'--',color='k')
    plt.title('Chukchi Sea',fontsize=32)
    
    plt.annotate('j', xy=(-0.1,1.05), xycoords='axes fraction', fontsize=32, weight='bold',
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom') 

    ax=plt.subplot2grid((3,4), (2,2))
    i=10
    xmajorLocator = MultipleLocator(8) #将x主刻度标签设置为20的倍数
    xmajorFormatter = FormatStrFormatter('%d') #设置x轴标签文本的格式
    ymajorLocator = MultipleLocator(0.2) #将y轴主刻度标签设置为0.5的倍数
    ymajorFormatter = FormatStrFormatter('%.1f') #设置y轴标签文本的格式
    #设置主刻度标签的位置,标签文本的格式
    ax.xaxis.set_major_locator(xmajorLocator)
    ax.xaxis.set_major_formatter(xmajorFormatter)
    ax.yaxis.set_major_locator(ymajorLocator)
    ax.yaxis.set_major_formatter(ymajorFormatter)
    
    #修改次刻度
    xminorLocator = MultipleLocator(1) #将x轴次刻度标签设置为5的倍数
    yminorLocator = MultipleLocator(0.1) #将此y轴次刻度标签设置为0.1的倍数
    #设置次刻度标签的位置,没有标签文本格式
    ax.xaxis.set_minor_locator(xminorLocator)
    ax.yaxis.set_minor_locator(yminorLocator) 
    ax.tick_params(which='both', width=2)
    ax.tick_params(which='major', length=9)  
    ax.tick_params(which='minor',length=5)
    #plt.plot(taux,dpn,'k--',label='globe')
   

    plt.xticks(fontsize=26)
    plt.yticks(fontsize=26)
   # plt.xlabel('$Year$',fontsize=28)
    plt.ylim(-0.1,1.1)
    
    
    murange=np.arange(34)+1986
    
    sets=np.where(iceagen[:,1]==i+1)[0]
        
    plt.plot(murange,icex1[:,i],color='gray',label='iceage')
    plt.plot(murange,acfx[i]/max(data3),color='#8cdcda',label='$W_{ACF}$')  
    plt.plot(murange,psdx[i]/max(data2),color='#f16a70',label='$W_{PS}$')
    
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,icex1[:,i])
    icey=slope*murange+intercept
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,psdx[i]/max(data2))
    psdy=slope*murange+intercept
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,acfx[i]/max(data3))
    acfy=slope*murange+intercept
   # plt.plot(murange,acfy,'--',color='b')
   # plt.plot(murange,psdy,'--',color='r')
    plt.plot(murange,icey,'--',color='k')
    plt.title('E. Siberian Sea',fontsize=32)
    
    plt.annotate('k', xy=(-0.1,1.05), xycoords='axes fraction', fontsize=32, weight='bold',
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom') 

    ax=plt.subplot2grid((3,4), (2,3))
    i=11
    xmajorLocator = MultipleLocator(8) #将x主刻度标签设置为20的倍数
    xmajorFormatter = FormatStrFormatter('%d') #设置x轴标签文本的格式
    ymajorLocator = MultipleLocator(0.2) #将y轴主刻度标签设置为0.5的倍数
    ymajorFormatter = FormatStrFormatter('%.1f') #设置y轴标签文本的格式
    #设置主刻度标签的位置,标签文本的格式
    ax.xaxis.set_major_locator(xmajorLocator)
    ax.xaxis.set_major_formatter(xmajorFormatter)
    ax.yaxis.set_major_locator(ymajorLocator)
    ax.yaxis.set_major_formatter(ymajorFormatter)
    
    #修改次刻度
    xminorLocator = MultipleLocator(1) #将x轴次刻度标签设置为5的倍数
    yminorLocator = MultipleLocator(0.1) #将此y轴次刻度标签设置为0.1的倍数
    #设置次刻度标签的位置,没有标签文本格式
    ax.xaxis.set_minor_locator(xminorLocator)
    ax.yaxis.set_minor_locator(yminorLocator) 
    ax.tick_params(which='both', width=2)
    ax.tick_params(which='major', length=9)  
    ax.tick_params(which='minor',length=5)
    #plt.plot(taux,dpn,'k--',label='globe')
   

    plt.xticks(fontsize=26)
    plt.yticks(fontsize=26)
  #  plt.ylim(0.38,1.02)
   # plt.xlabel('$Year$',fontsize=28)
    plt.ylim(-0.1,1.1)
    
    
    murange=np.arange(34)+1986
    
    sets=np.where(iceagen[:,1]==i+1)[0]
        
    plt.plot(murange,icex1[:,i],color='gray',label='iceage')
    plt.plot(murange,acfx[i]/max(data3),color='#8cdcda',label='$W_{ACF}$')  
    plt.plot(murange,psdx[i]/max(data2),color='#f16a70',label='$W_{PS}$')
    
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,icex1[:,i])
    icey=slope*murange+intercept
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,psdx[i]/max(data2))
    psdy=slope*murange+intercept
    slope, intercept, r_value, p_value, std_err = stats.linregress(murange,acfx[i]/max(data3))
    acfy=slope*murange+intercept
    plt.plot(murange,acfy,'--',color='b')
    plt.plot(murange,psdy,'--',color='r')
    plt.plot(murange,icey,'--',color='k')
    plt.title('Laptev Sea',fontsize=32)
    
    plt.annotate('l', xy=(-0.1,1.05), xycoords='axes fraction', fontsize=32, weight='bold',
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom') 


    ax.set_xlabel('$Year$',fontsize=16)
    
    figure = plt.gcf() # get current figure
                # 
    figure.set_size_inches(36, 4)
        #plt.savefig("/home/meng/fig/community_"+str(yy)+".png")     
   
    #plt.show()
    plt.savefig("/home/meng/bak_bupt/newproj/fig/indexesA.pdf",format='pdf',dpi=300,bbox_inches='tight')


def plot_trend_ice3():
    
    path='/home/meng/bak_bupt/newproj/data/'
    regrid=np.loadtxt(path+'regridcos2.5d_global.dat')
    #regrid=np.loadtxt(path+'/data/seaice/regridcos2.5d_global.dat')
    regrid2=np.loadtxt(path+'nonzeroicenodes.dat')
   
    data1=np.loadtxt(path+'trend_psdsum_ice_anuala.dat')
    data2=np.loadtxt(path+'trend_autocorr_ice_anual_abs.dat')

    data=np.loadtxt(path+'trend_autocorr_ice_anual_abs.dat')
    nodes=[int(i) for i in data[:,0]]

    N=166
    month=5
    data1=np.loadtxt(path+'trend_autocorr_ice_monthly_abs.dat')
    rx1=np.reshape(data1[:,1],(N,12))
    px1=np.reshape(data1[:,2],(N,12))
    data2=np.loadtxt(path+'trend_psdsum_ice_monthly.dat')
    rx2=np.reshape(data2[:,1],(N,12))
    px2=np.reshape(data2[:,2],(N,12))
    nodes1=[nodes[i] for i in range(len(nodes)) if(px1[:,month][i]<0.05)]
    nodes2=[nodes[i] for i in range(len(nodes)) if(px2[:,month][i]<0.05)]
    signodes=nodes1+nodes2
    
    
    dataa=np.loadtxt(path+'iceage_1985_week22.dat')

    datab=np.loadtxt(path+'iceage_2019_week22.dat')


 
    fig = plt.figure()
    
   # ax3 = plt.subplot2grid(shape=(21, 23), loc=(13, 0), colspan=10,rowspan=10)
    ax = fig.add_subplot(131)

    data=dataa
   # nodes=[int(i) for i in range(0,len(data),50) if (data[:,2][i]<20)]
   
  #  nodes1=[int(i) for i in range(0,len(data),50) if (data[:,2][i]==0)]
    nodes=[int(i) for i in range(0,len(data),10) if (data[:,2][i] in np.arange(1,20))]
    
   
    m = Basemap(projection='npstere',boundinglat=45,lon_0=270,resolution='l')
      
    m.drawcoastlines(linewidth = 1)
    m.drawlsmask(land_color='gray',ocean_color='midnightblue',lakes=True)
    m.drawparallels(np.arange(-80.,81.,20.))
    m.drawmeridians(np.arange(-180.,181.,20.))
    #m.drawmapboundary(fill_color='gray')
   # m.fillcontinents(color='gray',lake_color='cyan')
    lats1=np.array(data[:,0][nodes])
    lons1=np.array(data[:,1][nodes])
    x, y = m(lons1,lats1)
    
            #lats1=np.array(lats1)
            #lons1=np.array(lons1)
    color=data[:,2][nodes]
  

    cm=m.scatter(x,y,15,marker='o',c=color,cmap='Blues_r',vmin=0, vmax=6)   
 
    plt.clim(1,6)
    
   
    lats1=np.array(regrid2[:,1][signodes])
    lons1=np.array(regrid2[:,2][signodes])
    x, y = m(lons1,lats1)
    
    

    m.scatter(x,y,150,facecolors='none', edgecolors='deeppink',marker='o',linewidth=2)





   
    plt.title('$June\ 3-10,\ 1985$',fontsize=42) #annual
      
    
    plt.annotate('a', xy=(-0.1,1.05), xycoords='axes fraction', fontsize=45,weight='bold',
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom')  


    #ax4 = plt.subplot2grid(shape=(21, 23), loc=(13, 11), colspan=10,rowspan=10)
    ax = fig.add_subplot(132)
   
    data=datab
    nodes=[int(i) for i in range(0,len(data),10) if (data[:,2][i] in np.arange(1,20))]
   
    m = Basemap(projection='npstere',boundinglat=45,lon_0=270,resolution='l')
    m.drawlsmask(land_color='gray',ocean_color='midnightblue',lakes=True)

    m.drawcoastlines(linewidth = 1)
    
    m.drawparallels(np.arange(-80.,81.,20.))
    m.drawmeridians(np.arange(-180.,181.,20.))
   # m.drawmapboundary(fill_color='gray')
   # m.fillcontinents(color='gray',lake_color='cyan')
    lats1=np.array(data[:,0][nodes])
    lons1=np.array(data[:,1][nodes])
    x, y = m(lons1,lats1)
    
            #lats1=np.array(lats1)
            #lons1=np.array(lons1)
    color=data[:,2][nodes]


    cm=m.scatter(x,y,35,marker='o',c=color,cmap='Blues_r',vmin=0, vmax=6)
   

    cb=plt.colorbar(cm,fraction=0.05,pad=0.06,extend='both')
    cb.set_label(label='Sea Ice Age (year)', size=42,rotation=90)
    cb.ax.tick_params(labelsize=42) 
    #m.scatter(x,y,150,marker='o',c=color,cmap='seismic_r')       
   # cb=plt.colorbar(fraction=0.025,pad=0.06)
   # cb.set_label(label='r', size=24, weight='bold')
    #cb.ax.tick_params(labelsize=24)
    a=abs(min(color))
    b=abs(max(color))
    c=max(a,b)   
    c=0.25
    plt.clim(1,6)
 
    lats1=np.array(regrid2[:,1][signodes])
    lons1=np.array(regrid2[:,2][signodes])
    x, y = m(lons1,lats1)
    
    

    m.scatter(x,y,150,facecolors='none', edgecolors='deeppink',marker='o',linewidth=2)
   
    plt.title('$June\ 3-10,\ 2019$',fontsize=42) #annual
      
    
    plt.annotate('b', xy=(-0.1,1.05), xycoords='axes fraction', fontsize=45,weight='bold',
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom')  


    ax=plt.subplot(133)
    m = Basemap(projection='npstere',boundinglat=45,lon_0=270,resolution='l')
      
    m.drawcoastlines(linewidth = 1)
    m.drawlsmask(land_color='mistyrose',ocean_color='k',lakes=True)
    m.drawparallels(np.arange(-80.,81.,20.))
    m.drawmeridians(np.arange(-180.,181.,20.))
    path='/home/meng/bak_bupt/newproj/data/'

    data=np.loadtxt(path+'divide_arctic_12.dat')
    nodes=np.where(data[:,1]>0)[0]
    lats1=data[:,2][nodes]
    lonsx=data[:,3][nodes]
    lons1=[]
    for i in range(len(lonsx)):
        lon=lonsx[i]
        if(lon>=0):
            lon=lon
        else:
            lon=360+lon
        lons1.append(lon)
    lats1=np.array(lats1)
    lons1=np.array(lons1)
    x, y = m(lons1,lats1)
    color=data[:,1][nodes]
    
    m.scatter(x,y,350,marker='o',c=color,cmap='tab20')


    ax.annotate('1', xy=(0.15, 0.7), xycoords='axes fraction', fontsize=42 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='w',
                    ha='left', va='bottom')
    ax.annotate('2', xy=(0.15, 0.48), xycoords='axes fraction', fontsize=42 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='w',
                    ha='left', va='bottom')
    ax.annotate('3', xy=(0.5, 0.15), xycoords='axes fraction', fontsize=42 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='w',
                    ha='left', va='bottom')
    ax.annotate('4', xy=(0.7, 0.18), xycoords='axes fraction', fontsize=42 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='w',
                    ha='left', va='bottom')
    ax.annotate('5', xy=(0.65, 0.45), xycoords='axes fraction', fontsize=42 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='w',
                    ha='left', va='bottom')
    ax.annotate('6', xy=(0.55, 0.62), xycoords='axes fraction', fontsize=42 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='w',
                    ha='left', va='bottom')
    ax.annotate('7', xy=(0.48, 0.48), xycoords='axes fraction', fontsize=42 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='w',
                    ha='left', va='bottom')
    ax.annotate('8', xy=(0.44, 0.35), xycoords='axes fraction', fontsize=42 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='w',
                    ha='left', va='bottom')
    ax.annotate('9', xy=(0.36, 0.38), xycoords='axes fraction', fontsize=42 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='w',
                    ha='left', va='bottom')
    ax.annotate('10', xy=(0.3, 0.45), xycoords='axes fraction', fontsize=42 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='w',
                    ha='left', va='bottom')
    ax.annotate('11', xy=(0.31, 0.53), xycoords='axes fraction', fontsize=42 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='w',
                    ha='left', va='bottom')
    ax.annotate('12', xy=(0.39, 0.6), xycoords='axes fraction', fontsize=42 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='w',
                    ha='left', va='bottom')
    
    
    ax.annotate('1 Sea of Okhotsk', xy=(1.05, 1.0), xycoords='axes fraction', fontsize=38 ,
                    xytext=(0, -12), textcoords='offset points',color='k',
                    ha='left', va='bottom')
    ax.annotate('2 Bering Sea', xy=(1.05, 0.95), xycoords='axes fraction', fontsize=38 ,
                    xytext=(0, -12), textcoords='offset points',color='k',
                    ha='left', va='bottom')
    ax.annotate('3 Hudson Bay', xy=(1.05,0.9), xycoords='axes fraction', fontsize=38 ,
                    xytext=(0, -12), textcoords='offset points',color='k',
                    ha='left', va='bottom')
    ax.annotate('4 Baffin Bay', xy=(1.05,0.85), xycoords='axes fraction', fontsize=38 ,
                    xytext=(0, -12), textcoords='offset points',color='k',
                    ha='left', va='bottom')
    ax.annotate('5 Greenland Sea', xy=(1.05,0.8), xycoords='axes fraction', fontsize=38 ,
                    xytext=(0, -12), textcoords='offset points',color='k',
                    ha='left', va='bottom')  
    ax.annotate('6 Barents-Kara Sea', xy=(1.05,0.75), xycoords='axes fraction', fontsize=38 ,
                    xytext=(0, -12), textcoords='offset points',color='k',
                    ha='left', va='bottom')
    ax.annotate('7 Central Arctic', xy=(1.05,0.7), xycoords='axes fraction', fontsize=38 ,
                    xytext=(0, -12), textcoords='offset points',color='k',
                    ha='left', va='bottom') 
    ax.annotate('8 Canadian Arctic', xy=(1.05,0.65), xycoords='axes fraction', fontsize=38 ,
                    xytext=(0, -12), textcoords='offset points',color='k',
                    ha='left', va='bottom') 
    ax.annotate('9 Beaufort Sea', xy=(1.05,0.6), xycoords='axes fraction', fontsize=38 ,
                    xytext=(0, -12), textcoords='offset points',color='k',
                    ha='left', va='bottom')     
    ax.annotate('10 Chukchi Sea', xy=(1.05,0.55), xycoords='axes fraction', fontsize=38 ,
                    xytext=(0, -12), textcoords='offset points',color='k',
                    ha='left', va='bottom')     
    ax.annotate('11 E. Siberian Sea', xy=(1.05,0.5), xycoords='axes fraction', fontsize=38 ,
                    xytext=(0, -12), textcoords='offset points',color='k',
                    ha='left', va='bottom') 
    ax.annotate('12 Laptev Sea', xy=(1.05,0.45), xycoords='axes fraction', fontsize=38 ,
                    xytext=(0, -12), textcoords='offset points',color='k',
                    ha='left', va='bottom')  

    
    plt.annotate('c', xy=(-0.1,1.05), xycoords='axes fraction', fontsize=45,weight='bold',
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom')  



       
    plt.subplots_adjust(top = 0.99, bottom = 0.01, right = 0.99, left = 0.01, 
                hspace = 0.2, wspace = 0.00001)   
    
    figure = plt.gcf() # get current figure
                # 
    figure.set_size_inches(40, 10)
    #plt.savefig("/home/meng/paper/trends_ice2.png",bbox_inches='tight')        
    plt.savefig("/home/meng/bak_bupt/newproj/fig/trends_ice3.pdf",bbox_inches='tight',dpi=300)     
            
        
        
        
        