#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Mon Apr  3 14:03:38 2023

@author: meng
"""

#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Fri Mar 31 23:02:34 2023

@author: meng
"""



import nolds
from scipy.interpolate import griddata

from collections import Counter
import os
os.environ['PROJ_LIB'] = r'/home/meng/anaconda3/pkgs/proj-7.2.0-h8b9fe22_0/share/proj'
from matplotlib import colors 
from numpy.random import multivariate_normal 
import seaborn as sns
import pandas as pd
import matplotlib.pyplot as plt
import numpy as np
from scipy import stats
from matplotlib.ticker import MultipleLocator, FormatStrFormatter 
from scipy.stats.stats import pearsonr
from mpl_toolkits.basemap import Basemap, addcyclic, shiftgrid
from numpy import random, histogram2d, diff
import matplotlib.pyplot as plt
from scipy.interpolate import interp2d
import math
from matplotlib.ticker import (MultipleLocator, FormatStrFormatter,
                               AutoMinorLocator)
from scipy.stats import rankdata
    
from scipy.stats import gaussian_kde

import matplotlib as mpl
    
import glob
import seaborn as sns
def logistic(x,mu):
	y = mu*x*(1.0-x)
	return y 
def chaost(n1,n2,x0,mu):
    x=x0
    z=np.linspace(0.0,1.0,n2-n1)
    for i in range(0,n1):
        x=logistic(x,mu)
    for i in range(n1,n2):
        x=logistic(x,mu)
        z[i-n1]=x
    return z

def autoca(x,tau,l):
    z=[]
    for t in range(-tau,0):
        x1=x[tau:l+tau]
        x2=x[tau-t:l-t+tau]
        r=pearsonr(x1,x2)[0]
        z.append(abs(r))
    for t in range(0,tau):
        x1=x[tau-t:l+tau-t]
        x2=x[tau:l+tau]
        r=pearsonr(x1,x2)[0]
        z.append(abs(r))
    w=(1-np.mean(z))/np.std(z)
    return z
def autowa(x,tau,l):
    xx=autoca(x,tau,l)
    a=(1-np.mean(xx))/np.std(xx)
    return a
    
def pdswelch(x,fs): 
        
    from scipy import signal
    import numpy as np
    import matplotlib.pyplot as plt
    m=fs
    f, Pxx_den = signal.welch(x, fs, nperseg=m)
   # print (sum(Pxx_den))
    return f,Pxx_den/sum(Pxx_den)





def mix_test():

    
    mixwl30=[]
    for rx in [0.5,1,2]:
        N=2000
        a=0
        for i in range(12):
            a+=pow(np.sin(2*np.pi*i/12),2)/12
        
        x=a*np.sin(2*np.pi*np.arange(N)/12)
        
        b=np.sqrt(3)
        y=np.random.uniform(-b,b,N)
        wx=[]
        px=np.arange(0,1,0.01)
        m=len(px)
        
        sn=100
        fs=18
        tau=10
        l=30
        
        wx0=[]
        sampx0=[]
        psdx0=[]
        for p in px:
                ratio=int(N*p)
                
                z1=np.zeros(N-ratio)
                z2=np.ones(ratio)
                z=list(z1)+list(z2)
                wx=[]
                sampx=[]
                psdx=[]
                for st in range(sn):        
                    np.random.shuffle(z)
                    z=np.array(z)
                    y=np.array(y)
                    x=np.array(x)
                    
                    mix=(1-z)*x+z*y
                    trend=pow(np.arange(N)/N,rx)*1000
                    trendx=mix+trend[:len(mix)]
                    w=autowa(trendx[500:],tau,l)
                 
                    wx.append(w)
                  
                wx0.append(np.mean(wx))
        plt.plot(wx0)
                #sampx0.append(np.mean(sampx))
        mixwl30.append(wx0)
 
        
    for fx in [500,1000]:
        N=2000
        a=0
        for i in range(12):
            a+=pow(np.sin(2*np.pi*i/12),2)/12
        
        x=a*np.sin(2*np.pi*np.arange(N)/12)
        
        b=np.sqrt(3)
        y=np.random.uniform(-b,b,N)
        wx=[]
        px=np.arange(0,1,0.01)
        m=len(px)
        
        sn=100
        fs=18
        tau=10
        l=30
        
        wx0=[]
        sampx0=[]
        psdx0=[]
        for p in px:
                ratio=int(N*p)
                
                z1=np.zeros(N-ratio)
                z2=np.ones(ratio)
                z=list(z1)+list(z2)
                wx=[]
                sampx=[]
                psdx=[]
                for st in range(sn):        
                    np.random.shuffle(z)
                    z=np.array(z)
                    y=np.array(y)
                    x=np.array(x)
                    
                    mix=(1-z)*x+z*y
                    xr=np.arange(N)
                    trend=np.sin(2*np.pi*xr/fx)*1
                    trendx=mix+trend
                    w=autowa(trendx,tau,l)                 
                    wx.append(w)

                wx0.append(np.mean(wx))
        plt.plot(wx0)

        mixwl30.append(wx0) 
    
    mixwl100=[]
    for rx in [0.5,1,2]:
        N=2000
        a=0
        for i in range(12):
            a+=pow(np.sin(2*np.pi*i/12),2)/12
        
        x=a*np.sin(2*np.pi*np.arange(N)/12)
        
        b=np.sqrt(3)
        y=np.random.uniform(-b,b,N)
        wx=[]
        px=np.arange(0,1,0.01)
        m=len(px)
        
        sn=100
        fs=18
        tau=10
        l=100
        
        wx0=[]
        sampx0=[]
        psdx0=[]
        for p in px:
                ratio=int(N*p)
                
                z1=np.zeros(N-ratio)
                z2=np.ones(ratio)
                z=list(z1)+list(z2)
                wx=[]
                sampx=[]
                psdx=[]
                for st in range(sn):        
                    np.random.shuffle(z)
                    z=np.array(z)
                    y=np.array(y)
                    x=np.array(x)
                    
                    mix=(1-z)*x+z*y
                    trend=pow(np.arange(N)/N,rx)*1000
                    trendx=mix+trend[:len(mix)]
                    w=autowa(trendx[500:],tau,l)
                 
                    wx.append(w)
                  
                wx0.append(np.mean(wx))
        plt.plot(wx0)
                #sampx0.append(np.mean(sampx))
        mixwl100.append(wx0)
 
        
    for fx in [500,1000]:
        N=2000
        a=0
        for i in range(12):
            a+=pow(np.sin(2*np.pi*i/12),2)/12
        
        x=a*np.sin(2*np.pi*np.arange(N)/12)
        
        b=np.sqrt(3)
        y=np.random.uniform(-b,b,N)
        wx=[]
        px=np.arange(0,1,0.01)
        m=len(px)
        
        sn=100
        fs=18
        tau=10
        l=100
        
        wx0=[]
        sampx0=[]
        psdx0=[]
        for p in px:
                ratio=int(N*p)
                
                z1=np.zeros(N-ratio)
                z2=np.ones(ratio)
                z=list(z1)+list(z2)
                wx=[]
                sampx=[]
                psdx=[]
                for st in range(sn):        
                    np.random.shuffle(z)
                    z=np.array(z)
                    y=np.array(y)
                    x=np.array(x)
                    
                    mix=(1-z)*x+z*y
                    xr=np.arange(N)
                    trend=np.sin(2*np.pi*xr/fx)*1
                    trendx=mix+trend
                    w=autowa(trendx,tau,l)                 
                    wx.append(w)

                wx0.append(np.mean(wx))
        plt.plot(wx0)

        mixwl100.append(wx0) 


def logistx_test():
    murange=np.arange(3.4,4,0.01)
    m=len(murange)
    sn=100
    tau=10
    l=30
    N=1500
    fs=18
    wl30=[]
    for b in [0.5,1,2]:
    
        wx0=[]
      #  psdx0=[]
       # sampx0=[]
        for mu in murange:
    
    
            wx=[]
           # sampx=[]
            #
            for times in range(sn):
                x0=np.random.choice(1000)/1000        
                logistx=chaost(500,500+N,x0,mu)           
                trendx=1000*pow(np.arange(N)/N,b)
                newx=logistx+trendx
                w=autowa(newx[500:],tau,l)
                if(w>0):
                    wx.append(w)
                
            wx0.append(np.mean(wx))
        plt.plot(wx0)
        wl30.append(wx0)


    
    for fx in [500,1000]:
        wx0=[]
      #  psdx0=[]
       # sampx0=[]
        for mu in murange:
    
    
            wx=[]
           # sampx=[]
            #
            for times in range(sn):
                x0=np.random.choice(1000)/1000        
                logistx=chaost(500,500+N,x0,mu)           
                xr=np.arange(N)
                trendx=np.sin(2*np.pi*xr/fx)*10
                newx=logistx+trendx
                w=autowa(newx,tau,l)
                if(w>0):
                    wx.append(w)
               
            wx0.append(np.mean(wx))    
        plt.plot(wx0)
        plt.plot(wl30[0])
        wl30.append(wx0)
        
############################################################l=1000        
    murange=np.arange(3.4,4,0.01)
    m=len(murange)
    sn=100
    tau=10
    l=100
    N=1500
    fs=18
    wl100=[]
    for b in [0.5,1,2]:
    
        wx0=[]
      #  psdx0=[]
       # sampx0=[]
        for mu in murange:
    
    
            wx=[]
           # sampx=[]
            #
            for times in range(sn):
                x0=np.random.choice(1000)/1000        
                logistx=chaost(500,500+N,x0,mu)           
                trendx=1000*pow(np.arange(N)/N,b)
                newx=logistx+trendx
                w=autowa(newx[500:],tau,l)
                if(w>0):
                    wx.append(w)
                
            wx0.append(np.mean(wx))
        plt.plot(wx0)
        wl100.append(wx0)


    
    for fx in [500,1000]:
        wx0=[]
      #  psdx0=[]
       # sampx0=[]
        for mu in murange:
    
    
            wx=[]
           # sampx=[]
            #
            for times in range(sn):
                x0=np.random.choice(1000)/1000        
                logistx=chaost(500,500+N,x0,mu)           
                xr=np.arange(N)
                trendx=np.sin(2*np.pi*xr/fx)*10
                newx=logistx+trendx
                w=autowa(newx,tau,l)
                if(w>0):
                    wx.append(w)
               
            wx0.append(np.mean(wx))    
        plt.plot(wx0)
        plt.plot(wl1000[0])
        wl100.append(wx0)

def plots():
    outfile=open('/home/meng/bak_bupt/newproj/data/WACF_mix30.dat','w')
    for i in range(len(px)):
        outfile.write('%.2f %.6f %.6f %.6f %.6f %.6f \n'%(px[i],mixwl30[0][i],mixwl30[1][i],mixwl30[2][i],mixwl30[3][i],mixwl30[4][i]))
        outfile.flush()
    outfile.close()

    outfile=open('/home/meng/bak_bupt/newproj/data/WACF_mix100.dat','w')
    for i in range(len(px)):
        outfile.write('%.2f %.6f %.6f %.6f %.6f %.6f \n'%(px[i],mixwl1000[0][i],mixwl1000[1][i],mixwl1000[2][i],mixwl1000[3][i],mixwl1000[4][i]))
        outfile.flush()
    outfile.close()


    outfile=open('/home/meng/bak_bupt/newproj/data/WACF_logist30.dat','w')
    for i in range(len(murange)):
        outfile.write('%.2f %.6f %.6f %.6f %.6f %.6f \n'%(murange[i],wl30[0][i],wl30[1][i],wl30[2][i],wl30[3][i],wl30[4][i]))
        outfile.flush()
    outfile.close()
    
    outfile=open('/home/meng/bak_bupt/newproj/data/WACF_logist100.dat','w')
    for i in range(len(murange)):
        outfile.write('%.2f %.6f %.6f %.6f %.6f %.6f \n'%(murange[i],wl1000[0][i],wl1000[1][i],wl1000[2][i],wl1000[3][i],wl1000[4][i]))
        outfile.flush()
    outfile.close()   
    
    px=np.arange(0,1,0.01)
    murange=np.arange(3.4,4,0.01)
    
    data=np.loadtxt('/home/meng/bak_bupt/newproj/data/WACF_mix30.dat')
    mixwl30=[data[:,1],data[:,2],data[:,3],data[:,4],data[:,5]]
    
    data=np.loadtxt('/home/meng/bak_bupt/newproj/data/WACF_mix100.dat')
    mixwl100=[data[:,1],data[:,2],data[:,3],data[:,4],data[:,5]]   
    
    data=np.loadtxt('/home/meng/bak_bupt/newproj/data/WACF_logist30.dat')
    wl30=[data[:,1],data[:,2],data[:,3],data[:,4],data[:,5]]   
    
    data=np.loadtxt('/home/meng/bak_bupt/newproj/data/WACF_logist100.dat')
    wl100=[data[:,1],data[:,2],data[:,3],data[:,4],data[:,5]]

    ax=plt.subplot(221)
    xmajorLocator = MultipleLocator(0.2) #将x主刻度标签设置为20的倍数
    xmajorFormatter = FormatStrFormatter('%.1f') #设置x轴标签文本的格式
    ymajorLocator = MultipleLocator(0.5) #将y轴主刻度标签设置为0.5的倍数
    ymajorFormatter = FormatStrFormatter('%.1f') #设置y轴标签文本的格式
    #设置主刻度标签的位置,标签文本的格式
    ax.xaxis.set_major_locator(xmajorLocator)
    ax.xaxis.set_major_formatter(xmajorFormatter)
    ax.yaxis.set_major_locator(ymajorLocator)
    ax.yaxis.set_major_formatter(ymajorFormatter)
    
    #修改次刻度
    xminorLocator = MultipleLocator(0.1) #将x轴次刻度标签设置为5的倍数
    yminorLocator = MultipleLocator(0.25) #将此y轴次刻度标签设置为0.1的倍数
    #设置次刻度标签的位置,没有标签文本格式
    ax.xaxis.set_minor_locator(xminorLocator)
    ax.yaxis.set_minor_locator(yminorLocator) 
    ax.tick_params(which='both', width=4)
    ax.tick_params(which='major', length=9)  
    ax.tick_params(which='minor',length=5)
    #plt.plot(taux,dpn,'k--',label='globe')
   
    plt.xticks(fontsize=24)
    plt.yticks(fontsize=24)
    plt.xlabel('$p$',fontsize=28)
    plt.ylabel('$W_{ACF}$',fontsize=28)
    

    
   
    # plt.scatter(px,mixwl30[0], s=100, facecolors='none', edgecolors='#1e341f',label='b=0.5')
    # plt.scatter(px,mixwl30[1], s=100, facecolors='none', edgecolors='#850d29',label='b=0.5')
    # plt.scatter(px,mixwl30[2], s=100, facecolors='none', edgecolors='#bb2649',label='b=0.5')
    # plt.scatter(px,mixwl30[3], s=100, label='f=10',marker='+',c='#17293a')
    # plt.scatter(px,mixwl30[4], s=100, label='f=100',marker='+',c='#304b5f')

    plt.scatter(px,mixwl30[2], s=100, facecolors='none', edgecolors='#ef476f',label='b=2')
    plt.scatter(px,mixwl30[1], s=100, facecolors='none', edgecolors='#ffd166',label='b=1')
    plt.scatter(px,mixwl30[0], s=100, facecolors='none', edgecolors='#06d6a0',label='b=0.5')
    plt.scatter(px,mixwl30[3], s=100, label='f=1/500',marker='+',c='#118ab2')
    plt.scatter(px,mixwl30[4], s=100, label='f=1/1000',marker='+',c='#073b4c')
    plt.legend(fontsize=24,loc=1,bbox_to_anchor=(0.95,0.5))

   # plt.legend(fontsize=28)
    plt.title('$MIX(p),\ N=30$',fontsize=28)
    plt.annotate('a', xy=(-0.1,1.05), xycoords='axes fraction', fontsize=28,weight='bold',
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom')     
    
    ax=plt.subplot(222)
    xmajorLocator = MultipleLocator(0.2) #将x主刻度标签设置为20的倍数
    xmajorFormatter = FormatStrFormatter('%.1f') #设置x轴标签文本的格式
    ymajorLocator = MultipleLocator(0.5) #将y轴主刻度标签设置为0.5的倍数
    ymajorFormatter = FormatStrFormatter('%.1f') #设置y轴标签文本的格式
    #设置主刻度标签的位置,标签文本的格式
    ax.xaxis.set_major_locator(xmajorLocator)
    ax.xaxis.set_major_formatter(xmajorFormatter)
    ax.yaxis.set_major_locator(ymajorLocator)
    ax.yaxis.set_major_formatter(ymajorFormatter)
    
    #修改次刻度
    xminorLocator = MultipleLocator(0.1) #将x轴次刻度标签设置为5的倍数
    yminorLocator = MultipleLocator(0.25) #将此y轴次刻度标签设置为0.1的倍数
    #设置次刻度标签的位置,没有标签文本格式
    ax.xaxis.set_minor_locator(xminorLocator)
    ax.yaxis.set_minor_locator(yminorLocator) 
    ax.tick_params(which='both', width=4)
    ax.tick_params(which='major', length=9)  
    ax.tick_params(which='minor',length=5)
    #plt.plot(taux,dpn,'k--',label='globe')
   
    plt.xticks(fontsize=24)
    plt.yticks(fontsize=24)
    plt.xlabel('$p$',fontsize=24)
    plt.ylabel('$W_{ACF}$',fontsize=24)
    
   
    plt.scatter(px,mixwl100[2], s=100, facecolors='none', edgecolors='#ef476f',label='b=2')
    plt.scatter(px,mixwl100[1], s=100, facecolors='none', edgecolors='#ffd166',label='b=1')
    plt.scatter(px,mixwl100[0], s=100, facecolors='none', edgecolors='#06d6a0',label='b=0.5')
    plt.scatter(px,mixwl100[3], s=100, label='f=1/500',marker='+',c='#118ab2')
    plt.scatter(px,mixwl100[4], s=100, label='f=1/1000',marker='+',c='#073b4c')
   

   # plt.legend(fontsize=24)
    plt.title('$MIX(p),\ N=100$',fontsize=28)
    plt.annotate('b', xy=(-0.1,1.05), xycoords='axes fraction', fontsize=31,weight='bold',
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom')     
        
    ax=plt.subplot(223)
    xmajorLocator = MultipleLocator(0.2) #将x主刻度标签设置为20的倍数
    xmajorFormatter = FormatStrFormatter('%.1f') #设置x轴标签文本的格式
    ymajorLocator = MultipleLocator(0.5) #将y轴主刻度标签设置为0.5的倍数
    ymajorFormatter = FormatStrFormatter('%.1f') #设置y轴标签文本的格式
    #设置主刻度标签的位置,标签文本的格式
    ax.xaxis.set_major_locator(xmajorLocator)
    ax.xaxis.set_major_formatter(xmajorFormatter)
    ax.yaxis.set_major_locator(ymajorLocator)
    ax.yaxis.set_major_formatter(ymajorFormatter)
    
    #修改次刻度
    xminorLocator = MultipleLocator(0.1) #将x轴次刻度标签设置为5的倍数
    yminorLocator = MultipleLocator(0.25) #将此y轴次刻度标签设置为0.1的倍数
    #设置次刻度标签的位置,没有标签文本格式
    ax.xaxis.set_minor_locator(xminorLocator)
    ax.yaxis.set_minor_locator(yminorLocator) 
    ax.tick_params(which='both', width=4)
    ax.tick_params(which='major', length=9)  
    ax.tick_params(which='minor',length=5)
    #plt.plot(taux,dpn,'k--',label='globe')
   
    plt.xticks(fontsize=24)
    plt.yticks(fontsize=24)
    plt.xlabel('$\mu$',fontsize=28)
    plt.ylabel('$W_{ACF}$',fontsize=28)
    
   
    plt.scatter(murange,wl30[2], s=100, facecolors='none', edgecolors='#ef476f',label='b=2')
    plt.scatter(murange,wl30[1], s=100, facecolors='none', edgecolors='#ffd166',label='b=1')
    plt.scatter(murange,wl30[0], s=100, facecolors='none', edgecolors='#06d6a0',label='b=0.5')
    plt.scatter(murange,wl30[3], s=100, label='f=1/500',marker='+',c='#118ab2')
    plt.scatter(murange,wl30[4], s=100, label='f=1/1000',marker='+',c='#073b4c')

   # plt.legend(fontsize=28)
    plt.title('$Logistic(\mu),\ N=30$',fontsize=28)
    plt.annotate('c', xy=(-0.1,1.05), xycoords='axes fraction', fontsize=28,weight='bold',
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom')     
    
    ax=plt.subplot(224)
    xmajorLocator = MultipleLocator(0.2) #将x主刻度标签设置为20的倍数
    xmajorFormatter = FormatStrFormatter('%.1f') #设置x轴标签文本的格式
    ymajorLocator = MultipleLocator(0.5) #将y轴主刻度标签设置为0.5的倍数
    ymajorFormatter = FormatStrFormatter('%.1f') #设置y轴标签文本的格式
    #设置主刻度标签的位置,标签文本的格式
    ax.xaxis.set_major_locator(xmajorLocator)
    ax.xaxis.set_major_formatter(xmajorFormatter)
    ax.yaxis.set_major_locator(ymajorLocator)
    ax.yaxis.set_major_formatter(ymajorFormatter)
    
    #修改次刻度
    xminorLocator = MultipleLocator(0.1) #将x轴次刻度标签设置为5的倍数
    yminorLocator = MultipleLocator(0.25) #将此y轴次刻度标签设置为0.1的倍数
    #设置次刻度标签的位置,没有标签文本格式
    ax.xaxis.set_minor_locator(xminorLocator)
    ax.yaxis.set_minor_locator(yminorLocator) 
    ax.tick_params(which='both', width=4)
    ax.tick_params(which='major', length=9)  
    ax.tick_params(which='minor',length=5)
    #plt.plot(taux,dpn,'k--',label='globe')
   

    plt.xticks(fontsize=24)
    plt.yticks(fontsize=24)
    plt.xlabel('$\mu$',fontsize=28)
    plt.ylabel('$W_{ACF}$',fontsize=28)
    
   
    plt.scatter(murange,wl100[2], s=100, facecolors='none', edgecolors='#ef476f',label='b=2')
    plt.scatter(murange,wl100[1], s=100, facecolors='none', edgecolors='#ffd166',label='b=1')
    plt.scatter(murange,wl100[0], s=100, facecolors='none', edgecolors='#06d6a0',label='b=0.5')
    plt.scatter(murange,wl100[3], s=100, label='f=1/500',marker='+',c='#118ab2')
    plt.scatter(murange,wl100[4], s=100, label='f=1/1000',marker='+',c='#073b4c')

    plt.title('$Logistic(\mu),\ N=100$',fontsize=28)
    plt.annotate('d', xy=(-0.1,1.05), xycoords='axes fraction', fontsize=28,weight='bold',
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom')    
        

    plt.subplots_adjust(top = 0.9, bottom = 0.15, right = 0.95, left = 0.1, 
                hspace = 0.3, wspace = 0.2)   
    
    figure = plt.gcf() # get current figure
                # 
    figure.set_size_inches(24, 18)
        #plt.savefig("/home/meng/fig/community_"+str(yy)+".png")     
    plt.savefig("/home/meng/bak_bupt/newproj/fig/WACF.pdf",dpi=300,bbox_inches='tight') 

#ef476f // #ffd166 // #06d6a0 // #118ab2 // #073b4c
 
############################################################################################################################

def plot_ice_autowa():
    path='/home/meng/bak_bupt/newproj/data'
    data=np.loadtxt(path+'/autow_northpole.dat')
    ax=plt.subplot(411)
    xmajorLocator = MultipleLocator(5) #将x主刻度标签设置为20的倍数
    xmajorFormatter = FormatStrFormatter('%d') #设置x轴标签文本的格式
    ymajorLocator = MultipleLocator(0.5) #将y轴主刻度标签设置为0.5的倍数
    ymajorFormatter = FormatStrFormatter('%.1f') #设置y轴标签文本的格式
    #设置主刻度标签的位置,标签文本的格式
    ax.xaxis.set_major_locator(xmajorLocator)
    ax.xaxis.set_major_formatter(xmajorFormatter)
    ax.yaxis.set_major_locator(ymajorLocator)
    ax.yaxis.set_major_formatter(ymajorFormatter)
    
    #修改次刻度
    xminorLocator = MultipleLocator(1) #将x轴次刻度标签设置为5的倍数
    yminorLocator = MultipleLocator(0.25) #将此y轴次刻度标签设置为0.1的倍数
    #设置次刻度标签的位置,没有标签文本格式
    ax.xaxis.set_minor_locator(xminorLocator)
    ax.yaxis.set_minor_locator(yminorLocator) 
    ax.tick_params(which='both', width=4)
    ax.tick_params(which='major', length=9)  
    ax.tick_params(which='minor',length=5)
    #plt.plot(taux,dpn,'k--',label='globe')
   

    plt.xticks(fontsize=24)
    plt.yticks(fontsize=24)
   # plt.xlabel('$Year$',fontsize=28)
    #plt.ylabel('$W_{ACF}$',fontsize=28)
    
    murange=np.arange(120)/12+1980
    wl1000=data
   # plt.scatter(murange,wl1000[:,2], s=100, facecolors='none', edgecolors='#ef476f',label='b=2')
    plt.plot(murange,wl1000[:,2][:120],color='k',label='original')
    plt.plot(murange,wl1000[:,4][:120],color='royalblue',label='linear')
    plt.plot(murange,wl1000[:,6][:120],color='tomato',label='oscillatory')


    plt.legend(fontsize=28,loc=1,bbox_to_anchor=(1.2,1.2))
    #plt.title('$Logistic(\mu),\ N=1000$',fontsize=28)
    plt.annotate('$W_{ACF}$', xy=(-0.1,-1.35), xycoords='axes fraction', fontsize=28,weight='bold',
                          xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                          ha='left', va='bottom')    

        
    ax=plt.subplot(412)
    xmajorLocator = MultipleLocator(5) #将x主刻度标签设置为20的倍数
    xmajorFormatter = FormatStrFormatter('%d') #设置x轴标签文本的格式
    ymajorLocator = MultipleLocator(0.5) #将y轴主刻度标签设置为0.5的倍数
    ymajorFormatter = FormatStrFormatter('%.1f') #设置y轴标签文本的格式
    #设置主刻度标签的位置,标签文本的格式
    ax.xaxis.set_major_locator(xmajorLocator)
    ax.xaxis.set_major_formatter(xmajorFormatter)
    ax.yaxis.set_major_locator(ymajorLocator)
    ax.yaxis.set_major_formatter(ymajorFormatter)
    
    #修改次刻度
    xminorLocator = MultipleLocator(1) #将x轴次刻度标签设置为5的倍数
    yminorLocator = MultipleLocator(0.25) #将此y轴次刻度标签设置为0.1的倍数
    #设置次刻度标签的位置,没有标签文本格式
    ax.xaxis.set_minor_locator(xminorLocator)
    ax.yaxis.set_minor_locator(yminorLocator) 
    ax.tick_params(which='both', width=4)
    ax.tick_params(which='major', length=9)  
    ax.tick_params(which='minor',length=5)
    #plt.plot(taux,dpn,'k--',label='globe')
   

    plt.xticks(fontsize=24)
    plt.yticks(fontsize=24)
    # plt.xlabel('$Year$',fontsize=28)
    # plt.ylabel('$W_{ACF}$',fontsize=28)
    
    murange=np.arange(120)/12+1990
    wl1000=data
   # plt.scatter(murange,wl1000[:,2], s=100, facecolors='none', edgecolors='#ef476f',label='b=2')
    plt.plot(murange,wl1000[:,2][120:240],color='k',label='original')
    plt.plot(murange,wl1000[:,4][120:240],color='royalblue',label='linear trend')
    plt.plot(murange,wl1000[:,6][120:240],color='tomato',label='oscillatory trend')
    
    
    ax=plt.subplot(413)
    xmajorLocator = MultipleLocator(5) #将x主刻度标签设置为20的倍数
    xmajorFormatter = FormatStrFormatter('%d') #设置x轴标签文本的格式
    ymajorLocator = MultipleLocator(0.5) #将y轴主刻度标签设置为0.5的倍数
    ymajorFormatter = FormatStrFormatter('%.1f') #设置y轴标签文本的格式
    #设置主刻度标签的位置,标签文本的格式
    ax.xaxis.set_major_locator(xmajorLocator)
    ax.xaxis.set_major_formatter(xmajorFormatter)
    ax.yaxis.set_major_locator(ymajorLocator)
    ax.yaxis.set_major_formatter(ymajorFormatter)
    
    #修改次刻度
    xminorLocator = MultipleLocator(1) #将x轴次刻度标签设置为5的倍数
    yminorLocator = MultipleLocator(0.25) #将此y轴次刻度标签设置为0.1的倍数
    #设置次刻度标签的位置,没有标签文本格式
    ax.xaxis.set_minor_locator(xminorLocator)
    ax.yaxis.set_minor_locator(yminorLocator) 
    ax.tick_params(which='both', width=4)
    ax.tick_params(which='major', length=9)  
    ax.tick_params(which='minor',length=5)
    #plt.plot(taux,dpn,'k--',label='globe')
   

    plt.xticks(fontsize=24)
    plt.yticks(fontsize=24)
    # plt.xlabel('$Year$',fontsize=28)
    # plt.ylabel('$W_{ACF}$',fontsize=28)
    
    murange=np.arange(120)/12+2000
    wl1000=data
   # plt.scatter(murange,wl1000[:,2], s=100, facecolors='none', edgecolors='#ef476f',label='b=2')
    plt.plot(murange,wl1000[:,2][240:360],color='k',label='original')
    plt.plot(murange,wl1000[:,4][240:360],color='royalblue',label='linear trend')
    plt.plot(murange,wl1000[:,6][240:360],color='tomato',label='oscillatory trend')    
    

    ax=plt.subplot(414)
    xmajorLocator = MultipleLocator(5) #将x主刻度标签设置为20的倍数
    xmajorFormatter = FormatStrFormatter('%d') #设置x轴标签文本的格式
    ymajorLocator = MultipleLocator(0.5) #将y轴主刻度标签设置为0.5的倍数
    ymajorFormatter = FormatStrFormatter('%.1f') #设置y轴标签文本的格式
    #设置主刻度标签的位置,标签文本的格式
    ax.xaxis.set_major_locator(xmajorLocator)
    ax.xaxis.set_major_formatter(xmajorFormatter)
    ax.yaxis.set_major_locator(ymajorLocator)
    ax.yaxis.set_major_formatter(ymajorFormatter)
    
    #修改次刻度
    xminorLocator = MultipleLocator(1) #将x轴次刻度标签设置为5的倍数
    yminorLocator = MultipleLocator(0.25) #将此y轴次刻度标签设置为0.1的倍数
    #设置次刻度标签的位置,没有标签文本格式
    ax.xaxis.set_minor_locator(xminorLocator)
    ax.yaxis.set_minor_locator(yminorLocator) 
    ax.tick_params(which='both', width=4)
    ax.tick_params(which='major', length=9)  
    ax.tick_params(which='minor',length=5)
    #plt.plot(taux,dpn,'k--',label='globe')
   

    plt.xticks(fontsize=24)
    plt.yticks(fontsize=24)
   # plt.xlabel('$Year$',fontsize=28)
    #plt.ylabel('$W_{ACF}$',fontsize=28)
    
    murange=np.arange(119)/12+2010
    wl1000=data
   # plt.scatter(murange,wl1000[:,2], s=100, facecolors='none', edgecolors='#ef476f',label='b=2')
    plt.plot(murange,wl1000[:,2][360:],color='k',label='original')
    plt.plot(murange,wl1000[:,4][360:],color='royalblue',label='linear trend')
    plt.plot(murange,wl1000[:,6][360:],color='tomato',label='oscillatory trend')    
    
    plt.annotate('$Year$', xy=(0.5,-0.2), xycoords='axes fraction', fontsize=28,weight='bold',
                          xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                          ha='left', va='bottom')  
    # plt.subplots_adjust(top = 0.95, bottom = 0.2, right = 0.95, left = 0.1, 
    #             hspace = 0.2, wspace = 0.3)   
    
    figure = plt.gcf() # get current figure
                # 
    figure.set_size_inches(24, 28)
        #plt.savefig("/home/meng/fig/community_"+str(yy)+".png")     
    plt.savefig("/home/meng/bak_bupt/newproj/fig/WACF_ice_northpole.pdf",dpi=300,bbox_inches='tight') 

def mix_test():
    N=2000
    a=0
    for i in range(12):
        a+=pow(np.sin(2*np.pi*i/12),2)/12
    
    x=a*np.sin(2*np.pi*np.arange(N)/12)
    
    b=np.sqrt(3)
    y=np.random.uniform(-b,b,N)
    wx=[]
    px=np.arange(0,1,0.01)
    m=len(px)
    
    sn=10
    fs=18
    tau=10
    l=30
    
    wx0=[]
    sampx0=[]
    psdx0=[]
    for p in px:
            ratio=int(N*p)
            
            z1=np.zeros(N-ratio)
            z2=np.ones(ratio)
            z=list(z1)+list(z2)
            wx=[]
            sampx=[]
            psdx=[]
            for st in range(sn):        
                np.random.shuffle(z)
                z=np.array(z)
                y=np.array(y)
                x=np.array(x)
                
                mix=(1-z)*x+z*y
                
                xr=np.arange(N)/N
                trend=np.sin(2*np.pi*xr*10)*10
                trendx=mix+trend
                w=autowa(trendx,tau,l)
                s=nolds.sampen(trendx[:l])    
                p1,p2=pdswelch(trendx[:l],fs)
                psd=sum(p1*p2)
                wx.append(w)
                sampx.append(s)
                psdx.append(psd)
            wx0.append(np.mean(wx))
            sampx0.append(np.mean(sampx))
            psdx0.append(np.mean(psdx))



def logistx_test():
    murange=np.arange(3.4,4,0.01)
    m=len(murange)
    sn=100
    tau=10
    l=30
    N=1500
    fs=18
    wx0=[]
    psdx0=[]
    sampx0=[]
    for mu in murange:


        wx=[]
        sampx=[]
        psdx=[]
        
        for times in range(sn):
            x0=np.random.choice(1000)/1000        
            logistx=chaost(500,500+N,x0,mu) 
            xr=np.arange(N)/N
            trendx=np.sin(2*np.pi*xr*10)*1
            newx=logistx+trendx
            w=autowa(newx,tau,l)
            wx.append(w)
            s=nolds.sampen(newx[:l])
            sampx.append(s)
            p1,p2=pdswelch(newx[:l],fs)
            psd=sum(p1*p2)
            psdx.append(psd)
            # la=nolds.lyap_r(newx[:l])
            # lyapx.append(la)
        wx0.append(np.mean(wx))
        sampx0.append(np.mean(sampx))
        psdx0.append(np.mean(psdx))











###########################################################################################



xaxis=np.arange(3,4,0.1)
xaxis=[3.5,3.7,3.8]
mux=[]
for i in xaxis:
    mu=i
    n1=500
    n2=3000
    x0=0.1
    logistx=chaost(n1,n2,x0,mu)
    wx=[]
    dfax=[]
    sampx=[]
    axx=np.arange(10,1000,10)
    for a in axx:
        tau=5
        l=a
        w=autowa(logistx,tau,l)
        wx.append(w)
        #dfax.append(nolds.dfa(newx[:l]))
        #sampx.append(nolds.sampen(newx[:l]))
       # mux.append(mu)
    plt.plot(axx,wx,'o--')
    
    
    #plt.plot(np.log(axx[:]),np.log(wx[:]))












n1=0
n2=50
x=0.05
mu=3.1
logistx=chaost(n1,n2,x,mu)
#plt.plot(logistx,'o--')
y=np.fft.fft(logistx)
plt.plot(y)




dfax=[]
lyapx=[]
sampx=[]
wx=[]



tau=10
l=30
xaxis=np.arange(3,4,0.1)
xaxis=[3.5,3.7,3.8]
mux=[]
for i in xaxis:
    mu=i
    n1=500
    n2=2000
    x0=0.1
    logistx=chaost(n1,n2,x0,mu)
    wx=[]
    dfax=[]
    sampx=[]
    axx=np.arange(0,50,0.1)
    for a in axx:
        b=1
        trendx=linearx(a,b,n2-n1)
        newx=logistx+trendx
        w=autowa(newx,tau,l)
        wx.append(w)
        #dfax.append(nolds.dfa(newx[:l]))
        #sampx.append(nolds.sampen(newx[:l]))
       # mux.append(mu)
   # plt.plot(axx,wx)
    plt.plot(np.log(axx[:]),np.log(wx[:]))
    
wx=[]    
newx0=[]
for i in range(n2-n1):
    newx0.append(np.random.choice(n2-n1)/(n2-n1))
for a in axx:
    b=1
    trendx=linearx(a,b,n2-n1)
    newx=newx0+trendx
    w=autowa(newx,tau,l)
    wx.append(w)
#plt.plot(axx,wx)
plt.plot(np.log(axx),np.log(wx))





tau=10
l=1000
xaxis=np.arange(3,4,0.1)
xaxis=[3.5,3.7,3.8]
mux=[]
for i in xaxis:
    mu=i
    n1=500
    n2=2000
    x0=0.1
    logistx=chaost(n1,n2,x0,mu)
    wx=[]
    dfax=[]
    sampx=[]
    axx=np.arange(0,1000,1)
    for a in axx:
        b=5
        trendx=sinx(a,b,n2-n1)
        newx=logistx+trendx
        w=autowa(newx,tau,l)
        wx.append(w)
       # dfax.append(nolds.dfa(newx[:l],order=2))
        sampx.append(nolds.sampen(newx[:l]))
       # mux.append(mu)
   # plt.plot(axx,wx)
    plt.plot(np.log(axx[:]),np.log(sampx[:]))
    
wx=[]   
sampx=[] 
newx0=[]
for i in range(n2-n1):
    newx0.append(np.random.choice(n2-n1)/(n2-n1))
for a in axx:
    b=5
    trendx=sinx(a,b,n2-n1)
    newx=newx0+trendx
    w=autowa(newx,tau,l)
    wx.append(w)
    sampx.append(nolds.sampen(newx[:l]))

#plt.plot(axx,wx)
plt.plot(np.log(axx),np.log(wx))









wx=np.array(wx)
sampx=np.array(sampx)
plt.plot(mux,wx/2.5,'o--')
plt.plot(xaxis,sampx,'o--')

mu=3.65

logistx=chaost(n1,n2,x0,mu)

x1=logistx+np.arange(1500)*0

a=autowa(x1,tau*10,l*10)

print (a)



N=2000
a=0
for i in range(12):
    a+=pow(np.sin(2*np.pi*i/12),2)/12

x=a*np.sin(2*np.pi*np.arange(N)/12)

b=np.sqrt(3)
y=np.random.uniform(-b,b,N)
wx=[]
px=np.arange(0,1,0.01)
for l in range(10,1000,10):
    tau=10
    p=0.1
    ratio=int(N*p)
    
    z1=np.zeros(N-ratio)
    z2=np.ones(ratio)
    z=list(z1)+list(z2)
    np.random.shuffle(z)
    z=np.array(z)
    y=np.array(y)
    x=np.array(x)
    
    mix=(1-z)*x+z*y
    trend=np.arange(N)*10
    trendx=mix+trend
    w=autowa(trendx,tau,l)
    s=nolds.sampen(trendx[:l])
    print (p,w)
    wx.append(w)
plt.plot(wx[:])

wx=[]
px=np.arange(0,1,0.01)
for l in range(10,1000,10):
    tau=10
    p=0.9
    ratio=int(N*p)
    
    z1=np.zeros(N-ratio)
    z2=np.ones(ratio)
    z=list(z1)+list(z2)
    np.random.shuffle(z)
    z=np.array(z)
    y=np.array(y)
    x=np.array(x)
    
    mix=(1-z)*x+z*y
    trend=np.arange(N)*10
    trendx=mix+trend
    w=autowa(trendx,tau,l)
    s=nolds.sampen(trendx[:l])
    print (p,w)
    wx.append(w)
plt.plot(wx[:])



                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  