#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Wed Oct 26 09:48:23 2022

@author: meng
"""
from scipy import signal
import numpy as np
from scipy.stats.stats import pearsonr
#from mpl_toolkits.basemap import Basemap, addcyclic, shiftgrid
from scipy import stats
import math
def circledis(lat1,lat2,lon1,lon2):
    r=6371#km
    lat1=lat1/180*np.pi
    lat2=lat2/180*np.pi
    lon1=lon1/180*np.pi
    lon2=lon2/180*np.pi
    a=np.arccos(np.sin(lat1)*np.sin(lat2)+np.cos(lat1)*np.cos(lat2)*np.cos(np.abs(lon1-lon2)))
    d=a*r
    return d
def corr():
  #  path='/home/meng/bak_bupt/newproj/data/'
    path='/public3/home/sc52351/mengjun/arctic/data/'
    datai=np.loadtxt(path+'psd_sum_ICE.dat')  
    datat=np.loadtxt(path+'psd_sum_t850.dat')
    regridi=np.loadtxt(path+'nonzeroicenodes.dat')

    ix=np.reshape(datai,(377,480))
    tx=np.reshape(datat,(8040,480))
  #  regridii=np.loadtxt(path+'psdnumnan_arctic.dat')
    #outfile0=open(path+'psdnumnan_arctic.dat','w')
    nnn=0
    nodes=np.loadtxt(path+'globe_672.dat')
    nx=[int(i) for i in nodes[:,0]]
    regrid=nodes
    for stime in range(1):
      yr=np.arange(39)
      sy=np.random.shuffle(yr)
      for month in range(12):
        outfile=open(path+"psd_icet_corr_mon"+str(month)+"_lag12_670.dat",'w')
        timex0=[month+12*year for year in range(39)]
        for i in range(377):
          
          if(math.isnan(sum(ix[i])) is False):
           # print (i,regridi[:,0][i])
            # outfile0.write('%d %.1f %.1f %d \n'%(regridi[:,0][i],regridi[:,1][i],regridi[:,2][i],i))
            lat1=regridi[:,1][i]
            lon1=regridi[:,2][i]
            for j in range(2,len(nx)):            
                cx=[]
                taux=[]
                nnn+=1
                lat2=nodes[:,1][j]
                lon2=nodes[:,2][j]
                dd=circledis(lat1, lat2, lon1, lon2)
                jj=(j-2)*12
                cp=0
                cn=0
                tp=0
                tn=0
                r0=0
                p0=0
                for tau in range(-12,1):
                    timex1=[month-tau+12*year for year in range(39)]
                    x1=ix[i][timex0]
                    x2=tx[jj][timex1]
                    x1=signal.detrend(x1)
                    x2=signal.detrend(x2)
                    r,p=pearsonr(x1,x2)
                    if(p<0.05):
                        cx.append(r)
                        taux.append(tau)
                for tau in range(1,13):
                    timex1=[month+tau+12*year for year in range(39)]
                    x1=ix[i][timex1]
                    x2=tx[jj][timex0]
                    x1=signal.detrend(x1)
                    x2=signal.detrend(x2)
                    r,p=pearsonr(x1,x2)
                    if(p<0.05):
                        cx.append(r)
                        taux.append(tau)
                if(len(cx)>0):
               
                    p=list(cx).index(max(cx))
                    n=list(cx).index(min(cx))
                    cp=max(cx)
                    cn=min(cx)
                    r0,p0=pearsonr(ix[i][timex0],tx[jj][timex0])
                    tp=taux[p]
                    tn=taux[n]
                
              
    
                outfile.write('%d %d %.6f %.6f %.6f %.6f %d %d %d \n'%(i,j,cp,cn,r0,p0,tp,tn,dd))
                outfile.flush()
    
        outfile.close()
        
corr()