#!/usr/bin/env python2
# -*- coding: utf-8 -*-
"""
Created on Mon Jul 22 14:18:11 2019

@author: jingfang
"""

import os
os.environ['PROJ_LIB'] = r'/home/jingfang/anaconda2/share/proj'

import matplotlib
#matplotlib.use('Agg')  # Or any other X11 back-end
from mpl_toolkits.basemap import Basemap, addcyclic, shiftgrid
#from mpl_toolkits.basemap import Basemap
import numpy as np
import matplotlib.pyplot as plt
from matplotlib.patches import Polygon
import math
from numpy import random

import pandas as pd
import seaborn as sns
import matplotlib.pyplot as plt
from scipy import stats

from scipy.interpolate import interp2d
from matplotlib.colors import LogNorm    
from scipy.stats.stats import pearsonr

from netCDF4 import Dataset

from scipy.stats import rankdata

from scipy.stats import gaussian_kde

import glob

import seaborn as sns

def divide_arctic():
    path='/home/meng/bak_bupt/newproj/data/'
    dataa=np.loadtxt(path+'iceage_1985_week22.dat')
    regrid=np.loadtxt(path+'nonzeroicenodes.dat')
    
    lats0=np.array(regrid[:,1])
    lons0=np.array(regrid[:,2])
    
    lats1=np.array(dataa[:,0])
    lons1=np.array(dataa[:,1])

    # outfile=open(path+'divide_arctic.dat','w')
    # lats=lats0
    # lons=lons0
    outfile=open(path+'divide_arctic_iceage.dat','w')

    lats=lats1
    lons=lons1
    age=dataa[:,2]
    nodes=np.where(age<20)[0]
    lats=lats1[nodes]
    lons=lons1[nodes]
    z=np.zeros(len(lats))
    z0=np.zeros(len(lats))
    
    
    for i in range(len(nodes)):
        k=int(nodes[i])
        z0[i]=k
        lat=lats[i]
        lon=lons[i]
        if(lon>=0):
            lon=lon
        else:
            lon=360+lon
        if(lat<=60 and 120<lon<165):
            z[i]=1

        if(lat<=65 and 165<=lon<=200):
            z[i]=2

        if(50<lat<=65 and 260<=lon<=292.5):
            z[i]=3

        if(lat<=65 and 292.5<=lon<=315) or (65<lat<=80 and 280<=lon<=310):# or (lat<=50 and lon>=305):
            z[i]=4

        if(60<=lat<=80 and 315<lon<=360) or (70<=lat<=80 and lon<=25):
            z[i]=5
        if(60<lat<=80 and 25<lon<=100):
            z[i]=6
        if(lat>80):
            z[i]=7
        if(65<lat<=80 and 235<=lon<=280):
            z[i]=8
        if(65<=lat<=80 and 180<=lon<=235):
            z[i]=10
        if(65<=lat<=80 and 100<lon<180):
            z[i]=9
    for i in range(len(lats)):
        outfile.write('%d %d %.1f %.1f \n'%(z0[i],z[i],lats[i],lons[i]))
        outfile.flush()
    outfile.close()

def scattermap():
   
    fig=plt.figure()
    ax=fig.add_axes([0.1,0.1,0.8,0.8])   
    m = Basemap(projection='npstere',boundinglat=45,lon_0=270,resolution='l')
      
    m.drawcoastlines(linewidth = 1)
    m.drawlsmask(land_color='darkseagreen',ocean_color='k',lakes=True)
    m.drawparallels(np.arange(-80.,81.,20.))
    m.drawmeridians(np.arange(-180.,181.,20.))
    path='/home/meng/bak_bupt/newproj/data/'

    data=np.loadtxt(path+'divide_arctic_iceage.dat')
    nodes=np.where(data[:,1]>0)[0]
    lats1=data[:,2][nodes]
    lonsx=data[:,3][nodes]
    lons1=[]
    for i in range(len(lonsx)):
        lon=lonsx[i]
        if(lon>=0):
            lon=lon
        else:
            lon=360+lon
        lons1.append(lon)
    lats1=np.array(lats1)
    lons1=np.array(lons1)
    x, y = m(lons1,lats1)
    color=data[:,1][nodes]
    
    m.scatter(x,y,1,marker='o',c=color,cmap='tab10')
 #   m.scatter(x,y,1000,marker='o',c=color.map('colors'))


    ax.annotate('1', xy=(0.15, 0.7), xycoords='axes fraction', fontsize=64 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='w',
                    ha='left', va='bottom')
    ax.annotate('2', xy=(0.17, 0.48), xycoords='axes fraction', fontsize=64 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='w',
                    ha='left', va='bottom')
    ax.annotate('3', xy=(0.5, 0.15), xycoords='axes fraction', fontsize=64 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='w',
                    ha='left', va='bottom')
    ax.annotate('4', xy=(0.7, 0.18), xycoords='axes fraction', fontsize=64 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='w',
                    ha='left', va='bottom')
    ax.annotate('5', xy=(0.65, 0.45), xycoords='axes fraction', fontsize=64 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='w',
                    ha='left', va='bottom')
    ax.annotate('6', xy=(0.55, 0.62), xycoords='axes fraction', fontsize=64 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='w',
                    ha='left', va='bottom')
    ax.annotate('7', xy=(0.48, 0.48), xycoords='axes fraction', fontsize=64 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='w',
                    ha='left', va='bottom')
    ax.annotate('8', xy=(0.44, 0.35), xycoords='axes fraction', fontsize=64 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='w',
                    ha='left', va='bottom')
    ax.annotate('9', xy=(0.35, 0.55), xycoords='axes fraction', fontsize=64 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='w',
                    ha='left', va='bottom')
    ax.annotate('10', xy=(0.3, 0.42), xycoords='axes fraction', fontsize=64 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='w',
                    ha='left', va='bottom')




    figure = plt.gcf() # get current figure
        # 
    figure.set_size_inches(24, 20)
    
    
    #ax.set_title('Great Circle from New York to London')
    #plt.show()
    plt.savefig("/home/meng/bak_bupt/newproj/fig/nodes_iceage.pdf",format='pdf',dpi=300,bbox_inches='tight')


def trend():
    path='/home/meng/bak_bupt/newproj/data/'
    datax=np.loadtxt(path+'availnodes.dat')
    nodes=[int(i) for i in datax[:,0]]
    psd=np.loadtxt(path+'psd_sum_ICE.dat')#reshape(377,480)
    N=377
    psdxx=np.reshape(psd,(N,480))

    acf=np.loadtxt(path+'autocorr_abs_ice.dat')#reshape(480,377)
    N=377
    acfx=np.reshape(acf,(480,N))
    

    icen=np.loadtxt(path+'divide_arctic.dat')

    iceagen=np.loadtxt(path+'divide_arctic_iceage.dat')
    
path='/home/meng/bupt_data/data/seaice/'
for year in range(1986,2020):
    print (year)
    files=glob.glob(path+"iceage/iceage_nh_12.5km_"+str(year)+"0101_"+str(year)+"1231_v4.1.nc")
    #data=Dataset('/home/meng/bupt_data/data/iceage/iceage_nh_12.5km_19840101_19841231_v4.1.nc','r',format='NETCDF4')
    #data=Dataset('/home/meng/bupt_data/data/seaice/iceage/iceage_nh_12.5km_19840101_19841231_v4.1.nc','r',format='NETCDF4')
    week=22
    data=Dataset(files[0],'r')
    iceage=data.variables['age_of_sea_ice'][week,:,:]
   
    lats=data.variables['latitude'][:]
    lons=data.variables['longitude'][:]
    
    outfile=open(path+"iceage/iceage_"+str(year)+"_week"+str(week)+".dat",'w')
    for i in range(722):
        for j in range(722):
            lat=lats[i,j]
            lon=lons[i,j]
            age=iceage[i,j]
            outfile.write('%.10f %.10f %d \n'%(lat,lon,age))
            outfile.flush()
    outfile.close()
    


    a=0
    b=480
    for i in nodes:
        print (i)
        x1=x[i]






def distance(nylat,nylon,lonlat,lonlon):
    dlat=nylat-lonlat
    dlon=nylon-lonlon
    a=np.sin(dlat/180.*np.pi/2.)*np.sin(dlat/180.*np.pi/2.)+np.cos(nylat/180.*np.pi)*np.cos(lonlat/180.*np.pi)*np.sin(dlon/180.*np.pi/2.)*np.sin(dlon/180.*np.pi/2.)
    c=2*math.atan2(np.sqrt(a),np.sqrt(1-a))
    d=6371*c
    return d

def plotmap():
    fig=plt.figure()
    ax=fig.add_axes([0.1,0.1,0.8,0.8])
    m = Basemap(projection='robin',lon_0=180,resolution='c')# draw coastlines, country boundaries, fill continents.
    #cs = m.contourf(x, y, air_cyclic,50)
    #cbar = plt.colorbar(cs, orientation='horizontal', shrink=0.5)
    m.drawcoastlines(linewidth=2, linestyle='solid', color='k')
    #m.drawcountries(linewidth=0.5)
    #m.fillcontinents(color='g',lake_color='aqua')
    # draw parallels and meridians.
    m.drawparallels(np.arange(-90.,120.,30.),labels=[True,True,True,True])
    m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True])
    m.drawmapboundary(fill_color='w')
    
def plotnodes():
    data=np.loadtxt('/home/meng/bupt_data/data/seaice/nonzeroicenodes.dat')
    #data=np.loadtxt('/home/meng/bupt_data/data/seaice/regridcos2.5d.dat')
    nodes=x
    m = Basemap(projection='ortho',lat_0=90,lon_0=180,resolution='l')
    m.drawcoastlines(linewidth = 3)

    #m.bluemarble()
        #m.etopo()
    m.drawparallels(np.arange(-90.,120.,5.),labels=[True,True,True,True],fontsize=34,linewidth=3)
    m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True],fontsize=34,linewidth=3)
    m.drawmapboundary(fill_color='w')
    

       
    
    lats1=np.array(data[:,1][nodes])
    lons1=np.array(data[:,2][nodes])

    x, y = m(lons1,lats1)

    color=data[:,7]
    m.scatter(x,y,400,marker='o',c='color',cmap='Blues')
    cb=plt.colorbar(fraction=0.025,pad=0.06)
    cb.set_label(label='None zeros ice years', size=34, weight='bold')
    cb.ax.tick_params(labelsize=34) 
    figure = plt.gcf() # get current figure
        # 
    figure.set_size_inches(24, 20)

    plt.savefig("/home/meng/fig/nodezeroseaicenodes.png",format='png',bbox_inches='tight')
    
def divide():    
    path='/home/jingfang/CLUSTER_DATA/orgindata/seaice/'
    nodes=np.loadtxt(path+'nodes.dat')
    outfile=open(path+'dividenodes.dat','w')
    z=np.zeros(len(nodes))
    for i in range(len(nodes)):
        lat=nodes[:,0][i]
        lon=nodes[:,1][i]
        if(lon>=0):
            lon=lon
        else:
            lon=360+lon
        if(lat<=60 and 120<lon<165):
            z[i]=1

        if(lat<=65 and 165<=lon<=200):
            z[i]=2

        if(50<lat<=65 and 260<=lon<=292.5):
            z[i]=3

        if(50<lat<=65 and 292.5<=lon<=315) or (65<lat<=80 and 280<=lon<=310) or (lat<=50 and lon>=305):
            z[i]=4

        if(60<=lat<=80 and 315<lon<=360) or (70<=lat<=80 and lon<=25):
            z[i]=5
        if(60<lat<=80 and 25<lon<=100):
            z[i]=6
        if(lat>80):
            z[i]=7
        if(65<lat<=80 and 235<=lon<=280):
            z[i]=8
        if(65<=lat<=80 and 180<=lon<=235):
            z[i]=10
        if(65<=lat<=80 and 100<lon<180):
            z[i]=9
    for i in range(len(nodes)):
        outfile.write('%d %d %.1f %.1f \n'%(i,z[i],nodes[:,0][i],nodes[:,1][i]))
        outfile.flush()
    outfile.close()

 
    
    
def scattermap():
    fig=plt.figure()
    ax=fig.add_axes([0.1,0.1,0.8,0.8])
    #m = Basemap(projection='robin',lon_0=180,resolution='c')# draw coastlines, country boundaries, fill continents.
    m = Basemap(projection='ortho',lat_0=90,lon_0=-180,resolution='l')
    m.bluemarble()
#    m.drawcoastlines(linewidth=0.25)
#    m.drawcountries(linewidth=0.25)
#    #map.fillcontinents(color='lightgreen',lake_color='aqua',alpha=0.1)
#    # draw the edge of the map projection region (the projection limb)
#    m.drawmapboundary(fill_color='aqua')
#    # draw lat/lon grid lines every 30 degrees.
#    m.drawmeridians(np.arange(0,360,30))
#    m.drawparallels(np.arange(-90,90,30))
    #cs = m.contourf(x, y, air_cyclic,50)
    #cbar = plt.colorbar(cs, orientation='horizontal', shrink=0.5)
# =============================================================================
#     m = Basemap(projection='robin',lon_0=180,resolution='c')
# =============================================================================
   # m.drawcoastlines(linewidth=2, linestyle='solid', color='k')
    #m.drawcountries(linewidth=0.5)
    #m.fillcontinents(color='orange',lake_color='aqua',alpha=0.3)
    # draw parallels and meridians.
    m.drawparallels(np.arange(-90.,120.,30.),labels=[True,True,True,True],fontsize=64,linewidth=5)
    m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True],fontsize=64,linewidth=5)
    m.drawmapboundary(fill_color='w')
# =============================================================================
#     data = Dataset(path+'era5seaice.nc','r',format='NETCDF4')
#     lats=data.variables['latitude'][:]
#     lons=data.variables['longitude'][:]
#     lats1=[]
#     lons1=[]
#     for i in range(0,len(lats),10):
#         for j in range(0,len(lons),10):
#             xpt,ypt=m(lons[j],lats[i])
#             value=m.is_land(xpt,ypt)
#             if(value is False):
#                 lats1.append(lats[i])
#                 lons1.append(lons[j])
# =============================================================================
    data=np.loadtxt('/home/jingfang/CLUSTER_DATA/orgindata/seaice/dividenodes.dat')
    lats1=data[:,2]
    lonsx=data[:,3]
    lons1=[]
    for i in range(len(lonsx)):
        lon=lonsx[i]
        if(lon>=0):
            lon=lon
        else:
            lon=360+lon
        lons1.append(lon)
    lats1=np.array(lats1)
    lons1=np.array(lons1)
    x, y = m(lons1,lats1)
    color=data[:,1]
    m.scatter(x,y,500,marker='o',c=color,cmap='tab20')


    ax.annotate('1', xy=(0.32, 0.24), xycoords='axes fraction', fontsize=64 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='k',
                    ha='left', va='bottom')
    ax.annotate('2', xy=(0.5, 0.24), xycoords='axes fraction', fontsize=64 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='k',
                    ha='left', va='bottom')
    ax.annotate('3', xy=(0.72, 0.51), xycoords='axes fraction', fontsize=64 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='k',
                    ha='left', va='bottom')
    ax.annotate('4', xy=(0.65, 0.6), xycoords='axes fraction', fontsize=64 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='k',
                    ha='left', va='bottom')
    ax.annotate('5', xy=(0.49, 0.61), xycoords='axes fraction', fontsize=64 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='k',
                    ha='left', va='bottom')
    ax.annotate('6', xy=(0.37, 0.58), xycoords='axes fraction', fontsize=64 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='k',
                    ha='left', va='bottom')
    ax.annotate('7', xy=(0.48, 0.5), xycoords='axes fraction', fontsize=64 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='k',
                    ha='left', va='bottom')
    ax.annotate('8', xy=(0.58, 0.44), xycoords='axes fraction', fontsize=64 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='k',
                    ha='left', va='bottom')
    ax.annotate('9', xy=(0.43, 0.37), xycoords='axes fraction', fontsize=64 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='k',
                    ha='left', va='bottom')
    ax.annotate('10', xy=(0.52, 0.37), xycoords='axes fraction', fontsize=64 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='k',
                    ha='left', va='bottom')




    figure = plt.gcf() # get current figure
        # 
    figure.set_size_inches(24, 20)
    
    
    #ax.set_title('Great Circle from New York to London')
    #plt.show()
    plt.savefig("/home/jingfang/fig/seaice/nodes.png",format='png',bbox_inches='tight')
    
    
def comunity():
    fig=plt.figure()
    ax=fig.add_axes([0.1,0.1,0.8,0.8])
    #m = Basemap(projection='robin',lon_0=180,resolution='c')# draw coastlines, country boundaries, fill continents.
    m = Basemap(projection='ortho',lat_0=90,lon_0=-180,resolution='l')
    m.bluemarble()

    m.drawparallels(np.arange(-90.,120.,30.),labels=[True,True,True,True],fontsize=64,linewidth=5)
    m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True],fontsize=64,linewidth=5)
    m.drawmapboundary(fill_color='w')

    data=np.loadtxt('/home/jingfang/CLUSTER_DATA/orgindata/seaice/nodes.dat')
    data1=np.loadtxt('/home/jingfang/code/detect_community/combo/airt_comm_comboC++.txt')
    lats1=data[:,0]
    lonsx=data[:,1]
    lons1=[]
    for i in range(len(lonsx)):
        lon=lonsx[i]
        if(lon>=0):
            lon=lon
        else:
            lon=360+lon
        lons1.append(lon)
    lats1=np.array(lats1)
    lons1=np.array(lons1)
    x, y = m(lons1,lats1)
    color=data1
  
    m.scatter(x,y,500,marker='o',c=color,cmap='PiYG')

    ax.annotate('a', xy=(0.37, 0.58), xycoords='axes fraction', fontsize=64 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='k',
                    ha='left', va='bottom')
    ax.annotate('b', xy=(0.5, 0.35), xycoords='axes fraction', fontsize=64 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='k',
                    ha='left', va='bottom')
    ax.annotate('c', xy=(0.72, 0.51), xycoords='axes fraction', fontsize=64 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='k',
                    ha='left', va='bottom')
    ax.annotate('d', xy=(0.45, 0.45), xycoords='axes fraction', fontsize=64 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='k',
                    ha='left', va='bottom')
    ax.annotate('f', xy=(0.49, 0.61), xycoords='axes fraction', fontsize=64 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='k',
                    ha='left', va='bottom')
    ax.annotate('e', xy=(0.32, 0.24), xycoords='axes fraction', fontsize=64 ,weight='bold',
                    xytext=(0, -12), textcoords='offset points',color='k',
                    ha='left', va='bottom')



    figure = plt.gcf() # get current figure
        # 
    figure.set_size_inches(24, 20)
    
    
    #ax.set_title('Great Circle from New York to London')
    #plt.show()
    plt.savefig("/home/jingfang/fig/seaice/comunity_airt.png",format='png',bbox_inches='tight')
    
def timeseries():
    path='/home/jingfang/CLUSTER_DATA/orgindata/seaice/'
    data=np.loadtxt('/home/jingfang/code/detect_community/combo/airt_comm_comboC++.txt')
    data1=np.loadtxt('/home/jingfang/CLUSTER_DATA/orgindata/seaice/ERA5_AIRT1000_ano_arctic.dat')
    data2=np.loadtxt('/home/jingfang/CLUSTER_DATA/orgindata/seaice/era5seaice_ano.dat')
    l=14600
    outfile1=open(path+'communityt_tano.dat','w')
    outfile2=open(path+'communityt_iceano.dat','w')
    for i in range(6):
        print i
        x1=[]
        x2=[]
        for j in range(len(data)):
            if(data[j]==i):
                y1=data1[j*l:(j+1)*l] 
                y2=data2[j*l:(j+1)*l]
                for k in range(l):
                    x1.append(y1[k])
                    x2.append(y2[k])
        z1=np.reshape(x1,(len(x1)/l,l))
        z2=np.reshape(x2,(len(x2)/l,l))
        for j in range(l):
            outfile1.write('%.6f \n'%(np.mean(z1[:,j])))
            outfile2.write('%.6f \n'%(np.mean(z2[:,j])))
            outfile1.flush()
            outfile2.flush()
    outfile1.close()
    outfile2.close()
        
def correlation():
    path='/home/jingfang/CLUSTER_DATA/orgindata/seaice/'
    
    data1=np.loadtxt(path+'communityt_tano.dat')
    data2=np.loadtxt(path+'communityt_iceano.dat')
    
    n=6
    l=14600
    x=np.reshape(data1,(n,l))
    y=np.reshape(data2,(n,l))
    for i in range(n):
        for j in range(i+1,n):
            x1=np.reshape(y[i],(40,365))
            y1=np.reshape(y[j],(40,365))
            z=[]
            z1=[]
            for k in range(40):
                c,d=pearsonr(x1[k],y1[k])
                z.append(c)
                z1.append(d)
            print i+1,j+1,np.mean(c),np.mean(d)
    
    
    for i in range(n):
        x1=np.reshape(x[i],(40,365))
        y1=np.reshape(y[i],(40,365))
        z=[]
        z1=[]
        for j in range(40):
            x2=x1[j]
            y2=y1[j]
            c,d=pearsonr(x2,y2)
            z1.append(d)
            z.append(c)
        print np.mean(z),np.mean(z1)
        plt.subplot(121)
        plt.plot(z)
        #sns.kdeplot(cx)
        plt.subplot(122)
        #sns.kdeplot(tx)
        plt.plot(z1)
        figure = plt.gcf() # get current figure
        figure.set_size_inches(20, 6)
#         
#          #figure.set_size_inches(25, 20)
#         
#         
#        
        plt.savefig("/home/jingfang/fig/seaice/"+str(i)+".png",format='png',bbox_inches='tight')
        plt.close()  
# =============================================================================
#         cx=[]
#         tx=[]
#         for j in range(1,39):
#             s1=365*j
#             z=[]
#             for k in range(-90,91):
#                 s2=s1+k
#                 x1=x[i][s1:s1+365]
#                 y1=y[i][s2:s2+365]
#                 c=pearsonr(x1,y1)[0]
#                 z.append(c)
#             for k in range(len(z)):
#                 if(abs(z[k])==max(np.abs(z))):
#                      cx.append(z[k])
#                      tx.append(90-k)
#                      break
#         plt.subplot(121)
#         plt.plot(cx)
#         #sns.kdeplot(cx)
#         plt.subplot(122)
#         #sns.kdeplot(tx)
#         plt.plot(tx)
#         figure = plt.gcf() # get current figure
#         figure.set_size_inches(20, 6)
#         
#          #figure.set_size_inches(25, 20)
#         
#         
#        
#         plt.savefig("/home/jingfang/fig/seaice/"+str(i)+".png",format='png',bbox_inches='tight')
#         plt.close()        
# =============================================================================
def scattermapa():

    data = Dataset("/home/jingfang/CLUSTER_DATA/orgindata/seaice/ERA5_ice_1980.nc",'r',format='NETCDF4')
    outfile=open('/home/jingfang/CLUSTER_DATA/CODE/Python/arctic/DATA/regridcos2.5d.dat','w')
    latx=data.variables['latitude'][:]
    lonx=data.variables['longitude'][:]
    regrid=np.loadtxt('/home/jingfang/CLUSTER_DATA/CODE/Python/arctic/DATA/regridcos2.5d_arctic.dat')
    lats=regrid[:,1]
    lons=[]
    for i in regrid[:,2]:
        if(i>=180):
            j=i-360
            lons.append(j)
        else:
            lons.append(i)
    latx=list(latx)
    lonx=list(lonx)
    nodes=[]
    lix=[]
    ljx=[]
    lx=[]
    for i in range(len(regrid)):
        if(lats[i] in latx and lons[i] in lonx):
            nodes.append(i)
            li=latx.index(lats[i])
            lj=lonx.index(lons[i])
            l=li*1440+lj
            lx.append(l)
            lix.append(li)
            ljx.append(lj)
    n=0
    for i in range(len(lx)):
        print i
        ii=lix[i]
        jj=ljx[i]
        ll=lx[i]
        ice=data.variables['siconc'][0,ii,jj]
        if(ice>=0):
            n+=1

            outfile.write('%d %.1f %.1f %d %d \n'%(nodes[i],latx[ii],lonx[jj],ii,jj))
            outfile.flush()
    outfile.close()
    
        
    
    
    fig=plt.figure()
    ax=fig.add_axes([0.1,0.1,0.8,0.8])
    #m = Basemap(projection='robin',lon_0=180,resolution='c')# draw coastlines, country boundaries, fill continents.
    m = Basemap(projection='ortho',lat_0=90,lon_0=180,resolution='l')
    m.bluemarble()
    m.drawcoastlines(linewidth = 3)

    m.drawparallels(np.arange(-90.,120.,30.),labels=[True,True,True,True],fontsize=64,linewidth=5)
    m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True],fontsize=64,linewidth=5)
    m.drawmapboundary(fill_color='w')

    regrid=np.loadtxt('/home/jingfang/CLUSTER_DATA/CODE/Python/arctic/DATA/regridcos2.5d.dat')
  #  nodes=np.loadtxt('/home/jingfang/CLUSTER_DATA/CODE/Python/arctic/DATA/Ocean.dat')
    #lats1=[90-nodes[i]/1440*0.25 for i in range(len(nodes))]
    #lons1=[nodes[i]%1440*0.25 for i in range(len(nodes))]
   

    lats1=np.array(regrid[:,1])
    lons1=np.array(regrid[:,2])
    #lats1=np.array(lats1)
    #lons1=np.array(lons1)
    x, y = m(lons1,lats1)
    m.scatter(x,y,50,marker='o',c='r')
   
    #plt.colorbar()



    figure = plt.gcf() # get current figure
        # 
    figure.set_size_inches(24, 20)
    plt.savefig('/home/jingfang/fig/seaice/2.5dcos_ocean.png')       

def scattermap():

    data = Dataset("/home/jingfang/CLUSTER_DATA/orgindata/seaice/ERA5_ice_1996.nc",'r',format='NETCDF4')
    outfile=open('/home/jingfang/CLUSTER_DATA/CODE/Python/arctic/DATA/regridcos2d.dat','w')
    n=0
    for i in range(0,201,8):
        ice=data.variables['siconc'][100,i,:]   
        lat=data.variables['latitude'][i]
        
        a=np.cos(lat*np.pi/180.)
        if(a==0):
            b=1
        else:
            b=int(1/a)
        ice=np.array(ice)
        y=np.where(ice>=0)[0]
        n+=len(y)
        y0=np.arange(0,1440,8*b)
        z=np.intersect1d(y,y0)
        #z=[y[k] for k in range(0,len(y),4)]
        print lat,z
        for j in z:
            l=i*1440+j
            lon=data.variables['longitude'][j]
            outfile.write('%d %.6f %.6f %d %d \n'%(l,lat,lon,i,j))
            outfile.flush()
    outfile.close()
        
    
    
    fig=plt.figure()
    ax=fig.add_axes([0.1,0.1,0.8,0.8])
    #m = Basemap(projection='robin',lon_0=180,resolution='c')# draw coastlines, country boundaries, fill continents.
    m = Basemap(projection='ortho',lat_0=90,lon_0=180,resolution='l')
    m.bluemarble()
    m.drawcoastlines(linewidth = 3)

    m.drawparallels(np.arange(-90.,120.,30.),labels=[True,True,True,True],fontsize=64,linewidth=5)
    m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True],fontsize=64,linewidth=5)
    m.drawmapboundary(fill_color='w')

    #regrid=np.loadtxt('/home/jingfang/CLUSTER_DATA/CODE/Python/arctic/DATA/regridcos2.5d_arctic.dat')
    regrid=np.loadtxt(path+'/CODE/Python/arctic/DATA/iceregion.dat')
    nodes=np.loadtxt('/home/jingfang/CLUSTER_DATA/CODE/Python/arctic/DATA/Ocean.dat')
    #lats1=[90-nodes[i]/1440*0.25 for i in range(len(nodes))]
    #lons1=[nodes[i]%1440*0.25 for i in range(len(nodes))]
   

    lats1=np.array(regrid[:,1])
    lons1=np.array(regrid[:,2])
    #lats1=np.array(lats1)
    #lons1=np.array(lons1)
    x, y = m(lons1,lats1)
    m.scatter(x,y,50,marker='o',c='r')
    regrid=np.loadtxt('/home/jingfang/CLUSTER_DATA/CODE/Python/arctic/DATA/regridcos2.5d_arctic.dat')

    #plt.colorbar()



    figure = plt.gcf() # get current figure
        # 
    figure.set_size_inches(24, 20)
    plt.savefig('/home/jingfang/fig/seaice/2.5dcos_ice.png')




def scattermap_global():
    data=Dataset('/home/meng/CLUSTER_DATA/orgindata/ERA5850/1990.nc','r',format='NETCDF4')
    lats=data.variables['latitude'][:]
    lons=data.variables['longitude'][:]
    outfile=open('/home/jingfang/CLUSTER_DATA/CODE/Python/arctic/DATA/regridcos2.5d_global.dat','w')
    nodes=0
    for i in range(0,73,1):
        lat=lats[i]
        #if(-40<lat<40):
        a=np.cos(lat*np.pi/180.)
        if(a==0):
            b=1
        else:
            b=int(1/a)
        y=np.arange(0,144,1*b)
        for j in y:
            lon=lons[j]
            n=i*144+j
            nodes+=1
            outfile.write('%d %.6f %.6f %d %d \n'%(n,lat,lon,i,j))
            outfile.flush()
    outfile.close()
    
    
    
def scattermap_global_bupt():
    path='/home/meng/bupt_data/'
    data=Dataset(path+'origin/1990.nc','r',format='NETCDF4')
    lats=data.variables['latitude'][:]
    lons=data.variables['longitude'][:]
    outfile=open(path+'data/seaice/regridcos7.5d_global.dat','w')
    nodes=0
    for i in range(0,73,3):
        lat=lats[i]
        #if(-40<lat<40):
        a=np.cos(lat*np.pi/180.)
        if(a==0):
            b=1
        else:
            b=int(1/a)
        y=np.arange(0,144,3*b)
        for j in y:
            lon=lons[j]
            n=i*144+j
            nodes+=1
            outfile.write('%d %.6f %.6f %d %d \n'%(n,lat,lon,i,j))
            outfile.flush()
    outfile.close()        

    lats=data.variables['latitude'][:]
    lons=data.variables['longitude'][:]
    outfile=open('/home/jingfang/CLUSTER_DATA/CODE/Python/arctic/DATA/regridcos2.5d_arctic.dat','w')
    for i in range(0,21):
        lat=lats[i]
        #if(-40<lat<40):
        a=np.cos(lat*np.pi/180.)
        if(a==0):
            b=1
        else:
            b=int(1/a)
        y=np.arange(0,144,b)
        for j in y:
            lon=lons[j]
            n=i*144+j
            outfile.write('%d %.6f %.6f %d %d \n'%(n,lat,lon,i,j))
            outfile.flush()
    outfile.close()
        
    
    
    fig=plt.figure()
    ax=fig.add_axes([0.1,0.1,0.8,0.8])
    #m = Basemap(projection='robin',lon_0=180,resolution='c')# draw coastlines, country boundaries, fill continents.
    m = Basemap(projection='moll', resolution=None, lat_0=0, lon_0=0)  
    #m.drawcoastlines(linewidth = 3)

    m.bluemarble()

    m.drawparallels(np.arange(-90.,120.,30.),labels=[True,True,True,True],fontsize=64,linewidth=5)
    m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True],fontsize=64,linewidth=5)
    m.drawmapboundary(fill_color='w')

    #regrid=np.loadtxt('/home/jingfang/CLUSTER_DATA/CODE/Python/arctic/DATA/regridcos7.5d_global.dat')
    regrid=np.loadtxt('/home/meng/bupt_data/data/seaice/regridcos7.5d_global.dat')
    
    #regrid=np.loadtxt('/home/jingfang/CLUSTER_DATA/CODE/Python/arctic/DATA/globaloceannodes_2.5d.dat')
    #lats1=[90-nodes[i]/1440*0.25 for i in range(len(nodes))]
    #lons1=[nodes[i]%1440*0.25 for i in ran1987_1_850t_G.datge(len(nodes))]
   

    lats1=np.array(regrid[:,1])
    lons1=np.array(regrid[:,2])
    #lats1=np.array(lats1)
    #lons1=np.array(lons1)
    x, y = m(lons1,lats1)
    m.scatter(x,y,50,marker='o',c='r')
   
    #plt.colorbar()



    figure = plt.gcf() # get current figure
        # 
    figure.set_size_inches(24, 20)
    plt.savefig('/home/meng/fig/7.5dcos_global_ocean.png')

    data = Dataset("/home/jingfang/CLUSTER_DATA/orgindata/seaice/ERA5_ice_1996.nc",'r',format='NETCDF4')
    outfile=open('/home/jingfang/CLUSTER_DATA/CODE/Python/arctic/DATA/regridcos2d.dat','w')
    n=0
    for i in range(0,201,8):
        ice=data.variables['siconc'][100,i,:]   
        lat=data.variables['latitude'][i]
        
        a=np.cos(lat*np.pi/180.)
        if(a==0):
            b=1
        else:
            b=int(1/a)
        ice=np.array(ice)
        y=np.where(ice>=0)[0]
        n+=len(y)
        y0=np.arange(0,1440,8*b)
        z=np.intersect1d(y,y0)
        #z=[y[k] for k in range(0,len(y),4)]
        print lat,z
        for j in z:
            l=i*1440+j
            lon=data.variables['longitude'][j]
            outfile.write('%d %.6f %.6f %d %d \n'%(l,lat,lon,i,j))
            outfile.flush()
    outfile.close()
    
def plotgrids():
        plt.subplot(221)
        
        nodes=np.arange(1788)
        ax=plt.plot()
        m = Basemap(projection='ortho',lat_0=90,lon_0=180,resolution='l')
        m.drawcoastlines(linewidth = 3)
        #m.fillcontinents(color='coral',lake_color='aqua')
    
        #m = Basemap(projection='moll', resolution=None, lat_0=0, lon_0=0)    
        #m.bluemarble()
    #    m = Basemap(projection='moll', resollution=None,
    #            lat_0=0, lon_0=0)
    #    m.etopo()
        m.drawparallels(np.arange(-90.,120.,30.),labels=[True,True,True,True],fontsize=54,linewidth=2)
        m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True],fontsize=54,linewidth=2)
        regrid=np.loadtxt('/home/jingfang/CLUSTER_DATA/CODE/Python/arctic/DATA/regridcos2.5d_global.dat')
        #lats1=[90-nodes[i]/1440*0.25 for i in range(len(nodes))]
        #lons1=[nodes[i]%1440*0.25 for i in ran1987_1_850t_G.datge(len(nodes))]
       
        lats1=np.array(regrid[:,1][nodes])
        lons1=np.array(regrid[:,2][nodes])
        x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
        #color=nca
        m.scatter(x,y,400,marker='o',c='red',cmap='cool')
          
      #  cb=plt.colorbar(fraction=0.025,pad=0.06)
       # cb.set_label(label='times', size=34, weight='bold')
       # cb.set_ticks([0.10,0.15,0.20,0.25,0.30])
        #cb.ax.tick_params(labelsize=34)    
       # cb.set_clim(0.1,0.35)
        figure = plt.gcf() # get current figure
                # 
        figure.set_size_inches(25, 25)
        plt.title('850hPa air-temperature (T)',fontsize=65)
    
        #plt.title('Significant nodes \n rall_WIndtoAO=0.387 rall_WindtoW=0.317 rall_WtoAO=0.113 N=3751\n r40Nout_WindtoAO=-0.151 r40Nout_WindtoW=0.279 r40Nout_WtoAO=0.104 N=2154',fontsize=34) #200
        #plt.title('Southern node to 40N T with correlation to NorthErn node of 40N\n significantly infulenced by wind speed in the node',fontsize=34) #1000
    
        plt.annotate('(a)', xy=(-0.1,1.0), xycoords='axes fraction', fontsize=65 ,
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom')    
        plt.subplot(222)
        regrid=np.loadtxt('/home/jingfang/CLUSTER_DATA/CODE/Python/arctic/DATA/regridcos2.5d.dat')

        #nodes=regrid[:,0]
        m = Basemap(projection='ortho',lat_0=90,lon_0=180,resolution='l')
        m.drawcoastlines(linewidth = 3)
    
        #m.bluemarble()
            #m.etopo()
        m.drawparallels(np.arange(-90.,120.,30.),labels=[True,True,True,True],fontsize=54,linewidth=3)
        m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True],fontsize=54,linewidth=3)
        m.drawmapboundary(fill_color='w')
        
    
           
        
        lats1=np.array(regrid[:,1])
        lons1=np.array(regrid[:,2])
    
        x, y = m(lons1,lats1)
    
       # color=ncg[:1788]
        m.scatter(x,y,400,marker='o',c='blue',cmap='cool')
           
        plt.title('Ice concentration (ICE)',fontsize=65)
    
        plt.annotate('(b)', xy=(-0.1,1.0), xycoords='axes fraction', fontsize=65 ,
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom')    
        plt.subplot(212)
        regrid=np.loadtxt('/home/jingfang/CLUSTER_DATA/CODE/Python/arctic/DATA/regridcos2.5d_global.dat')

        nodes=np.where(regrid[:,1]!=40)[0]
        m = Basemap(projection='robin',lon_0=0,resolution='c')# draw coastlines, country boundaries, fill continents.

        m.drawcoastlines(linewidth = 3)
    
        #m.bluemarble()
            #m.etopo()
        m.drawparallels([-80,-40,0,40,80],labels=[True,True,True,True],fontsize=54,linewidth=3)
        m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True],fontsize=54,linewidth=3)
        m.drawmapboundary(fill_color='w')
        
    
           
        
        lats1=np.array(regrid[:,1][nodes])
        lons1=np.array(regrid[:,2][nodes])
    
        x, y = m(lons1,lats1)
    
        #color=ncg[1788:]
        m.scatter(x,y,300,marker='o',c='red',cmap='cool')
        
        lats=np.zeros(500)
        lats=[40. for i in range(500)]
        lons=np.arange(500)*360/500.
        x, y = m(lons,lats)
        plt.title('850hPa air-temperature (T)',fontsize=65)
        #color=ncg[1788:]
        m.scatter(x,y,300,marker='o',c='k')
        
        plt.annotate('NG', xy=(0.5,0.8), xycoords='axes fraction', fontsize=150 ,
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,weight="bold",
                         ha='left', va='bottom')   
        plt.annotate('SG', xy=(0.5,0.3), xycoords='axes fraction', fontsize=150 ,
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,weight="bold",
                         ha='left', va='bottom')   
    

        plt.annotate('(c)', xy=(-0.1,1.0), xycoords='axes fraction', fontsize=65 ,
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom')   
    
        plt.subplots_adjust(top = 0.95, bottom = 0.0, right = 0.9, left = 0.1, 
                hspace = 0.01, wspace = 0.2)   
    
        figure = plt.gcf() # get current figure
                # 
        figure.set_size_inches(45, 45)
        plt.savefig("/home/jingfang/fig/seaice/network/H_tau10/sy1node/grids.png")
    
    

def scattermapICECONC1():
    fig=plt.figure()
    ax=fig.add_axes([0.1,0.1,0.8,0.8])
    #m = Basemap(projection='robin',lon_0=180,resolution='c')# draw coastlines, country boundaries, fill continents.
    m = Basemap(projection='ortho',lat_0=90,lon_0=-180,resolution='l')
    m.bluemarble()

    m.drawparallels(np.arange(-90.,120.,30.),labels=[True,True,True,True],fontsize=64,linewidth=5)
    m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True],fontsize=64,linewidth=5)
    m.drawmapboundary(fill_color='w')
    year=1979
    day=32
    cut=15
    data=np.loadtxt("/home/jingfang/CLUSTER_DATA/CODE/Python/arctic/DATA/SEA_ICE/"+str(year)+"_"+str(day)+".dat")
    myList=list(data)
    x=np.argsort(myList)
    y=x[::-1]
    z=[i for i in y if myList[i]>cut/100.]
    regrid=np.loadtxt('/home/jingfang/CLUSTER_DATA/CODE/Python/arctic/DATA/Ocean_1degree_cos.dat')
    nodes=np.loadtxt('/home/jingfang/CLUSTER_DATA/CODE/Python/arctic/DATA/Ocean.dat')
    color=[myList[i] for i in z]
   
  #  z=[i for i in z if int(nodes[i]) in regrid]
  #  z=[nodes[i] for i in z]
    
    lats1=[90-nodes[i]/1440*0.25 for i in z]
    lons1=[nodes[i]%1440*0.25 for i in z]

    lats1=np.array(lats1)
    lons1=np.array(lons1)
    x, y = m(lons1,lats1)
    m.scatter(x,y,10,marker='o',c=color,cmap='YlOrRd')
   
    cb=plt.colorbar()
    cb.set_label(label='density', size=24, weight='bold')
    cb.ax.tick_params(labelsize=24)    



    figure = plt.gcf() # get current figure
        # 
    figure.set_size_inches(24, 20)
    
    a=int(len(z))
    b=np.mean(color)
    b=round(b,2)
    c=round(sum(color),2)
    #ax.set_title('Great Circle from New York to London')
    #plt.show()
    plt.savefig("/home/jingfang/fig/seaice/T850/"+str(year)+"_"+str(day)+"_"+str(cut)+"_"+str(a)+"_"+str(b)+"_"+str(c)+".png",format='png',bbox_inches='tight')        




def t850():

    fig=plt.figure()
    ax=fig.add_axes([0.1,0.1,0.8,0.8])
    #m = Basemap(projection='robin',lon_0=180,resolution='c')# draw coastlines, country boundaries, fill continents.
    m = Basemap(projection='ortho',lat_0=90,lon_0=-180,resolution='l')
    m.bluemarble()

    m.drawparallels(np.arange(-90.,120.,30.),labels=[True,True,True,True],fontsize=34,linewidth=5)
    m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True],fontsize=34,linewidth=5)
    m.drawmapboundary(fill_color='w')
    year=1979
    day=32
    cut=15
    data0 = Dataset("/home/jingfang/CLUSTER_DATA/orgindata/seaice/ERA5_850hp_"+str(year)+".nc",'r',format='NETCDF4')
    data=np.loadtxt("/home/jingfang/CLUSTER_DATA/CODE/Python/arctic/DATA/SEA_ICE/"+str(year)+"_"+str(day)+".dat")

    myList=list(data)
    x=np.argsort(myList)
    y=x[::-1]
    z=[i for i in y if myList[i]>cut/100.]
    regrid=np.loadtxt('/home/jingfang/CLUSTER_DATA/CODE/Python/arctic/DATA/Ocean_1degree_cos.dat')
    nodes=np.loadtxt('/home/jingfang/CLUSTER_DATA/CODE/Python/arctic/DATA/Ocean.dat')
    #color=[myList[i] for i in z]
   
  #  z=[i for i in z if int(nodes[i]) in regrid]
  #  z=[nodes[i] for i in z]
    lats0=[int(nodes[i]/1440) for i in z]
    lons0=[int(nodes[i]%1440) for i in z]
    lats0=np.array(lats0)
    lons0=np.array(lons0)
    datat=[]
    for i in range(len(z)):
        a=int(nodes[i]/1440)
        b=int(nodes[i]%1440)
        datat.append(data0.variables['t'][day,a,b])
   # datat=data0.variables['t'][day,lats0,lons0]
    lats1=[90-nodes[i]/1440*0.25 for i in z]
    lons1=[nodes[i]%1440*0.25 for i in z]

    lats1=np.array(lats1)
    lons1=np.array(lons1)
    x, y = m(lons1,lats1)
    color=datat
    m.scatter(x,y,10,marker='o',c=color,cmap='YlOrRd')
   
    cb=plt.colorbar()

    cb.set_label(label='T850', size=24, weight='bold')
    cb.ax.tick_params(labelsize=24)    


    figure = plt.gcf() # get current figure
        # 
    figure.set_size_inches(24, 20)
    
    a=int(len(z))
    b=np.mean(color)
    b=round(b,2)
    c=round(sum(color),2)
    #ax.set_title('Great Circle from New York to London')
    #plt.show()
    plt.savefig("/home/jingfang/fig/seaice/T850/850t_"+str(year)+"_"+str(day)+"_"+str(cut)+"_"+str(a)+"_"+str(b)+"_"+str(c)+".png",format='png',bbox_inches='tight')        
            

def scatter():
       A="/Users/fanjingfang/CLUSTER_DATA/"
       A='/home/jingfang/CLUSTER_DATA/'
       #A="/p/tmp/jingfang/"
       a=A+"orgindata/seaice/ERA5_850hp_"
       b=".nc"
       c=A+"/CODE/Python/arctic/DATA/850HP/"
       a1=A+"orgindata/seaice/ERA5_ice_"
        
       path=A+'CODE/Python/arctic/Counts/'
       year=2018
       print year
       data_lebel = int(year)
       
       datat = Dataset(a+str(data_lebel)+b,'r',format='NETCDF4')
       dataice = Dataset(a1+str(data_lebel)+b,'r',format='NETCDF4')
       nodes=np.loadtxt(A+'CODE/Python/arctic/DATA/regridcos1d.dat')
       for d in range(1):
           date=215
         
           x=[]
           for no in range(len(nodes)):
               la=nodes[:,3][no]
               lb=nodes[:,4][no]
               la=int(la)
               lb=int(lb)
               x.append(dataice.variables['siconc'][date,la,lb])
           x=np.array(x)                    #date=int(data1[:,1][i])
      
                    #x=np.array(dataice.variables['siconc'][date,j,:])
                    #z=np.array(datat.variables['t'][date,j,:])
           y=np.where(x==1)[0]
           #print y
           cut=0.15
           y1=np.where(x>=cut)[0]
           yy1=np.where(x<0.80)[0]
           y3=np.intersect1d(y1,yy1)
           y2=np.where(x>=0.95)[0]
          # y1=y3
          # for s in range(-60,61):
           #    print s
           z=[]        
           for no in range(len(nodes)):
               la=nodes[:,3][no]
               lb=nodes[:,4][no]
               la=int(la)
               lb=int(lb)
               z.append(datat.variables['t'][date,la,lb])

           icex=x
           tx=z
           c0=pearsonr(icex,tx)[0]
           
           if(len(y1)==0):
                c1=0
           else:
                icex=[]
                tx=[]
                for kk in y1:
                    icex.append(x[kk])
                    tx.append(z[kk])
                c1=pearsonr(icex,tx)[0]
           X=icex
           Y=tx
           xy = np.vstack([X,Y])
           z = gaussian_kde(xy)(xy)
           plt.scatter(X, Y, c=z, s=50, edgecolor='')   
           plt.xlabel('iceconc')
           plt.ylabel('t850')
           cb=plt.colorbar()
        
           cb.set_label(label='density', size=10, weight='bold')
           cb.ax.tick_params(labelsize=10)    
        
        
           figure = plt.gcf() # get current figure
                # 
           figure.set_size_inches(6, 5)
            
           c1=round(c1,2)
            #ax.set_title('Great Circle from New York to London')
            #plt.show()
           plt.savefig("/home/jingfang/fig/seaice/T850/scatter_"+str(year)+"_"+str(date)+"_"+str(cut)+"_"+str(c1)+".png",format='png',bbox_inches='tight')        
        

        
def scattermapICECONC2():
    fig=plt.figure()
    ax=fig.add_axes([0.1,0.1,0.8,0.8])
    #m = Basemap(projection='robin',lon_0=180,resolution='c')# draw coastlines, country boundaries, fill continents.
    m = Basemap(projection='ortho',lat_0=90,lon_0=-180,resolution='l')
    m.bluemarble()

    m.drawparallels(np.arange(-90.,120.,30.),labels=[True,True,True,True],fontsize=34,linewidth=5)
    m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True],fontsize=34,linewidth=5)
    m.drawmapboundary(fill_color='w')
    year=2018
    month=7
    day=4
    cut=95
   # data=np.loadtxt("/home/jingfang/CLUSTER_DATA/CODE/Python/arctic/DATA/SEA_ICE/"+str(year)+"_"+str(day)+".dat")
    data=np.loadtxt("/home/jingfang/CLUSTER_DATA/CODE/Python/arctic/DATA/NASSSIC/"+str(year)+"_"+str(month)+"_"+str(day)+".dat")
    MOdata=Dataset('/home/jingfang/CLUSTER_DATA/CODE/Python/arctic/SMOD_1979-2017_v04r00.nc','r')
    nodes=np.loadtxt('/home/jingfang/CLUSTER_DATA/CODE/Python/arctic/DATA/NASSSIC/Ocean.dat')

    lonx=MOdata.variables['longitude'][:]
    latx=MOdata.variables['latitude'][:]
    myList=list(data)
    x=np.argsort(myList)
    y=x[::-1]
    z0=[i for i in y if myList[i]>cut/100.]
    print len(z0)
    z=[int(nodes[i]) for i in y if myList[i]>cut/100.]
    
    color=[myList[i] for i in z0]
    

    
    lats1=[latx[int(i/304),int(i%304)] for i in z]
    lons1=[lonx[int(i/304),int(i%304)] for i in z]    

    lats1=np.array(lats1)
    lons1=np.array(lons1)
    x, y = m(lons1,lats1)
    m.scatter(x,y,10,marker='o',c=color,cmap='YlOrRd')
   
    cb=plt.colorbar()
    cb.set_label(label='density', size=24, weight='bold')
    cb.ax.tick_params(labelsize=24)    



    figure = plt.gcf() # get current figure
        # 
    figure.set_size_inches(24, 20)
    a=int(len(z))
    b=round(np.mean(color),2)
    c=round(sum(color),2)
    
    #ax.set_title('Great Circle from New York to London')
    #plt.show()
    plt.savefig("/home/jingfang/fig/seaice/T850/nass_"+str(year)+"_"+str(month)+"_"+str(day)+"_"+str(cut)+"_"+str(a)+"_"+str(b)+"_"+str(c)+".png",format='png',bbox_inches='tight')        
            
def scattermapICECONC3():
  #  fig=plt.figure()
   # ax=fig.add_axes([0.1,0.1,0.8,0.8])
    plt.subplot(121)
    #m = Basemap(projection='robin',lon_0=180,resolution='c')# draw coastlines, country boundaries, fill continents.
    m = Basemap(projection='ortho',lat_0=90,lon_0=0,resolution='l')
    m.bluemarble()

    m.drawparallels(np.arange(-90.,120.,30.),labels=[True,True,True,True],fontsize=24,linewidth=2)
    m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True],fontsize=24,linewidth=2)
    m.drawmapboundary(fill_color='w')
    year=1979
    day=45
    cut=95
    data=np.loadtxt("/home/jingfang/CLUSTER_DATA/CODE/Python/arctic/Counts/icec_mo_"+str(year)+".dat")
    x=np.array(data[:,5])
    x1=np.where(x>=0.95)[0]
    x1=list(x1)

    lats1=data[:,3][x1]
    lons1=data[:,4][x1]

    color=data[:,6][x1]
   
  #  z=[i for i in z if int(nodes[i]) in regrid]
  #  z=[nodes[i] for i in z]
    


    lats1=np.array(lats1)
    lons1=np.array(lons1)
    x, y = m(lons1,lats1)
    m.scatter(x,y,5,marker='o',c=color,edgecolor=None,cmap='YlOrRd')
   
    cb = plt.colorbar()
    cb.set_label(label='MO(days)', size=24, weight='bold')
    cb.ax.tick_params(labelsize=24)

    
    plt.subplot(122)
# =============================================================================
#     a=data[:,2][x1]
#     b=data[:,3][x1]
#     plt.hist2d(a, b, (50, 50), cmap=plt.cm.jet)
# =============================================================================
# =============================================================================
#     x=data[:,2][x1]
#     y=data[:,3][x1]
#     
#     lats=data[:,0][x1]
#     lons=data[:,1][x1]
#     zz=[np.cos(i*np.pi/180.) for i in lats]
#     L=sum(zz)
#     x2=np.linspace(min(x)-1,max(x),50)
#     y2=np.linspace(min(y)-0.00001,max(y),50)
#    # x2=np.arange(min(x),max(x)+(max(x)-min(x))/100.,(max(x)-min(x))/100.)
#     #y2=np.arange(min(y),max(y)+(max(y)-min(y))/100.,(max(y)-min(y))/100.)
#     Z=[]
#     X=[]
#     Y=[]
#     for i in range(1,len(x2)):
#         xa=x2[i-1]
#         xb=x2[i]
#         x3a=np.where(x<=xb)[0]
#         x3b=np.where(x>xa)[0]
#         x3=np.intersect1d(x3a, x3b)
#         
#         
#         x4=[np.cos(lats[j]*np.pi/180.) for j in x3]
#         for j in range(1,len(y2)):
#             ya=y2[j-1]
#             yb=y2[j]
#             y3=np.array(y[x3])
#             y4a=np.where(y3<=yb)[0]
#             y4b=np.where(y3>ya)[0]
#             y4=np.intersect1d(y4a,y4b)
#             n=0
#             for k in y4:
#                 n+=x4[k]
#             Z.append(n/L)
#             X.append(xa)
#             Y.append(ya)
#     
#     plt.scatter(X,Y,c=Z,s=500,edgecolor='',cmap='hot')
# =============================================================================
#    plt.ylim(0.95,1)
#    plt.yticks(np.arange(0.95, 1, step=0.01),fontsize=24)
#    plt.xticks(np.arange(0,max(x),step=50),fontsize=24)
    x=data[:,6][x1]
    y=data[:,5][x1]
    xy = np.vstack([x,y])
    z = gaussian_kde(xy)(xy)
    plt.ylim(0.95,1)
    plt.yticks(np.arange(0.95, 1, step=0.01),fontsize=24)
    plt.xticks(np.arange(0,max(x),step=50),fontsize=24)
    plt.scatter(x, y, c=z, s=50, edgecolor='')    
    cb = plt.colorbar()
    cb.set_label(label='density', size=24, weight='bold')
    cb.ax.tick_params(labelsize=24)    
    cb.set_clim(min(z),max(z))
    figure = plt.gcf() # get current figure
        # 
    figure.set_size_inches(35, 15)
    
   
    #ax.set_title('Great Circle from New York to London')
    #plt.show()
    plt.savefig("/home/jingfang/fig/seaice/"+str(year)+"_"+str(cut)+".png",format='png',bbox_inches='tight')        
            
def scattermapICECONC4():
    fig=plt.figure()
    ax=fig.add_axes([0.1,0.1,0.8,0.8])
    #m = Basemap(projection='robin',lon_0=180,resolution='c')# draw coastlines, country boundaries, fill continents.
    m = Basemap(projection='ortho',lat_0=90,lon_0=-180,resolution='l')
    m.bluemarble()

    m.drawparallels(np.arange(-90.,120.,30.),labels=[True,True,True,True],fontsize=64,linewidth=5)
    m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True],fontsize=64,linewidth=5)
    m.drawmapboundary(fill_color='w')
    year=2015
    month=2
    day=14
    cut=95
   # data=np.loadtxt("/home/jingfang/CLUSTER_DATA/CODE/Python/arctic/DATA/SEA_ICE/"+str(year)+"_"+str(day)+".dat")
    data=np.loadtxt("/home/jingfang/CLUSTER_DATA/CODE/Python/arctic/DATA/NASSSIC/"+str(year)+"_"+str(month)+"_"+str(day)+".dat")
    MOdata=Dataset('/home/jingfang/CLUSTER_DATA/CODE/Python/arctic/SMOD_1979-2017_v04r00.nc','r')
    nodes=np.loadtxt('/home/jingfang/CLUSTER_DATA/CODE/Python/arctic/DATA/NASSSIC/Ocean.dat')

    lonx=MOdata.variables['longitude'][:]
    latx=MOdata.variables['latitude'][:]
    myList=list(data)
    x=np.argsort(myList)
    y=x[::-1]
    z0=[i for i in y if myList[i]>cut/100.]
    print len(z0)
    z=[int(nodes[i]) for i in y if myList[i]>cut/100.]
    
    color=[myList[i] for i in z0]
    

    
    lats1=[latx[int(i/304),int(i%304)] for i in z]
    lons1=[lonx[int(i/304),int(i%304)] for i in z]    

    lats1=np.array(lats1)
    lons1=np.array(lons1)
    x, y = m(lons1,lats1)
    m.scatter(x,y,10,marker='o',c=color,cmap='Reds')
   
    plt.colorbar()



    figure = plt.gcf() # get current figure
        # 
    figure.set_size_inches(24, 20)
    a=int(len(z))
    b=round(np.mean(color),2)
    c=round(sum(color),2)
    
    #ax.set_title('Great Circle from New York to London')
    #plt.show()
    plt.savefig("/home/jingfang/fig/seaice/nass_"+str(year)+"_"+str(month)+"_"+str(day)+"_"+str(cut)+"_"+str(a)+"_"+str(b)+"_"+str(c)+".png",format='png',bbox_inches='tight')        
            
def MO_ICEC():
    for year in range(2007,2018):
        cut=0.95
        fig=plt.figure()
        ax1 = fig.add_subplot(2,2,1)
        
   # ax=fig.add_axes([0.1,0.1,0.8,0.8])
        #ax1=plt.subplot(221)
        #m = Basemap(projection='robin',lon_0=180,resolution='c')# draw coastlines, country boundaries, fill continents.
        m = Basemap(projection='ortho',lat_0=90,lon_0=0,resolution='l')
        m.bluemarble()
    
        m.drawparallels(np.arange(-90.,120.,30.),labels=[True,True,True,True],fontsize=44,linewidth=2)
        m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True],fontsize=44,linewidth=2)
        m.drawmapboundary(fill_color='w')
        
        data=np.loadtxt("/home/jingfang/CLUSTER_DATA/CODE/Python/arctic/Counts/icec_mo_"+str(year)+".dat")
        x=np.array(data[:,5])
        x1=np.where(x>=0.95)[0]
        x1=list(x1)
    
        lats1=data[:,3][x1]
        lons1=data[:,4][x1]
    
        color=data[:,5][x1]
       
      #  z=[i for i in z if int(nodes[i]) in regrid]
      #  z=[nodes[i] for i in z]
        
    
    
        lats1=np.array(lats1)
        lons1=np.array(lons1)
        x, y = m(lons1,lats1)
        m.scatter(x,y,5,marker='o',c=color,edgecolor=None,cmap='YlOrRd')
       
        cb = plt.colorbar()
        cb.set_label(label='iceconc', size=44, weight='bold')
        cb.ax.tick_params(labelsize=44)
    
        
        #ax2=plt.subplot(222)
        ax2 = fig.add_subplot(2,2,2)
           
        x=data[:,6][x1]
        y=data[:,5][x1]
        xy = np.vstack([x,y])
        z = gaussian_kde(xy)(xy)
        plt.ylim(0.95,1)
        plt.yticks(np.arange(0.95, 1, step=0.01),fontsize=44)
        plt.xticks(np.arange(0,max(x),step=50),fontsize=44)
        plt.scatter(x, y, c=z, s=100, edgecolor='')    
       # plt.hist2d(x, y, bins=50, cmap='Blues')
        cb = plt.colorbar()
        cb.set_label(label='density', size=44, weight='bold')
        cb.ax.tick_params(labelsize=24)    
        cb.set_clim(min(z),max(z))
        plt.xlabel('MO',fontsize=44)
        plt.ylabel('iceconc',fontsize=44)
        ax3 = fig.add_subplot(2,2,3)
       # ax3=plt.subplot(223)
        #m = Basemap(projection='robin',lon_0=180,resolution='c')# draw coastlines, country boundaries, fill continents.
        m = Basemap(projection='ortho',lat_0=90,lon_0=0,resolution='l')
        m.bluemarble()
    
        m.drawparallels(np.arange(-90.,120.,30.),labels=[True,True,True,True],fontsize=44,linewidth=2)
        m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True],fontsize=44,linewidth=2)
        m.drawmapboundary(fill_color='w')
        
        data=np.loadtxt("/home/jingfang/CLUSTER_DATA/CODE/Python/arctic/Counts/icec_mo_"+str(year)+".dat")
        x=np.array(data[:,5])
        x1=np.where(x>=0.95)[0]
        x1=list(x1)
    
        lats1=data[:,3][x1]
        lons1=data[:,4][x1]
        cc=[i/max(data[:,6][x1]) for i in data[:,6][x1]]
        color=data[:,6][x1]
       
      #  z=[i for i in z if int(nodes[i]) in regrid]
      #  z=[nodes[i] for i in z]
        
    
    
        lats1=np.array(lats1)
        lons1=np.array(lons1)
        x, y = m(lons1,lats1)
        m.scatter(x,y,5,marker='o',c=color,edgecolor=None,cmap='YlOrRd')
       
        cb = plt.colorbar()
        cb.set_label(label='MO(days)', size=44, weight='bold')
        cb.ax.tick_params(labelsize=24)        

        ax4 = fig.add_subplot(2,2,4)         

        #ax4=plt.plot(224)
        ax5 = ax4.twiny()
        xticks=np.arange(0.95,1,0.01)
        ax4.set_xticks(np.arange(0.95,1,0.01)) 
        ax4.set_xticklabels(xticks, fontsize=44)
        xticks=np.arange(0,365,20)
        ax5.set_xticks(xticks) 
        ax5.set_xticklabels(xticks, fontsize=44)
        yticks=np.arange(0,3000,500)
        ax4.set_yticks(yticks) 
        ax4.set_yticklabels(yticks, fontsize=44)

#        fig = plt.figure()
#        ax1 = fig.add_axes([0.1, 0.5, 0.8, 0.4],
#                           ylim=(-1.2, 1.2))
        icecx=data[:,5][x1]

        ax4.hist(icecx,bins=20,normed=False,label='iceconc',color='b',alpha=0.5)
#        ax2 = fig.add_axes([0.1, 0.1, 0.8, 0.4],
#                           ylim=(-1.2, 1.2))
        ax4.legend(loc='upper right', bbox_to_anchor=(0.3, 0.95),fontsize=44)
        ax4.set_xlabel('iceconc',fontsize=44)
        mox=data[:,6][x1]
       # ax1.hist(icecx,bins=20,normed=True,label='iceconc',color='b')
        ax5.hist(mox,bins=50,normed=False,label='MO',color='r',alpha=0.5)
        ax5.legend(loc='upper right', bbox_to_anchor=(0.225, 0.85),fontsize=44)
        ax5.set_xlabel('MO(days)',fontsize=44)
# =============================================================================
#         colors = ['#E69F00', '#56B4E9',]
#         names = ['iceconc', 'MO']
# 
#         plt.hist([icecx,mox], bins = int(180/15), normed=True,
#          color = colors, label=names)
# =============================================================================


        figure = plt.gcf() # get current figure
            # 
        figure.set_size_inches(50, 45)
        
       
        #ax.set_title('Great Circle from New York to London')
        #plt.show()
        plt.savefig("/home/jingfang/fig/seaice/MO/"+str(year)+"_"+str(cut)+".png",format='png',bbox_inches='tight')  
        plt.close()
#MO_ICEC()
        
def ICEAGE_ICEC():
    for year in range(2007,2019):
        cut=0.95
        fig=plt.figure()
        ax1 = fig.add_subplot(2,2,1)
        
   # ax=fig.add_axes([0.1,0.1,0.8,0.8])
        #ax1=plt.subplot(221)
        #m = Basemap(projection='robin',lon_0=180,resolution='c')# draw coastlines, country boundaries, fill continents.
        m = Basemap(projection='ortho',lat_0=90,lon_0=0,resolution='l')
        m.bluemarble()
    
        m.drawparallels(np.arange(-90.,120.,30.),labels=[True,True,True,True],fontsize=44,linewidth=2)
        m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True],fontsize=44,linewidth=2)
        m.drawmapboundary(fill_color='w')
        
        data=np.loadtxt("/home/jingfang/CLUSTER_DATA/CODE/Python/arctic/Counts/icec_age_"+str(year)+".dat")
        x=np.array(data[:,5])
        x1=np.where(x>=0.95)[0]
        x1=list(x1)
    
        lats1=data[:,3][x1]
        lons1=data[:,4][x1]
    
        color=data[:,5][x1]
       
      #  z=[i for i in z if int(nodes[i]) in regrid]
      #  z=[nodes[i] for i in z]
        
    
    
        lats1=np.array(lats1)
        lons1=np.array(lons1)
        x, y = m(lons1,lats1)
        m.scatter(x,y,5,marker='o',c=color,edgecolor=None,cmap='YlOrRd')
       
        cb = plt.colorbar()
        cb.set_label(label='iceconc', size=44, weight='bold')
        cb.ax.tick_params(labelsize=44)
    
        
        #ax2=plt.subplot(222)
        ax2 = fig.add_subplot(2,2,2)
           
        x=data[:,6][x1]
        y=data[:,5][x1]
        xy = np.vstack([x,y])
        z = gaussian_kde(xy)(xy)
        plt.ylim(0.95,1)
        plt.yticks(np.arange(0.95, 1, step=0.01),fontsize=44)
       # plt.xticks(np.arange(0,max(x),step=50),fontsize=44)
        plt.scatter(x, y, c=z, s=500, edgecolor='')    
       # plt.hist2d(x, y, bins=50, cmap='Blues')
        cb = plt.colorbar()
        cb.set_label(label='density', size=44, weight='bold')
        cb.ax.tick_params(labelsize=24)    
        cb.set_clim(min(z),max(z))
        plt.xlabel('iceage',fontsize=44)
        plt.ylabel('iceconc',fontsize=44)
        ax3 = fig.add_subplot(2,2,3)
       # ax3=plt.subplot(223)
        #m = Basemap(projection='robin',lon_0=180,resolution='c')# draw coastlines, country boundaries, fill continents.
        m = Basemap(projection='ortho',lat_0=90,lon_0=0,resolution='l')
        m.bluemarble()
    
        m.drawparallels(np.arange(-90.,120.,30.),labels=[True,True,True,True],fontsize=44,linewidth=2)
        m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True],fontsize=44,linewidth=2)
        m.drawmapboundary(fill_color='w')
        
        data=np.loadtxt("/home/jingfang/CLUSTER_DATA/CODE/Python/arctic/Counts/icec_age_"+str(year)+".dat")
        x=np.array(data[:,5])
        x1=np.where(x>=0.95)[0]
        x1=list(x1)
    
        lats1=data[:,3][x1]
        lons1=data[:,4][x1]
        cc=[i/max(data[:,6][x1]) for i in data[:,6][x1]]
        color=data[:,6][x1]
       
      #  z=[i for i in z if int(nodes[i]) in regrid]
      #  z=[nodes[i] for i in z]
        
    
    
        lats1=np.array(lats1)
        lons1=np.array(lons1)
        x, y = m(lons1,lats1)
        m.scatter(x,y,5,marker='o',c=color,edgecolor=None,cmap='YlOrRd')
       
        cb = plt.colorbar()
        cb.set_label(label='iceage(years)', size=44, weight='bold')
        cb.ax.tick_params(labelsize=24)        

        ax4 = fig.add_subplot(2,2,4)         

        #ax4=plt.plot(224)
        ax5 = ax4.twiny()
#        xticks=np.arange(0.95,1,0.01)
#        ax4.set_xticks(np.arange(0.95,1,0.01)) 
#        ax4.set_xticklabels(xticks, fontsize=44)
#        xticks=np.arange(0,365,20)
#        ax5.set_xticks(xticks) 
#        ax5.set_xticklabels(xticks, fontsize=44)
#        yticks=np.arange(0,3000,500)
#        ax4.set_yticks(yticks) 
#        ax4.set_yticklabels(yticks, fontsize=44)

#        fig = plt.figure()
#        ax1 = fig.add_axes([0.1, 0.5, 0.8, 0.4],
#                           ylim=(-1.2, 1.2))
        icecx=data[:,5][x1]

        ax4.hist(icecx,bins=20,normed=False,label='iceconc',color='b',alpha=0.5)
#        ax2 = fig.add_axes([0.1, 0.1, 0.8, 0.4],
#                           ylim=(-1.2, 1.2))
        ax4.legend(loc='upper right', bbox_to_anchor=(0.3, 0.95),fontsize=44)
        ax4.set_xlabel('iceconc',fontsize=44)
        mox=data[:,6][x1]
       # ax1.hist(icecx,bins=20,normed=True,label='iceconc',color='b')
        ax5.hist(mox,bins=50,normed=False,label='MO',color='r',alpha=0.5)
        ax5.legend(loc='upper right', bbox_to_anchor=(0.225, 0.85),fontsize=44)
        ax5.set_xlabel('iceage(ys)',fontsize=44)
# =============================================================================
#         colors = ['#E69F00', '#56B4E9',]
#         names = ['iceconc', 'MO']
# 
#         plt.hist([icecx,mox], bins = int(180/15), normed=True,
#          color = colors, label=names)
# =============================================================================


        figure = plt.gcf() # get current figure
            # 
        figure.set_size_inches(50, 45)
        
       
        #ax.set_title('Great Circle from New York to London')
        #plt.show()
        plt.savefig("/home/jingfang/fig/seaice/AGE/"+str(year)+"_"+str(cut)+".png",format='png',bbox_inches='tight')  
        plt.close()
#ICEAGE_ICEC()        
        
        
        
        
        
        