#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Sat Apr 22 18:56:31 2023

@author: meng
"""


from netCDF4 import Dataset
import numpy as np

import os
import conda

from mpl_toolkits.basemap import Basemap
import matplotlib.pyplot as plt
from matplotlib.pyplot import MultipleLocator
import numpy as np
import pandas as pd
import networkx as nx
from geopy.distance import geodesic
from geopy.distance import great_circle as GC
from matplotlib import cm
import matplotlib.colors as colors
from matplotlib.colors import ListedColormap, LinearSegmentedColormap
import cartopy.crs as ccrs


from scipy.stats import norm
from geopy.distance import geodesic

from collections import Counter
import os
os.environ['PROJ_LIB'] = r'/home/meng/anaconda3/pkgs/proj-7.2.0-h8b9fe22_0/share/proj'
from matplotlib import colors 
from numpy.random import multivariate_normal 
import seaborn as sns
import pandas as pd
import matplotlib.pyplot as plt
import numpy as np
from scipy import stats
from matplotlib.ticker import MultipleLocator, FormatStrFormatter 
from scipy.stats.stats import pearsonr
from mpl_toolkits.basemap import Basemap, addcyclic, shiftgrid
from numpy import random, histogram2d, diff
import matplotlib.pyplot as plt
from scipy.interpolate import interp2d
import math
from matplotlib.ticker import (MultipleLocator, FormatStrFormatter,
                               AutoMinorLocator)
from scipy.stats import rankdata
    
from scipy.stats import gaussian_kde

import matplotlib as mpl
    
import glob
import seaborn as sns

def link(ICE1T1):
    cmax11=max(ICE1T1)
    cmin11=min(ICE1T1)
    tmax11=ICE1T1.index(cmax11)-20
    tmin11=ICE1T1.index(cmin11)-20
    wp11=(cmax11-np.mean(ICE1T1))/np.std(ICE1T1)
    wn11=(cmin11-np.mean(ICE1T1))/np.std(ICE1T1)
    cabs11,wabs11,tabs11=vabs(cmax11,cmin11,wp11,wn11,tmax11,tmin11)
    return cmax11,cmin11,wp11,wn11,tmax11,tmin11,cabs11,wabs11,tabs11

def vabs(cmax,cmin,wp,wn,tmax,tmin):
    v=1000
    t=1000
    w=1000
    if(abs(cmax)>=abs(cmin)):
        v=cmax
        t=tmax
        w=wp
    else:
        v=cmin
        t=tmin
        w=wn
    return v,w,t



def selectlink():
    path='/home/meng/bak_bupt/newproj/data/'
    m = Basemap(projection='ortho',lat_0=-90,lon_0=180,resolution='l')

    datalink=np.loadtxt(path+'1980_1_ICET_links_40y_tau20_8040.dat')
    datas=np.loadtxt(path+'ICET_40y_tau20_8040_linkcut.dat')
    N=8040
    regrid=np.loadtxt(path+'regridcos2.5d_global.dat')  
    
    x=np.reshape(datalink[:,10],(N,377))
    xa=np.reshape(abs(datalink[:,10]),(N,377))
    da=[np.mean(xa[i]) for i in range(8040)]     
    t=np.reshape(datalink[:,12],(N,377))
    
    
    xs=np.reshape(datas[:,0],(N,377))
    xas=np.reshape(abs(datas[:,0]),(N,377))
    das=[np.mean(xas[i]) for i in range(8040)]           
       
    datad=np.loadtxt(path+'ICET_degrees_40y_tau20_8040.dat')   
    degree=datad[:,0]
    cut=np.percentile(degree, 95)
    xx=np.where(degree>cut)[0]
    outfile=open(path+'links.dat','w')
    for i in xx:
        c=x[i,:]
        cs=xs[i,:]
        for j in range(100):
            if(abs(c[j])>cs[j] and regrid[:,1][i]<60):
                    lat=regrid[:,1][i]
                    lon=regrid[:,2][i]
               # print (lat,lon)
              #  if(m.is_land(lat,lon) is True):
                    print (i,j,c[j])
                    outfile.write('%d %d %.6f %d %.1f %.1f\n'%(i,j,c[j],t[i,j],regrid[:,1][i],regrid[:,2][i]))
                    outfile.flush()
    outfile.close()
        
    

def readdata():
    tmp0=np.loadtxt('/home/meng/bak_bupt/newproj/data/era5t8502.5g_ano_1979to2019.ano')
    tmp1=np.loadtxt('/home/meng/bak_bupt/newproj/data/era5t85075d_ano_1979to2019_g_new_377.ano')
    tmpice=np.loadtxt('/home/meng/bak_bupt/newproj/data/era5ice2.5d_ano_1979to2019_nonzero.ano')#original path='/home/meng/CLUSTER_DATA/CODE/Python/arctic/DATA/'


    t2xx=np.reshape(tmp0,(8040,14965))
    t1xx=np.reshape(tmp1,(377,15695))
    tixx=np.reshape(tmpice,(377,14965))

    monthds=[0,31,59,90,120,151,181,212,243,273,304,334,365]
    months=[31,28,31,30,31,30,31,31,30,31,30,31]
    
    regrid=np.loadtxt('/home/meng/bak_bupt/newproj/data/regridcos2.5d_global.dat')
    lats=regrid[:,1]
    lons=regrid[:,2]
    #regridi0=np.loadtxt(path+'regridcos2.5d.dat')
    regridi=np.loadtxt('/home/meng/bak_bupt/newproj/data/nonzeroicenodes.dat')
    path='/home/meng/bak_bupt/newproj/data/'
    nodes=np.loadtxt(path+'globe_726_new.dat')

def  global_Ta():    
   
    months=[31,28,31,30,31,30,31,31,30,31,30,31]
    ni=79
    nt=2262
    DATA = Dataset(path+"temperature_850hPa.nc",'r',format='NETCDF4')
    air_data=DATA.variables['t'][:]
    fileout=open(path+"era5t85075d_ano_1979to2019_g_new_"+str(ni)+"_"+str(nt)+"_726.ano",'w')      
    outfile=open(path+"lat_lon_"+str(ni)+"_"+str(nt)+"_726",'w')
    YEAR_NUMBER2=63
    YEAR_NUMBER1=5
    data_del_idx = 31+29-1
    taux=4
    
    latx=DATA.variables['latitude'][:]
    lonx=DATA.variables['longitude'][:]
    regrid=np.loadtxt(path+'regridcos2.5d_global.dat')

    
    regridi=np.loadtxt('/home/meng/bak_bupt/newproj/data/nonzeroicenodes.dat')

    for kk in range(1):
            lati=regridi[:,1][ni]
            loni=regridi[:,2][ni]
            if(loni>=180):
                lona=loni-360
            else:
                lona=loni
            print (lati,loni,lona)
            i=int(list(latx).index(lati))
            j=int(list(lonx).index(lona))
            
           ## outfile.flush()
            data1 = np.zeros(YEAR_NUMBER2*365)
            n=0         
            days=0
            for year in range(1959,2022):
                
                if(year%4==0 and year%100!=0) or (year%400==0):
                    months[1]=29
                    d=366
                else:
                    months[1]=28
                    d=365

               
                days+=d
                s1=days-d
                s2=days
                data=air_data[s1:s2,i,j]
                if(d==366):
                    data=np.delete(data,data_del_idx) # del the data of feb 29th
                for x in data:
                    n+=1
                    data1[n-1]=x

    

            data1 = np.reshape(data1,(YEAR_NUMBER2,365))
            DAY =365
            for year in range(20,YEAR_NUMBER2):                
                    for day in range(DAY):
                        day_x = data1[:,day][20:YEAR_NUMBER2]
                        day_ave=np.average(day_x)
                        day_std = np.std(day_x)
                        fileout.write('%.6f\n' % ((data1[year][day] - day_ave)/day_std))
               
            lati=regrid[:,1][nt]
            loni=regrid[:,2][nt]
            if(loni>=180):
                lona=loni-360
            else:
                lona=loni
            print (lati,loni,lona)
            i=int(list(latx).index(lati))
            j=int(list(lonx).index(lona))
            outfile.write('%.1f %.1f \n'%(lati,lona))
            outfile.flush()            
           
            data1 = np.zeros(YEAR_NUMBER2*365)
            n=0         
            days=0
            for year in range(1959,2022):
                
                if(year%4==0 and year%100!=0) or (year%400==0):
                    months[1]=29
                    d=366
                else:
                    months[1]=28
                    d=365

               
                days+=d
                s1=days-d
                s2=days
                data=air_data[s1:s2,i,j]
                if(d==366):
                    data=np.delete(data,data_del_idx) # del the data of feb 29th
                for x in data:
                    n+=1
                    data1[n-1]=x

    

            data1 = np.reshape(data1,(YEAR_NUMBER2,365))
            DAY =365
            for year in range(20,YEAR_NUMBER2):                
                    for day in range(DAY):
                        day_x = data1[:,day][20:YEAR_NUMBER2]
                        day_ave=np.average(day_x)
                        day_std = np.std(day_x)
                        fileout.write('%.6f\n' % ((data1[year][day] - day_ave)/day_std))
                        
    # temp=np.loadtxt(path+'era5t850_726.ano')
    
    # for i in range(len(temp)):
    #     fileout.write('%.6f \n'%(temp[i]))
    #     fileout.flush()
    # fileout.close()
    
    nodes=np.loadtxt(path+'globe_726_new.dat')
    for kk in range(len(nodes)):
            print (kk)
            i=int(nodes[:,3][kk])
            j=int(nodes[:,4][kk])
            outfile.write('%.1f %.1f \n'%(nodes[:,1][kk],nodes[:,2][kk]))
            outfile.flush()
            data1 = np.zeros(YEAR_NUMBER2*365)
            n=0         
            days=0
            for year in range(1959,2022):
                
                if(year%4==0 and year%100!=0) or (year%400==0):
                    months[1]=29
                    d=366
                else:
                    months[1]=28
                    d=365

               
                days+=d
                s1=days-d
                s2=days
                data=air_data[s1:s2,i,j]
                if(d==366):
                    data=np.delete(data,data_del_idx) # del the data of feb 29th
                for x in data:
                    n+=1
                    data1[n-1]=x

    

            data1 = np.reshape(data1,(YEAR_NUMBER2,365))
            DAY =365
            for year in range(20,YEAR_NUMBER2):                
                    for day in range(DAY):
                        day_x = data1[:,day][20:YEAR_NUMBER2]
                        day_ave=np.average(day_x)
                        day_std = np.std(day_x)
                        fileout.write('%.6f\n' % ((data1[year][day] - day_ave)/day_std))
               
    fileout.close()    
    outfile.close()
def lat_lon():
    path='/home/meng/bak_bupt/newproj/data/'
    regrida=np.loadtxt(path+'globe_726_new.dat')
    regrid=np.loadtxt(path+'regridcos2.5d_global.dat')
    regridi=np.loadtxt('/home/meng/bak_bupt/newproj/data/nonzeroicenodes.dat')

    ni=79
    nt=2262
    outfile=open(path+"lat_lon_"+str(ni)+"_"+str(nt)+"",'w')

    lati=regridi[:,1][ni]
    loni=regridi[:,2][ni]
    if(loni>=180):
        lona=loni-360
    else:
        lona=loni
    outfile.write('%.1f %.1f \n'%(lati,lona))
    outfile.flush()

    lati=regrid[:,1][nt]
    loni=regrid[:,2][nt]
    if(loni>=180):
        lona=loni-360
    else:
        lona=loni
    outfile.write('%.1f %.1f \n'%(lati,lona))
    outfile.flush()  
    
    for i in range(726):
            outfile.write('%.1f %.1f \n'%(regrida[:,1][i],regrida[:,2][i]))
            outfile.flush()    
    outfile.close()

def pathmining():
    ni=77
    nt=2262
    address = "/home/meng/bak_bupt/newproj/data/lat_lon_"+str(ni)+"_"+str(nt)+""
    lattic = np.loadtxt(address)
    
    
    #draw dots distribution
    fig = plt.figure(figsize=(16, 9))
    ax = fig.add_subplot(1, 1, 1, projection=ccrs.Robinson(central_longitude=-180))
    ax.set_global()
    ax.stock_img()
   # ax.coastlines()
    
    x, y = (lattic[:,1], lattic[:,0])
    
    
    #x,y=(32.5,-110)
    ax.scatter(x,y,s=100,c='black',marker = '.',alpha = 1,transform=ccrs.PlateCarree())
    
    plt.show()
    plt.close()
    
    #-----------------------------------------------------------------#
    #calculate distance
    N = len(lattic)
    distance_matrix = np.zeros((N,N))
    for i in range(0,N,1):
        for j in range(0,N,1):
            distance_matrix[i][j] = geodesic((lattic[i,0], lattic[i,1]), (lattic[j,0], lattic[j,1])).km
    
        

    begining_point,ending_point = (1,0)
    
    #address = "/home/meng/bak_bupt/newproj/data/1980_1_TT_links_f20y_tau20_83_2030_726.dat"
    #address = "/home/meng/bak_bupt/newproj/data/2000_1_TT_links_l20y_tau20_77_2262_726.dat"
    #address = "/home/meng/bak_bupt/newproj/data/1980_1_TT_links_f20y_tau20_77_2262_726.dat"

    #address = "/home/meng/bak_bupt/newproj/data/2010_1_TT_links_10y_tau20_77_2262_726.dat"
   # address = "/home/meng/bak_bupt/newproj/data/2010_1_TT_links_10y_tau20_83_2030_726.dat"
    #address = "/home/meng/bak_bupt/newproj/data/2019_3_TT_links_tau20_4_2030_726.dat"
    # address = "/home/meng/bak_bupt/newproj/data/2000_1_TT_links_tau20_4_2030_726.dat"
    # address = "/home/meng/bak_bupt/newproj/data/2015_1_TT_links_tau20_4_2030_726.dat"

    # address = "/home/meng/bak_bupt/newproj/data/1980_1_TT_links_40y_tau20_4_2030_726.dat"
    address="/home/meng/bak_bupt/newproj/data/2000_11_TT_links_tau20_77_2262_726.dat"    
    data = np.loadtxt(address)
    
    distance_max = 1500
    DG = nx.DiGraph()
    for i in range(0,N,1):
        DG.add_node(i)
    
    for rr in data:
        i,j,Wpos,Wneg, Tmax, Tmin, Tabs,lag0, Cmax, Cmin,Cabs,Wabs,Tabs_ = rr
        i,j = int(i),int(j)
        
        # if (distance_matrix[i,j]<distance_max):
        #     if (Tabs>0):
        #         DG.add_weighted_edges_from([(j,i,abs(1/max(abs(Wpos),abs(Wneg))))])
        #     else:
        #         if (Tabs<0):
        #             DG.add_weighted_edges_from([(i,j,abs(1/max(abs(Wpos),abs(Wneg))))])
        if (distance_matrix[i,j]<=distance_max):
                
            if (Tabs>0):
                    DG.add_weighted_edges_from([(j,i,abs(1/Cabs))])
            else:
                #if (Tabs<0):
                    DG.add_weighted_edges_from([(i,j,abs(1/Cabs))])
            # if (Tabs>0):
            #         DG.add_weighted_edges_from([(j,i,abs(1/Cabs))])
            # else:
            #         DG.add_weighted_edges_from([(i,j,abs(1/Cabs))])

    
    path = nx.dijkstra_path(DG, begining_point,ending_point)

    outfile=open("/home/meng/bak_bupt/newproj/data/path/path_40y_1000km_"+str(ni)+"_"+str(nt)+"tice_201903",'w')
    for i in path:
        outfile.write('%d \n'%(i))
        outfile.flush()
    outfile.close()      
           
    plt.figure(figsize=(16,9))
    m = Basemap(projection='npstere',boundinglat=-5,lon_0=180,resolution='l')
    
    m.shadedrelief(scale = 0.3)
    m.drawcoastlines(linewidth = 0.5)
    m.drawmeridians(np.arange(-180, 180, 45),dashes=[5, 5],labels=[1,0,0,1],color='#666b6c',linewidth=0.8,size=20,family = 'Arial',zorder=1)
    m.drawparallels(np.arange(-90, 90.001, 20),dashes=[5, 5],labels=[1,0,0,1],color='#666b6c',linewidth=0.8,size=20,family = 'Arial',zorder=1)
    
    x_p = []
    y_p = []
    for i in path:   
        x,y = (lattic[i,1],lattic[i,0])
        if x>180:
            x = x-360
        x,y = m(x,y)
        x_p.append(x)
        y_p.append(y)
    m.plot(x_p,y_p,'--',linewidth=2.8,color='#a64036',alpha = 0.6,label='Part1',zorder=4)
    for i in range(0,len(x_p),1):
        m.plot(x_p[i],y_p[i], marker = 'o', color='#a64036',markersize = 7.5,zorder=4)
    m.plot(x_p[0],y_p[0], marker = 'o', color='#a64036',markersize =12,zorder=4)
    m.plot(x_p[-1],y_p[-1], marker = 'o', color='#a64036',markersize = 12,zorder=4)


    plt.show()
    plt.close()


   

    wind_data = Dataset('/home/meng/bak_bupt/newproj/data/2019_3_15_500hpa_850hpa_wind.nc','r',format='NETCDF4')
    #V_data = Dataset('/home/jingfang/CLUSTER_DATA/data/NCEP1/Pressure_Levels_Wind/20140812V.nc','r',format='NETCDF4')
    level1=0
    DAY=0
    res=1
    uwnd=wind_data.variables['u'][DAY,level1,][::res,::res]
    vwnd=wind_data.variables['v'][DAY,level1,][::res,::res]
    hwnd=wind_data.variables['w'][DAY,level1,][::res,::res]
    
    
    lonX  =wind_data.variables['longitude'][:][::res]
    lat  =wind_data.variables['latitude'][:][::res]   
    speed=np.sqrt(vwnd*vwnd+uwnd*uwnd)*3.6    

    h=15000
   
    m = Basemap(projection='nsper',lon_0=280,lat_0=65,satellite_height=h*1000.,resolution='l')
  
    m.drawcoastlines(linewidth = 1,color='k')
    m.drawmeridians(np.arange(-180, 180, 60),dashes=[5, 5],labels=[1,0,0,1],color='gray',linewidth=0.8,size=32,family = 'Arial',zorder=1)
    m.drawparallels(np.arange(-90, 90.001, 30),dashes=[5, 5],labels=[1,0,0,1],color='gray',linewidth=0.8,size=32,family = 'Arial',zorder=1)
 

    speed, lon = shiftgrid(180, speed, lonX, start=False) 
    uwnd, lon1 = shiftgrid(180, uwnd, lonX, start=False) 
    vwnd, lon2 = shiftgrid(180, vwnd, lonX, start=False) 

    lon2d, lat2d = np.meshgrid(lon, lat)
    
    x, y = m(lon2d, lat2d)
    z=speed
   
    a=0
    b=220
    # a=-1
    # b=1
    
    levels1 = np.linspace(a,b,21)

    cs = m.contourf(x, y, z,extend='both',levels= levels1,cmap=plt.cm.YlGnBu_r)
   
    
    cbar = plt.colorbar(cs, orientation='horizontal',shrink=0.5,pad=0.05)
    label_1 =  np.linspace( a, b, 6)
    cbar.set_ticks(label_1)
    cbar.ax.tick_params(labelsize=30)
    cbar.ax.set_xlabel('Wind 850hPa(km/h)',fontsize=30)
    DAY=0
    res=2    
    res=30
    uwnd=wind_data.variables['u'][DAY,level1,][::res,::res]
    vwnd=wind_data.variables['v'][DAY,level1,][::res,::res]
    hwnd=wind_data.variables['w'][DAY,level1,][::res,::res]
    
    lonX  =wind_data.variables['longitude'][:][::res]
    lat  =wind_data.variables['latitude'][:][::res]   
    speed=np.sqrt(vwnd*vwnd+uwnd*uwnd)*3.6        
    speed, lon = shiftgrid(180, speed, lonX, start=False) 
    uwnd, lon1 = shiftgrid(180, uwnd, lonX, start=False) 
    vwnd, lon2 = shiftgrid(180, vwnd, lonX, start=False) 

    lon2d, lat2d = np.meshgrid(lon, lat)
    urot,vrot,x,y = m.rotate_vector(uwnd,vwnd,lon2d,lat2d,returnxy=True)
    Q=m.quiver(x,y,urot,vrot,color='w',pivot='tail', units='inches', width=0.04, headwidth=8., headlength=9.) #or specify, e.g., width=0.003, scale=400)
    figure = plt.gcf() # get current figure
       

    path=np.loadtxt("/home/meng/bak_bupt/newproj/data/path/path_2019_3_1000km_"+str(ni)+"_"+str(nt)+"tice")
    
    address = '/home/meng/bak_bupt/newproj/data/lat_lon_10_2030'
    
    
    lattic = np.loadtxt(address)        
    x_p = []
    y_p = []
    for i in path:   
        i=int(i)
        x,y = (lattic[i,1],lattic[i,0])
        if x>180:
            x = x-360
        x,y = m(x,y)
        x_p.append(x)
        y_p.append(y)
    m.plot(x_p,y_p,'--',linewidth=5,color='orange',alpha = 0.9,label='Part1',zorder=4)
    for i in range(0,len(x_p),1):
        m.plot(x_p[i],y_p[i], marker = 'o', color='orange',markersize = 10,zorder=4)

    
    plt.annotate('', xy=(x_p[8],y_p[8]), xycoords='data',
            xytext=(x_p[7], y_p[7]), textcoords='data',
                        size=6,
                         ha='center', va='bottom',color='#a64036',
                 
            arrowprops=dict(arrowstyle="fancy,head_width=5,head_length=5",lw=4,fc="orange",ec="orange",
                                        connectionstyle="arc3,rad=-0.1",alpha=1.0),)


    path=np.loadtxt("/home/meng/bak_bupt/newproj/data/path/path_2019_3_1000km_"+str(ni)+"_"+str(nt)+"icet")
    
    address = '/home/meng/bak_bupt/newproj/data/lat_lon_10_2030'
    
    
    lattic = np.loadtxt(address)        
    x_p = []
    y_p = []
    for i in path:   
        i=int(i)
        x,y = (lattic[i,1],lattic[i,0])
        if x>180:
            x = x-360
        x,y = m(x,y)
        x_p.append(x)
        y_p.append(y)
    m.plot(x_p,y_p,'--',linewidth=5,color='yellow',alpha = 0.9,label='Part1',zorder=4)
    for i in range(0,len(x_p),1):
        m.plot(x_p[i],y_p[i], marker = 'o', color='yellow',markersize = 10,zorder=4)

    
    plt.annotate('', xy=(x_p[4],y_p[4]), xycoords='data',
            xytext=(x_p[3], y_p[3]), textcoords='data',
                        size=6,
                         ha='center', va='bottom',color='#a64036',
                 
            arrowprops=dict(arrowstyle="fancy,head_width=5,head_length=5",lw=4,fc="orange",ec="orange",
                                        connectionstyle="arc3,rad=-0.1",alpha=1.0),)


    figure = plt.gcf() # get current figure
                # 
    figure.set_size_inches(35, 30)        




        
    plt.figure(figsize=(16,9))
    m = Basemap(projection='robin', lon_0=0)
    m.shadedrelief(scale = 0.5)
    m.drawcoastlines(linewidth = 0.5)
    m.drawmeridians(np.arange(-180, 180, 60),dashes=[5, 5],labels=[1,0,0,1],color='#666b6c',linewidth=0.8,alpha=0.8,size=20,family = 'Arial',zorder=1)
    m.drawparallels(np.arange(-90, 90.001, 30),dashes=[5, 5],labels=[1,0,0,1],color='#666b6c',linewidth=0.8,alpha=0.8,size=20,family = 'Arial',zorder=1)
    
    x_p = []
    y_p = []
    for i in path:
        x,y = m(lattic[i,1],lattic[i,0])
        x_p.append(x)
        y_p.append(y)
    m.plot(x_p,y_p,'--',linewidth=2.8,color='red',alpha = 0.9,zorder=4)
    for i in range(0,len(x_p),1):
        m.plot(x_p[i],y_p[i], marker = 'o', color='red',markersize = 7.5,zorder=4)
    
    m.plot(x_p[-1],y_p[-1], marker = 'o', color='red',markersize = 12,zorder=4)
        
    start = m(lattic[begining_point,1],lattic[begining_point,0])
    end = m(lattic[ending_point,1],lattic[ending_point,0])
    
    
    dx = end[0]-start[0]
    dy = end[1]-start[1]
    m.quiver(start[0],start[1],dx,dy,ls='--',width=0.003,scale=1,scale_units ='xy',alpha=0.5,headwidth=10,headlength=15,headaxislength=10,color='black',zorder=4)
    
    plt.title(r'$year='+str(year)+'$',fontsize=15,family = 'Arial')
    
    plt.show()
    plt.close()    
    
      
    
def correlations():
    tmp0=np.loadtxt('/home/meng/bak_bupt/newproj/data/era5t8502.5g_ano_1979to2019.ano')
    tmp1=np.loadtxt('/home/meng/bak_bupt/newproj/data/era5t85075d_ano_1979to2019_g_new_377.ano')
    tmpice=np.loadtxt('/home/meng/bak_bupt/newproj/data/era5ice2.5d_ano_1979to2019_nonzero.ano')#original path='/home/meng/CLUSTER_DATA/CODE/Python/arctic/DATA/'

    t2xx=np.reshape(tmp0,(8040,14965))
    t1xx=np.reshape(tmp1,(377,15695))
    tixx=np.reshape(tmpice,(377,14965))

    monthds=[0,31,59,90,120,151,181,212,243,273,304,334,365]
    months=[31,28,31,30,31,30,31,31,30,31,30,31]
    
    regrid=np.loadtxt('/home/meng/bak_bupt/newproj/data/regridcos2.5d_global.dat')
    lats=regrid[:,1]
    lons=regrid[:,2]
    #regridi0=np.loadtxt(path+'regridcos2.5d.dat')
    regridi=np.loadtxt('/home/meng/bak_bupt/newproj/data/nonzeroicenodes.dat')
    
    
  
    year=2009
    month=5
    
   
    
    ni=83#94
    nt=2030
    
    ni=40
    nt=2555
    
    ni=77
    nt=2262
    
    ni=43
    nt=3820
    
    
    ni=7
    nt=2176
    
    ni=43
    nt=4646
    
    ni=77
    nt=2262
    
    ni=83
    nt=2030
    
    
    ni=4
    nt=2030
    
    datas=np.loadtxt('/home/meng/bak_bupt/newproj/data/ICET_30d_tau20_8040_linkcut.dat')    
    cutx=np.reshape(datas[:,0],(8040,377))
    cut=cutx[nt,ni]
  
    
NN=0 
ii=0

for year in range(1980,2020):
  for month in range(1,13):
    
    T1=t1xx[ni]
    T2=t2xx[nt]
    I1=tixx[ni]
           
          
    ss1=365*(year-1979)+monthds[month-1]
    ss2=ss1+30
    s1=ss1
    s2=ss2
    ICE1T2=[]
    ICE1T1=[]
    T1T2=[]
    taus=[]
    for tau in range(20,-1,-1):
                taus.append(-tau)
                t1=T1[s1:s2]
                t2=T2[s1:s2]
                i1=I1[s1-tau:s2-tau]
                # i1=signal.detrend(i1)
                # t1=signal.detrend(t1)
                # t2=signal.detrend(t2)
                ICE1T1.append(pearsonr(i1,t1)[0])
                ICE1T2.append(pearsonr(i1,t2)[0])
                tt1=T1[s1-tau:s2-tau]
                T1T2.append(pearsonr(tt1,t2)[0])
               #print (pearsonr(i1,t2)[0],tau)
    for tau in range(1,21):
                taus.append(tau)
                t1=T1[s1-tau:s2-tau]
                t2=T2[s1-tau:s2-tau]
                i1=I1[s1:s2]
                # i1=signal.detrend(i1)
                # t1=signal.detrend(t1)
                # t2=signal.detrend(t2)
                ICE1T1.append(pearsonr(i1,t1)[0])
                ICE1T2.append(pearsonr(i1,t2)[0])
                tt1=T1[s1:s2]
                T1T2.append(pearsonr(tt1,t2)[0])
                
    cmax11,cmin11,wp11,wn11,tmax11,tmin11,cabs11,wabs11,tabs11=link(ICE1T1)
    cmax12,cmin12,wp12,wn12,tmax12,tmin12,cabs12,wabs12,tabs12=link(ICE1T2)
    Tcmax12,Tcmin12,Twp12,Twn12,Ttmax12,Ttmin12,Tcabs12,Twabs12,Ttabs12=link(T1T2)
    ii+=1
    # if(abs(cabs12)>0.77):
    #     print (year,month,cabs12,cabs11,Tcabs12,tabs12,tabs11,Ttabs12)
    #     NN+=1
 
    
    if(abs(cabs12)>cut and abs(Tcabs12)>0.6 and -15<tabs12<15 and -15<Ttabs12<15):
        print (year,month)
        print (ni,cabs11,cabs12,Tcabs12,tabs11,tabs12,Ttabs12)    
       

    plt.plot(ICE1T1)
    plt.plot(ICE1T2,'r')
    plt.plot(T1T2)
    
    ICE1=I1[s1+8:s2+8]
    TT1=T1[s1-13:s2-13]
    TT2=T2[s1:s2]
 
   
 
    ii1=ICE1/np.std(ICE1)
    tt1=TT1/np.std(TT1)
    tt2=TT2/np.std(TT2)
    # ii1=signal.detrend(ii1)
    # tt1=signal.detrend(tt1)
    # tt2=signal.detrend(tt2)
    # plt.plot(ii1,'b--',linewidth=5,label='$ICE_i$, Mar 4-Apr 3, 2019')
    # plt.plot(tt1,'c',linewidth=5,label='$T_i$, Mar 1-Mar 30, 2019')
    # plt.plot(tt2,'r',linewidth=5,label='$T_j$, Feb 26-Mar 27, 2019')
    plt.plot(ii1,'b--',linewidth=5,label='$ICE_i$, Mar 1-Mar30, 2019')
    plt.plot(tt1,'c',linewidth=5,label='$T_i$, Mar 1-Mar 30, 2019')
    plt.plot(tt2,'r',linewidth=5,label='$T_j$, Mar 1-Mar30, 2019')
        
    
    
    ni=77
    nt=2262
    address = "/home/meng/bak_bupt/newproj/data/lat_lon_"+str(ni)+"_"+str(nt)+""
    lattic = np.loadtxt(address)
    
    
    #draw dots distribution
    fig = plt.figure(figsize=(16, 9))
    ax = fig.add_subplot(1, 1, 1, projection=ccrs.Robinson(central_longitude=-180))
    ax.set_global()
    ax.stock_img()
   # ax.coastlines()
    
    x, y = (lattic[:,1], lattic[:,0])
    
    
    #x,y=(32.5,-110)
    ax.scatter(x,y,s=100,c='black',marker = '.',alpha = 1,transform=ccrs.PlateCarree())
    
    plt.show()
    plt.close()
    
    #-----------------------------------------------------------------#
    #calculate distance
    N = len(lattic)
    distance_matrix = np.zeros((N,N))
    for i in range(0,N,1):
        for j in range(0,N,1):
            distance_matrix[i][j] = geodesic((lattic[i,0], lattic[i,1]), (lattic[j,0], lattic[j,1])).km
    
        

   # begining_point,ending_point = (1,0)
    
    #address = "/home/meng/bak_bupt/newproj/data/1980_1_TT_links_f20y_tau20_83_2030_726.dat"
    #address = "/home/meng/bak_bupt/newproj/data/2000_1_TT_links_l20y_tau20_77_2262_726.dat"
    #address = "/home/meng/bak_bupt/newproj/data/1980_1_TT_links_f20y_tau20_77_2262_726.dat"

    #address = "/home/meng/bak_bupt/newproj/data/2010_1_TT_links_10y_tau20_77_2262_726.dat"
   # address = "/home/meng/bak_bupt/newproj/data/2010_1_TT_links_10y_tau20_83_2030_726.dat"
    #address = "/home/meng/bak_bupt/newproj/data/2019_3_TT_links_tau20_4_2030_726.dat"
    # address = "/home/meng/bak_bupt/newproj/data/2000_1_TT_links_tau20_4_2030_726.dat"
    # address = "/home/meng/bak_bupt/newproj/data/2015_1_TT_links_tau20_4_2030_726.dat"

    # address = "/home/meng/bak_bupt/newproj/data/1980_1_TT_links_40y_tau20_4_2030_726.dat"
    address="/home/meng/bak_bupt/newproj/data/2011_10_TT_links_tau20_77_2262_726.dat"    
    data = np.loadtxt(address)
    
    distance_max = 1000
    DG = nx.DiGraph()
    for i in range(0,N,1):
        DG.add_node(i)
    
    for rr in data:
        i,j,Wpos,Wneg, Tmax, Tmin, Tabs,lag0, Cmax, Cmin,Cabs,Wabs,Tabs_ = rr
        i,j = int(i),int(j)

        if (distance_matrix[i,j]<=distance_max):
                
            if (Tabs>0):
                    DG.add_weighted_edges_from([(j,i,abs(1/Cabs))])
            if (Tabs<=0):
                    DG.add_weighted_edges_from([(i,j,abs(1/Cabs))])
                    
                    
            
    begining_point,ending_point = (1,0)
    
    path = nx.dijkstra_path(DG, begining_point,ending_point)

    begining_point,ending_point = (0,1)
    
    patha = nx.dijkstra_path(DG, begining_point,ending_point)

   
    plt.figure(figsize=(16,9))
    m = Basemap(projection='npstere',boundinglat=-5,lon_0=180,resolution='l')
    
    m.shadedrelief(scale = 0.3)
    m.drawcoastlines(linewidth = 0.5)
    m.drawmeridians(np.arange(-180, 180, 45),dashes=[5, 5],labels=[1,0,0,1],color='#666b6c',linewidth=0.8,size=20,family = 'Arial',zorder=1)
    m.drawparallels(np.arange(-90, 90.001, 20),dashes=[5, 5],labels=[1,0,0,1],color='#666b6c',linewidth=0.8,size=20,family = 'Arial',zorder=1)
    
    x_p = []
    y_p = []
    for i in path:   
        x,y = (lattic[i,1],lattic[i,0])
        if x>180:
            x = x-360
        x,y = m(x,y)
        x_p.append(x)
        y_p.append(y)
    m.plot(x_p,y_p,'--',linewidth=2.8,color='#a64036',alpha = 0.6,label='Part1',zorder=4)
    for i in range(0,len(x_p),1):
        m.plot(x_p[i],y_p[i], marker = 'o', color='#a64036',markersize = 7.5,zorder=4)

    x_p = []
    y_p = []
    for i in patha:   
        x,y = (lattic[i,1],lattic[i,0])
        if x>180:
            x = x-360
        x,y = m(x,y)
        x_p.append(x)
        y_p.append(y)
    m.plot(x_p,y_p,'--',linewidth=2.8,color='b',alpha = 0.6,label='Part1',zorder=4)
    for i in range(0,len(x_p),1):
        m.plot(x_p[i],y_p[i], marker = 'o', color='b',markersize = 7.5,zorder=4)
   

    m.plot(x_p[0],y_p[0], marker = 'o', color='#a64036',markersize =12,zorder=4)
    m.plot(x_p[-1],y_p[-1], marker = 'o', color='#a64036',markersize = 12,zorder=4)


    plt.show()
    plt.close()

    
    outfile=open("/home/meng/bak_bupt/newproj/data/path/4_2030/path_40y_1000km_"+str(ni)+"_"+str(nt)+"tice_201110",'w')
    for i in path:
        outfile.write('%d \n'%(i))
        outfile.flush()
    outfile.close()      
               
    
    outfile=open("/home/meng/bak_bupt/newproj/data/path/4_2030/path_40y_1000km_"+str(ni)+"_"+str(nt)+"icet_201110",'w')
    for i in patha:
        outfile.write('%d \n'%(i))
        outfile.flush()
    outfile.close()      
    
    
    
    ax1 = plt.subplot(111)
    wind_data = Dataset('/home/meng/bak_bupt/newproj/data/2002_9_3_500hpa_850hpa_wind.nc','r',format='NETCDF4')
    
    #V_data = Dataset('/home/jingfang/CLUSTER_DATA/data/NCEP1/Pressure_Levels_Wind/20140812V.nc','r',format='NETCDF4')
    level1=0
    DAY=0
    res=1
    uwnd=wind_data.variables['u'][DAY,level1,][::res,::res]
    vwnd=wind_data.variables['v'][DAY,level1,][::res,::res]
    hwnd=wind_data.variables['w'][DAY,level1,][::res,::res]
    
    
    lonX  =wind_data.variables['longitude'][:][::res]
    lat  =wind_data.variables['latitude'][:][::res]   
    speed=np.sqrt(vwnd*vwnd+uwnd*uwnd)*3.6    

    h=15000
   
    m = Basemap(projection='nsper',lon_0=155,lat_0=55,satellite_height=h*1000.,resolution='l')
  
    m.drawcoastlines(linewidth = 1,color='k')
    m.drawmeridians(np.arange(-180, 180, 60),dashes=[5, 5],labels=[1,0,0,1],color='gray',linewidth=0.8,size=32,family = 'Arial',zorder=1)
    m.drawparallels(np.arange(-90, 90.001, 30),dashes=[5, 5],labels=[1,0,0,1],color='gray',linewidth=0.8,size=32,family = 'Arial',zorder=1)
 

    speed, lon = shiftgrid(180, speed, lonX, start=False) 
    uwnd, lon1 = shiftgrid(180, uwnd, lonX, start=False) 
    vwnd, lon2 = shiftgrid(180, vwnd, lonX, start=False) 

    lon2d, lat2d = np.meshgrid(lon, lat)
    
    x, y = m(lon2d, lat2d)
    z=speed
    
    a=0
    b=240
    # a=-1
    # b=1
    
    levels1 = np.linspace(a,b,21)

    cs = m.contourf(x, y, z,extend='both',levels= levels1,cmap=plt.cm.YlGnBu_r)
   
    
    cbar = plt.colorbar(cs, orientation='horizontal',shrink=0.5,pad=0.05)
    label_1 =  np.linspace( a, b, 6)
    cbar.set_ticks(label_1)
    cbar.ax.tick_params(labelsize=30)
    cbar.ax.set_xlabel('Wind 850hPa(km/h)',fontsize=30)
    DAY=0
    res=2    
    res=30
    uwnd=wind_data.variables['u'][DAY,level1,][::res,::res]
    vwnd=wind_data.variables['v'][DAY,level1,][::res,::res]
    hwnd=wind_data.variables['w'][DAY,level1,][::res,::res]
    
    lonX  =wind_data.variables['longitude'][:][::res]
    lat  =wind_data.variables['latitude'][:][::res]   
    speed=np.sqrt(vwnd*vwnd+uwnd*uwnd)*3.6        
    speed, lon = shiftgrid(180, speed, lonX, start=False) 
    uwnd, lon1 = shiftgrid(180, uwnd, lonX, start=False) 
    vwnd, lon2 = shiftgrid(180, vwnd, lonX, start=False) 

    lon2d, lat2d = np.meshgrid(lon, lat)
    urot,vrot,x,y = m.rotate_vector(uwnd,vwnd,lon2d,lat2d,returnxy=True)
    Q=m.quiver(x,y,urot,vrot,color='w',pivot='tail', units='inches', width=0.04, headwidth=8., headlength=9.) #or specify, e.g., width=0.003, scale=400)
    figure = plt.gcf() # get current figure
       

    path=np.loadtxt('/home/meng/bak_bupt/newproj/data/path/77_2262/path_40y_1000km_77_2262tice_200209')
    
    address = '/home/meng/bak_bupt/newproj/data/lat_lon_77_2262'
    
    
    lattic = np.loadtxt(address)        
    x_p = []
    y_p = []
    for i in path:   
        i=int(i)
        x,y = (lattic[i,1],lattic[i,0])
        if x>180:
            x = x-360
        x,y = m(x,y)
        x_p.append(x)
        y_p.append(y)
    m.plot(x_p,y_p,'--',linewidth=5,color='orange',alpha = 0.9,label='Part1',zorder=4)
    for i in range(0,len(x_p),1):
        m.plot(x_p[i],y_p[i], marker = 'o', color='orange',markersize = 10,zorder=4)

    
    plt.annotate('', xy=(x_p[8],y_p[8]), xycoords='data',
            xytext=(x_p[7], y_p[7]), textcoords='data',
                        size=6,
                         ha='center', va='bottom',color='#a64036',
                 
            arrowprops=dict(arrowstyle="fancy,head_width=5,head_length=5",lw=4,fc="orange",ec="orange",
                                        connectionstyle="arc3,rad=-0.1",alpha=1.0),)

    
    
    path=np.loadtxt('/home/meng/bak_bupt/newproj/data/path/77_2262/path_40y_1000km_77_2262icet_200209')
    
    address = '/home/meng/bak_bupt/newproj/data/lat_lon_88_2262'
    
    
    lattic = np.loadtxt(address)        
    x_p = []
    y_p = []
    for i in path:   
        i=int(i)
        x,y = (lattic[i,1],lattic[i,0])
        if x>180:
            x = x-360
        x,y = m(x,y)
        x_p.append(x)
        y_p.append(y)
    m.plot(x_p,y_p,'--',linewidth=5,color='#f7ff00',alpha = 0.9,label='Part1',zorder=4)
    for i in range(0,len(x_p),1):
        m.plot(x_p[i],y_p[i], marker = 'o', color='#f7ff00',markersize = 10,zorder=4)
    m.plot(x_p[0],y_p[0], marker = 'o', color='deeppink',markersize =15,zorder=4)
    m.plot(x_p[-1],y_p[-1], marker = 'o', color='deeppink',markersize = 15,zorder=4)
    #m.scatter(x_p[-1],y_p[-1], marker = 'o', color='#a64036',s = 12,zorder=4)
    #plt.title('($77.5^\circ N$, $160^\circ E$) ($30^\circ N$, $105^\circ E$)',fontsize=30)
    plt.title('December 2018',fontsize=30)    
    plt.annotate('', xy=(x_p[6],y_p[6]), xycoords='data',
            xytext=(x_p[5], y_p[5]), textcoords='data',
                        size=6,
                         ha='center', va='bottom',color='#a64036',
                 
            arrowprops=dict(arrowstyle="fancy,head_width=5,head_length=5",lw=4,fc="#f7ff00",ec="#f7ff00",
                                        connectionstyle="arc3,rad=-0.1",alpha=1.0),)
       
    
    
    
    plt.annotate('a', xy=(-0.15,1.05), xycoords='axes fraction', fontsize=38,weight='bold',
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom') 
        
    figure = plt.gcf() # get current figure
                # 
    figure.set_size_inches(35, 30)    
        
    
    
    ax1 = plt.subplot(231)
    wind_data = Dataset('/home/meng/bak_bupt/newproj/data/2010_2_9_500hpa_850hpa_wind.nc','r',format='NETCDF4')
    
    #V_data = Dataset('/home/jingfang/CLUSTER_DATA/data/NCEP1/Pressure_Levels_Wind/20140812V.nc','r',format='NETCDF4')
    level1=0
    DAY=0
    res=1
    uwnd=wind_data.variables['u'][DAY,level1,][::res,::res]
    vwnd=wind_data.variables['v'][DAY,level1,][::res,::res]
    hwnd=wind_data.variables['w'][DAY,level1,][::res,::res]
    
    
    lonX  =wind_data.variables['longitude'][:][::res]
    lat  =wind_data.variables['latitude'][:][::res]   
    speed=np.sqrt(vwnd*vwnd+uwnd*uwnd)*3.6    

    h=15000
   
    m = Basemap(projection='nsper',lon_0=135,lat_0=55,satellite_height=h*1000.,resolution='l')
  
    m.drawcoastlines(linewidth = 1,color='k')
    m.drawmeridians(np.arange(-180, 180, 60),dashes=[5, 5],labels=[1,0,0,1],color='gray',linewidth=0.8,size=32,family = 'Arial',zorder=1)
    m.drawparallels(np.arange(-90, 90.001, 30),dashes=[5, 5],labels=[1,0,0,1],color='gray',linewidth=0.8,size=32,family = 'Arial',zorder=1)
 

    speed, lon = shiftgrid(180, speed, lonX, start=False) 
    uwnd, lon1 = shiftgrid(180, uwnd, lonX, start=False) 
    vwnd, lon2 = shiftgrid(180, vwnd, lonX, start=False) 

    lon2d, lat2d = np.meshgrid(lon, lat)
    
    x, y = m(lon2d, lat2d)
    z=speed
    
    a=0
    b=240
    # a=-1
    # b=1
    
    levels1 = np.linspace(a,b,21)

    cs = m.contourf(x, y, z,extend='both',levels= levels1,cmap=plt.cm.YlGnBu_r)
   
    
    cbar = plt.colorbar(cs, orientation='horizontal',shrink=0.5,pad=0.05)
    label_1 =  np.linspace( a, b, 6)
    cbar.set_ticks(label_1)
    cbar.ax.tick_params(labelsize=30)
    cbar.ax.set_xlabel('Wind 850hPa(km/h)',fontsize=30)
    DAY=0
    res=2    
    res=30
    uwnd=wind_data.variables['u'][DAY,level1,][::res,::res]
    vwnd=wind_data.variables['v'][DAY,level1,][::res,::res]
    hwnd=wind_data.variables['w'][DAY,level1,][::res,::res]
    
    lonX  =wind_data.variables['longitude'][:][::res]
    lat  =wind_data.variables['latitude'][:][::res]   
    speed=np.sqrt(vwnd*vwnd+uwnd*uwnd)*3.6        
    speed, lon = shiftgrid(180, speed, lonX, start=False) 
    uwnd, lon1 = shiftgrid(180, uwnd, lonX, start=False) 
    vwnd, lon2 = shiftgrid(180, vwnd, lonX, start=False) 

    lon2d, lat2d = np.meshgrid(lon, lat)
    urot,vrot,x,y = m.rotate_vector(uwnd,vwnd,lon2d,lat2d,returnxy=True)
    Q=m.quiver(x,y,urot,vrot,color='w',pivot='tail', units='inches', width=0.04, headwidth=8., headlength=9.) #or specify, e.g., width=0.003, scale=400)
    figure = plt.gcf() # get current figure
       

    path=np.loadtxt('//home/meng/bak_bupt/newproj/data/path/path_2010_2_1000km_88_2662')
    
    address = '/home/meng/bak_bupt/newproj/data/lat_lon_77_2262'
    
    
    lattic = np.loadtxt(address)        
    x_p = []
    y_p = []
    for i in path:   
        i=int(i)
        x,y = (lattic[i,1],lattic[i,0])
        if x>180:
            x = x-360
        x,y = m(x,y)
        x_p.append(x)
        y_p.append(y)
    m.plot(x_p,y_p,'--',linewidth=5,color='orange',alpha = 0.9,label='Part1',zorder=4)
    for i in range(0,len(x_p),1):
        m.plot(x_p[i],y_p[i], marker = 'o', color='orange',markersize = 10,zorder=4)

    
    plt.annotate('', xy=(x_p[8],y_p[8]), xycoords='data',
            xytext=(x_p[7], y_p[7]), textcoords='data',
                        size=6,
                         ha='center', va='bottom',color='#a64036',
                 
            arrowprops=dict(arrowstyle="fancy,head_width=5,head_length=5",lw=4,fc="orange",ec="orange",
                                        connectionstyle="arc3,rad=-0.1",alpha=1.0),)

    
    
    path=np.loadtxt('//home/meng/bak_bupt/newproj/data/path/path_2010_2_1000km_88_2662icet')
    
    address = '/home/meng/bak_bupt/newproj/data/lat_lon_88_2262'
    
    
    lattic = np.loadtxt(address)        
    x_p = []
    y_p = []
    for i in path:   
        i=int(i)
        x,y = (lattic[i,1],lattic[i,0])
        if x>180:
            x = x-360
        x,y = m(x,y)
        x_p.append(x)
        y_p.append(y)
    m.plot(x_p,y_p,'--',linewidth=5,color='#f7ff00',alpha = 0.9,label='Part1',zorder=4)
    for i in range(0,len(x_p),1):
        m.plot(x_p[i],y_p[i], marker = 'o', color='#f7ff00',markersize = 10,zorder=4)
    m.plot(x_p[0],y_p[0], marker = 'o', color='deeppink',markersize =15,zorder=4)
    m.plot(x_p[-1],y_p[-1], marker = 'o', color='deeppink',markersize = 15,zorder=4)
    #m.scatter(x_p[-1],y_p[-1], marker = 'o', color='#a64036',s = 12,zorder=4)
    #plt.title('($77.5^\circ N$, $160^\circ E$) ($30^\circ N$, $105^\circ E$)',fontsize=30)
    plt.title('February 2010',fontsize=30)    
    plt.annotate('', xy=(x_p[6],y_p[6]), xycoords='data',
            xytext=(x_p[5], y_p[5]), textcoords='data',
                        size=6,
                         ha='center', va='bottom',color='#a64036',
                 
            arrowprops=dict(arrowstyle="fancy,head_width=5,head_length=5",lw=4,fc="#f7ff00",ec="#f7ff00",
                                        connectionstyle="arc3,rad=-0.1",alpha=1.0),)
       
    
    
    
    plt.annotate('a', xy=(-0.15,1.05), xycoords='axes fraction', fontsize=38,weight='bold',
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom') 
        
    figure = plt.gcf() # get current figure
                # 
    figure.set_size_inches(35, 30)    
        
    
    
    
    