#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Wed Oct 26 09:48:23 2022

@author: meng
"""
from scipy import signal
import numpy as np
from scipy.stats.stats import pearsonr
#from mpl_toolkits.basemap import Basemap, addcyclic, shiftgrid
from scipy import stats
import math
def circledis(lat1,lat2,lon1,lon2):
    r=6371#km
    lat1=lat1/180*np.pi
    lat2=lat2/180*np.pi
    lon1=lon1/180*np.pi
    lon2=lon2/180*np.pi
    a=np.arccos(np.sin(lat1)*np.sin(lat2)+np.cos(lat1)*np.cos(lat2)*np.cos(np.abs(lon1-lon2)))
    d=a*r
    return d


path='/public3/home/sc52351/mengjun/arctic/data/'
regrid1=np.loadtxt(path+'globe_726.dat')
regrid2=np.loadtxt(path+'nonzeroicenodes.dat')
x=np.intersect1d(regrid1[:,0], regrid2[:,0])
links=[]
ln=-1
for i in range(0,725):
    for j in range(i+1,726):
        ln+=1
        if(i in x or j in x):
            links.append(ln)
    

l=int(726*725*0.5)
cpx=np.zeros(shape=(l,480))
cnx=np.zeros(shape=(l,480))
tpx=np.zeros(shape=(l,480))
tnx=np.zeros(shape=(l,480))
l1=round(l*0.9)
l2=int(l*0.1)

cpx=np.zeros(l)
cnx=np.zeros(l)
cpox=np.zeros(l)
cpix=np.zeros(l)
cnox=np.zeros(l)
cnix=np.zeros(l)

regridi=np.loadtxt(path+'nonzeroicenodes.dat')
nodes=np.loadtxt(path+'globe_726.dat')
nx1=regridi[:,0]
nx2=nodes[:,0]
nx=np.intersect1d(nx1,nx2)
nodex=[list(nx1).index(i) for i in nx]
nodey=[list(nx2).index(i) for i in nx]
    
outfile=open(path+'siglink_tt_N.dat','w')
outfile1=open(path+'siglink_tt.dat','w')

for year in range(1980,2020):
    for mon in range(1,13):
        datai=np.loadtxt(path+"year/"+str(year)+"_"+str(mon)+"_ICET_links_30d_tau10.dat")
        datat=np.loadtxt(path+"year/"+str(year)+"_"+str(mon)+"_TT_links_30d_tau10.dat")
        cp=datat[:,8]
        cn=datat[:,9]
        tp=datat[:,4]
        tn=datat[:,5]
        n1=datat[:,0]
        n2=datat[:,1]
        
        cpi=datai[:,8]
        cni=datai[:,9]
        tpi=datai[:,4]
        tni=datai[:,5]
        n1i=datai[:,0]
        n2i=datai[:,1] 
        
        nodei1=0
        nodei2=19
        nodet1=0
        nodet2=6
        
        lxit1=np.where(n2i==nodei1)[0]
        lxit2=np.where(n2i==nodei2)[0]
        
        lxtt1=np.where(n2==nodet1)[0]
        lxtt2=np.where(n2==nodet2)[0]
        
  
       
        for l in range(7,726):
            cpi1=cpi[lxit1][l]
            cni1=cni[lxit1][l]
            cpi2=cpi[lxit2][l]
            cni2=cni[lxit2][l]

            cpt1=cp[lxtt1][l-1]
            cnt1=cn[lxtt1][l-1]
            cpt2=cp[lxtt2][l-7]
            cnt2=cn[lxtt2][l-7] 
            
            if(cni1<-0.7 and cpt1>0.7 and cni[lxit1][0]<-0.7):
                tni1=tni[lxit1][l]
                tpt1=tp[lxtt1][l-1]
                cn0=cni[lxit1][0]
                tn0=tni[lxit1][0]
                outfile.write('%d %d %d %d %.6f %d %.6f %d %.6f %d \n'%(year,mon,0,l,cni1,tni1,cpt1,tpt1,cn0,tn0))
            if(cni2<-0.7 and cpt2>0.7 and cpi[lxit2][6]<-0.7):
                tni2=tni[lxit2][l]
                tpt2=tp[lxtt2][l-7]
                cn0=cni[lxit2][6]
                tn0=tni[lxit2][6]
                outfile.write('%d %d %d %d %.6f %d %.6f %d %.6f %d \n'%(year,mon,19,l,cni2,tni2,cpt2,tpt2,cn0,tn0))
        
       
outfile.close()


        

