#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Thu May 27 10:54:01 2021

@author: meng
"""
from netCDF4 import Dataset
import numpy as np
import os
os.environ['PROJ_LIB'] = r'/home/meng/anaconda3/pkgs/proj-7.2.0-h8b9fe22_0/share/proj'
from matplotlib import colors 
from numpy.random import multivariate_normal 
import seaborn as sns
import pandas as pd
import matplotlib.pyplot as plt
import numpy as np
from scipy import stats
from matplotlib.ticker import MultipleLocator, FormatStrFormatter 
from scipy.stats.stats import pearsonr
from mpl_toolkits.basemap import Basemap, addcyclic, shiftgrid
from numpy import random, histogram2d, diff
import matplotlib.pyplot as plt
from scipy.interpolate import interp2d
def KS(x,y):
    a=max(max(x),max(y))
    b=min(min(x),min(y))
    z=np.linspace(b,a,50)
    lx=len(x)*1.0
    ly=len(y)*1.0
    zz=[]
    for i in z:
        xxx=[j for j in x if j<=i]
        yyy=[j for j in y if j<=i]
        zz.append(len(xxx)/lx-len(yyy)/ly)
    zza=[abs(i) for i in zz]
    c=zza.index(max(zza))
    return zz[c]

def dn(a,m,n):
    x=np.sqrt(-np.log(a/2.)*(m+n)/(2.*m*n))
    return x

def pdf(x,n):
    cnts, bins0 = np.histogram(x, bins=n, normed=False)    
    bins0 = (bins0[:-1] + bins0[1:]) / 2    
    cnts = cnts/len(x)
    return bins0,cnts

def pdf1(x,y):
    cnts, bins0 = np.histogram(x, bins=y, normed=False)    
    bins0 = (bins0[:-1] + bins0[1:]) / 2    
    cnts = cnts/len(x)
    for i in range(len(bins0)):
        if(sum(cnts[i:])==0):
            break
    return bins0[:i],cnts[:i]    
def pdswelch(x,fs): 
        
    from scipy import signal
    import numpy as np
    import matplotlib.pyplot as plt
    m=fs
    f, Pxx_den = signal.welch(x, fs, nperseg=m)
   # print (sum(Pxx_den))
    return f,Pxx_den/sum(Pxx_den)
def anualave(x,n):
    x1=np.reshape(x,(n,12))
    x2=[np.mean(x1[:,i]) for i in range(12)]
    return x2
def anualstd(x,n):
    x1=np.reshape(x,(n,12))
    x2=[np.std(x1[:,i]) for i in range(12)]
    return x2



def aunaltrend():
    path='/home/meng/bak_bupt/newproj/data/'

    
    data=np.loadtxt(path+'t2m_ori_arctic.dat')
    index=0
    x=np.reshape(data[:,index],(377,480))
    y=[np.mean(x[:,i]) for i in range(480)]
    z=np.reshape(y,(40,12))
    u=[np.mean(z[i]) for i in range(40)]
    ys=np.arange(40)+1980
    plt.plot(ys,z[:,5])
    plt.plot(ys,psdx[:,5])
    plt.plot(ys,autox[:,5])
    
  
    
    datat=np.loadtxt(path+'globalwarming')
    data2=np.loadtxt(path+'autocorr_abs_ice.dat')#reshape(480,8040)
    data3=np.loadtxt(path+'psd_sum_ICE.dat') #reshape(8040,480)
    N=377
    autocorr=data2
    aux=np.reshape(autocorr,(480,N))
    psdsum=data3
    psx=np.reshape(psdsum, (N,480))
    
    
    nodes=[]
    for i in range(N):
        if(sum(aux[:,i])>0 and sum(psx[i])>0):
            nodes.append(i)
            
    data1=np.loadtxt(path+'trend_psdsum_ice_anual.dat')
    data2=np.loadtxt(path+'trend_autocorr_ice_anual_abs.dat')
    nodes=np.where(data1[:,2]<0.05)[0]
    nodes1=data1[:,0][np.where(data1[:,2]<0.05)[0]]
    nodes2=data2[:,0][np.where(data2[:,2]<0.05)[0]]
    nodes=np.intersect1d(nodes1,nodes2)
    
    
    N=166
    month=5
    data=np.loadtxt(path+'trend_autocorr_ice_anual_abs.dat')
    nodes=[int(i) for i in data[:,0]]
    data1=np.loadtxt(path+'trend_autocorr_ice_monthly_abs.dat')
    rx1=np.reshape(data1[:,1],(N,12))
    px1=np.reshape(data1[:,2],(N,12))
    data2=np.loadtxt(path+'trend_psdsum_ice_monthly.dat')
    rx2=np.reshape(data2[:,1],(N,12))
    px2=np.reshape(data2[:,2],(N,12))
    nodes1=[nodes[i] for i in range(len(nodes)) if(px1[:,month][i]<0.05)]
    nodes2=[nodes[i] for i in range(len(nodes)) if(px2[:,month][i]<0.05)]
    signodes=nodes1+nodes2    
    
    nodes=signodes
    
    #nodes=[int(i) for i in nodes]
    nodes1=[int(i) for i in nodes1]
    nodes2=[int(i) for i in nodes2]
    auy=[np.mean(aux[i][nodes]) for i in range(480)]
    psy=[np.mean(psx[:,i][nodes]) for i in range(480)]
    
    autox=np.reshape(auy,(40,12))
    psdx=np.reshape(psy,(40,12))
    
    wv1=autox[:,5]*psdx[:,5]
    wv=wv1/np.std(wv1)    
    datai=np.loadtxt('/home/meng/bak_bupt/newproj/data/icevolum')
    #datai=np.loadtxt('/home/meng/bak_bupt/newproj/data/PIOMAS.thick.daily.1979.2022.Current.v2.1.dat')  
    outfile=open(path+'indexes_trend','w')
    for i in range(40):
        outfile.write('%d %.6f %.6f %.6f %.6f %.6f\n'%(i+1980,z[:,5][i],autox[:,5][i],datai[:,6][i+1],psdx[:,5][i],wv[i]))
        outfile.flush()
    outfile.close()
    
    data=np.loadtxt(path+'indexes_trend')

def corr_trend():
    data1=np.loadtxt(path+'trend_U850a.dat')
    data2=np.loadtxt(path+'trend_autocorr850.dat')
    data3=np.loadtxt(path+'trend_autocorr850a.dat')
    

def corr_auto_wind():
    path='/home/meng/bupt_data/data/seaice/'
    data1=np.loadtxt(path+'monthly_ano_Uwind850.nc')#reshape(8040,492)
    data1=np.loadtxt(path+'monthly_ano_tp.nc')#reshape(8040,492)
    data1=np.loadtxt(path+'monthly_ano_rh850.nc')#reshape(8040,492)
    data1=np.loadtxt(path+'monthly_ano_crr.nc')#reshape(8040,492)
    
    
    data2=np.loadtxt(path+'autocorr.dat')#reshape(480,8040)
    data3=np.loadtxt(path+'psd_sum_t850.dat') #reshape(8040,480)
    data4=np.loadtxt(path+'T850_extrem_num.dat')#reshape(8040,480)
    uwind=data1
    ux=np.reshape(uwind,(8040,492))
    autocorr=data2
    aux=np.reshape(autocorr,(480,8040))
    psdsum=data3
    psx=np.reshape(psdsum, (8040,480))
    extremp=data4[:,0]
    extremn=data4[:,1]
    extrema=data4[:,2]
    epx=np.reshape(extremp,(8040,480))
    enx=np.reshape(extremn,(8040,480))
    eax=np.reshape(extrema,(8040,480))
    
    outfile=open(path+'autocorr_rh850.dat','w')
    outfile1=open(path+'autocorr_rh850_monthly.dat','w')
    outfile2=open(path+'autocorr_rh850_anual.dat','w')
 #   outfile3=open(path+'corrAO_wneg850_scalar.dat','w')

    x=aux
    y=ux
    for i in range(8040):
        print (i)
        x1=x[:,i]
        x2=y[i][12:]
        r=pearsonr(x1,x2)[0]
        p=pearsonr(x1,x2)[1]
        y1=np.reshape(x1,(40,12))
        y2=np.reshape(x2,(40,12))
        outfile.write('%d %.6f %.6f \n'%(i,r,p))
        outfile.flush()
        yy1=[np.mean(y1[k]) for k in range(40)]
        yy2=[np.mean(y2[k]) for k in range(40)]
        r2=pearsonr(yy1,yy2)[0]
        p2=pearsonr(yy1,yy2)[1]
        outfile2.write('%.6f %.6f \n'%(r2,p2))
        outfile2.flush()
        for j in range(12):
            z1=y1[:,j]
            z2=y2[:,j]
            r1=pearsonr(z1,z2)[0]
            p1=pearsonr(z1,z2)[1]
            outfile1.write('%.6f %.6f \n'%(r1,p1))
            outfile1.flush()
    outfile.close()
    outfile1.close() 
    outfile2.close()    
 
    
    outfile=open(path+'autocorr_extrem.dat','w')
    outfile1=open(path+'autocorr_extrem_monthly.dat','w')
    outfile2=open(path+'autocorr_extrem_anual.dat','w')
 #   outfile3=open(path+'corrAO_wneg850_scalar.dat','w')

    x=aux
    y=eax
    for i in range(8040):
        print (i)
        x1=x[:,i]
        x2=y[i]
        r=pearsonr(x1,x2)[0]
        p=pearsonr(x1,x2)[1]
        y1=np.reshape(x1,(40,12))
        y2=np.reshape(x2,(40,12))
        outfile.write('%d %.6f %.6f \n'%(i,r,p))
        outfile.flush()
        yy1=[np.mean(y1[:,k]) for k in range(12)]
        yy2=[np.mean(y2[:,k]) for k in range(12)]
        r2=pearsonr(yy1,yy2)[0]
        p2=pearsonr(yy1,yy2)[1]
        outfile2.write('%.6f %.6f \n'%(r2,p2))
        outfile2.flush()
        for j in range(12):
            z1=y1[:,j]
            z2=y2[:,j]
            r1=pearsonr(z1,z2)[0]
            p1=pearsonr(z1,z2)[1]
            outfile1.write('%.6f %.6f \n'%(r1,p1))
            outfile1.flush()
    outfile.close()
    outfile1.close() 
    outfile2.close()     
    
 
    
    dataa=np.loadtxt(path+'autocorr_extrem.dat')
    datab=np.loadtxt(path+'autocorr_extrem_monthly.dat')
    datac=np.loadtxt(path+'autocorr_extrem_anual.dat')
    ra=dataa[:,1]
    pa=dataa[:,2]
    rb=datab[:,0]
    pb=datab[:,1]
    rx=np.reshape(rb,(8040,12))
    px=np.reshape(pb,(8040,12))
    rc=datac[:,0]
    pc=datac[:,1]



    ax=plt.plot()
    regrid=np.loadtxt(path+'regridcos2.5d_global.dat')
    #regrid=np.loadtxt(path+'/data/seaice/regridcos2.5d_global.dat')
    regrid2=np.loadtxt(path+'nonzeroicenodes.dat')
    nodes=np.arange(8040)
    m = Basemap(projection='robin',lon_0=-180,resolution='c')# draw coastlines, country boundaries, fill continents.
    m.drawcoastlines(linewidth = 3)
    
    m.drawparallels(np.arange(-90.,120.,15.),labels=[True,True,True,True],fontsize=34,linewidth=2)
    m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True],fontsize=34,linewidth=2)
           
    lats1=np.array(regrid[:,1][nodes])
    lons1=np.array(regrid[:,2][nodes])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    color=rc
#    m.scatter(x,y,200,marker='o',c=color,cmap='bwr')
    m.scatter(x,y,200,marker='o',c=color,cmap='bwr')          
    cb=plt.colorbar(fraction=0.025,pad=0.06)
    cb.set_label(label='Correlation to AO', size=34, weight='bold')
    cb.ax.tick_params(labelsize=34)
    a=abs(min(color))
    b=abs(max(color))
    c=max(a,b)    
    plt.clim(-c,c)
    signodes=[nodes[i] for i in range(len(nodes)) if (pc[i]<0.05)]
    print (len(signodes))
    lats1=np.array(regrid[:,1][signodes])
    lons1=np.array(regrid[:,2][signodes])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    m.scatter(x,y,200,marker='x',c='k')
       # ax.colorbar(im, fraction=0.046, pad=0.04)  
        #plt.colorbar() 
  
    
    figure = plt.gcf() # get current figure
                # 
    figure.set_size_inches(30, 12)


    plt.savefig("/home/meng/fig/autocorr_extrem.png")     



    month=2
    ax=plt.plot()
    regrid=np.loadtxt(path+'regridcos2.5d_global.dat')
    #regrid=np.loadtxt(path+'/data/seaice/regridcos2.5d_global.dat')
    regrid2=np.loadtxt(path+'nonzeroicenodes.dat')
    nodes=np.arange(8040)
    m = Basemap(projection='robin',lon_0=0,resolution='c')# draw coastlines, country boundaries, fill continents.
    m.drawcoastlines(linewidth = 3)
    
    m.drawparallels(np.arange(-90.,120.,15.),labels=[True,True,True,True],fontsize=34,linewidth=2)
    m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True],fontsize=34,linewidth=2)
           
    lats1=np.array(regrid[:,1][nodes])
    lons1=np.array(regrid[:,2][nodes])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    color=rx[:,month]
#    m.scatter(x,y,200,marker='o',c=color,cmap='bwr')
    m.scatter(x,y,200,marker='o',c=color,cmap='bwr')          
    cb=plt.colorbar(fraction=0.025,pad=0.06)
    cb.set_label(label='Correlation to AO', size=34, weight='bold')
    cb.ax.tick_params(labelsize=34)
    a=abs(min(color))
    b=abs(max(color))
    c=max(a,b)    
    plt.clim(-c,c)
    signodes=[nodes[i] for i in range(len(nodes)) if (px[i,month]<0.05)]
    print (len(signodes))
    lats1=np.array(regrid[:,1][signodes])
    lons1=np.array(regrid[:,2][signodes])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    m.scatter(x,y,200,marker='x',c='k')
       # ax.colorbar(im, fraction=0.046, pad=0.04)  
        #plt.colorbar() 
   # plt.title('$C_{min}\  March$',fontsize=34) #annual
      
    
    figure = plt.gcf() # get current figure
                # 
    figure.set_size_inches(30, 12)
    

def trend_autocorr():
    path='/home/meng/bupt_data/data/seaice/'
    path='/home/meng/bak_bupt/newproj/data/'
#    data=np.loadtxt(path+'psd_sum_t850.dat')#reshape(8040,480)
    data=np.loadtxt(path+'autocorr_abs.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'autocorr_ice.dat')#reshape(480,377)
#    data=np.loadtxt(path+'degrees_ICET.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'degrees_ICET_neg.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'degreeabs_ICET.dat')   #reshape(480,8040)

    ao=np.loadtxt(path+'AO.dat')
    aoi=ao[:,2][360:840]    
    outfile=open(path+'trend_autocorr850a.dat','w')
    outfile1=open(path+'trend_autocorr850a_monthly.dat','w')
    outfile2=open(path+'trend_autocorr850a_anual_1992to2011.dat','w')
    N=8040
    x=np.reshape(data,(480,N))
    a=0
    b=480
    #x=np.reshape(data,(8040,480))
    for i in range(N):
        print (i)
        x1=x[:,i]
        x2=np.arange(480)
        slope, intercept, r_value, p_value, std_err = stats.linregress(x2[a:b],x1[a:b])
        print (i,slope,r_value)
        y1=np.reshape(x1,(40,12))
        y2=np.reshape(x2,(40,12))
        outfile.write('%d %.6f %.6f %.6f %.6f %.6f \n'%(i,r_value,p_value,slope,intercept,std_err))
        outfile.flush()
        z1=[np.mean(y1[i]) for i in range(12,32)]
        z2=[np.mean(y2[i]) for i in range(12,32)]
        slope, intercept, r_value, p_value, std_err = stats.linregress(z1,z2)
        outfile2.write('%d %.6f %.6f %.6f %.6f %.6f \n'%(i,r_value,p_value,slope,intercept,std_err))
        outfile2.flush()        
        
        for j in range(12):
            z1=y1[:,j]
            z2=np.arange(40)
            slope, intercept, r_value, p_value, std_err = stats.linregress(z2[:],z1[:])
            outfile1.write('%d %.6f %.6f %.6f %.6f %.6f \n'%(i,r_value,p_value,slope,intercept,std_err))
            outfile1.flush()
    outfile.close()
    outfile1.close() 
    outfile2.close()



def trend_ogl():
    path='/home/meng/bak_bupt/newproj/data/'
    data=np.loadtxt(path+'monthly_ogl_monthly.dat')

 #   outfile3=open(path+'corrAO_wneg850_scalar.dat','w')
    
    x=np.reshape(data,(8040,480)) 
    
    
    outfile=open(path+'trend_ogl.dat','w')
    outfile1=open(path+'trend_ogl_monthly.dat','w')
    outfile2=open(path+'trend_ogl_anual.dat','w')
    
    
    N=8040
    a=0
    b=480
    #x=np.reshape(data,(8040,480))
    for i in range(N):
        print (i)
        x1=x[i]
        x2=np.arange(480)
        slope, intercept, r_value, p_value, std_err = stats.linregress(x2[a:b],x1[a:b])
        print (i,slope,r_value)
        y1=np.reshape(x1,(40,12))
        y2=np.reshape(x2,(40,12))
        outfile.write('%d %.6f %.6f %.6f %.6f %.6f \n'%(i,r_value,p_value,slope,intercept,std_err))
        outfile.flush()
        z1=[np.mean(y1[i]) for i in range(40)]
        z2=[np.mean(y2[i]) for i in range(40)]
        slope, intercept, r_value, p_value, std_err = stats.linregress(z1,z2)
        outfile2.write('%d %.6f %.6f %.6f %.6f %.6f \n'%(i,r_value,p_value,slope,intercept,std_err))
        outfile2.flush()        
        
        for j in range(12):
            z1=y1[:,j]
            z2=np.arange(40)
            slope, intercept, r_value, p_value, std_err = stats.linregress(z2[:],z1[:])
            outfile1.write('%d %.6f %.6f %.6f %.6f %.6f \n'%(i,r_value,p_value,slope,intercept,std_err))
            outfile1.flush()
    outfile.close()
    outfile1.close() 
    outfile2.close()



def trend_autocorr_ice():
    path='/home/meng/bak_bupt/newproj/data/'
#    data=np.loadtxt(path+'psd_sum_t850.dat')#reshape(8040,480)
#    data=np.loadtxt(path+'autocorr.dat')#reshape(480,8040)
    data=np.loadtxt(path+'autocorr_abs_ice.dat')#reshape(480,377)
#    data=np.loadtxt(path+'degrees_ICET.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'degrees_ICET_neg.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'degreeabs_ICET.dat')   #reshape(480,8040)
    datax=np.loadtxt(path+'availnodes.dat')
    nodes=[int(i) for i in datax[:,0]]
    ao=np.loadtxt(path+'AO.dat')
    aoi=ao[:,2][360:840]    
    outfile=open(path+'trend_autocorr_ice_abs.dat','w')
    outfile1=open(path+'trend_autocorr_ice_monthly_abs.dat','w')
    outfile2=open(path+'trend_autocorr_ice_anual_abs.dat','w')
    N=377
    x=np.reshape(data,(480,N))
    a=0
    b=480
    #x=np.reshape(data,(8040,480))
    for i in nodes:
        print (i)
        x1=x[:,i]

        x2=np.arange(480)
        slope, intercept, r_value, p_value, std_err = stats.linregress(x2[:],x1[:])
        print (i,slope,r_value)
        y1=np.reshape(x1,(40,12))
        y2=np.reshape(x2,(40,12))
        cut1=np.std(x1)
        cut2=np.mean(x1)
        outfile.write('%d %.6f %.6f %.6f %.6f %.6f %.6f %.6f\n'%(i,r_value,p_value,slope,intercept,std_err,cut1,cut2))
        outfile.flush()
        z1=[np.mean(y1[i]) for i in range(40)]
        z2=np.arange(40)
        cut1=np.std(z1)
        cut2=np.mean(z1)
        slope, intercept, r_value, p_value, std_err = stats.linregress(z2,z1)
        outfile2.write('%d %.6f %.6f %.6f %.6f %.6f %.6f %.6f \n'%(i,r_value,p_value,slope,intercept,std_err,cut1,cut2))
        outfile2.flush()        
        
        for j in range(12):
            z1=y1[:,j]
            z2=np.arange(40)
            cut1=np.std(z1)
            cut2=np.mean(z1)
            slope, intercept, r_value, p_value, std_err = stats.linregress(z2[:],z1[:])
            outfile1.write('%d %.6f %.6f %.6f %.6f %.6f %.6f %.6f\n'%(i,r_value,p_value,slope,intercept,std_err,cut1,cut2))
            outfile1.flush()
    outfile.close()
    outfile1.close() 
    outfile2.close()    
def trend_psdsum_ice():
    path='/home/meng/bupt_data/data/seaice/'
    path='/home/meng/bak_bupt/newproj/data/'
    datax=np.loadtxt(path+'availnodes.dat')
    nodes=[int(i) for i in datax[:,0]]
#    data=np.loadtxt(path+'psd_sum_t850.dat')#reshape(8040,480)
#    data=np.loadtxt(path+'autocorr.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'autocorr_ice.dat')#reshape(480,377)
    data=np.loadtxt(path+'psd_sum_ICE.dat')#reshape(377,480)
#    data=np.loadtxt(path+'degrees_ICET.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'degrees_ICET_neg.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'degreeabs_ICET.dat')   #reshape(480,8040)

    ao=np.loadtxt(path+'AO.dat')
    aoi=ao[:,2][360:840]    
    outfile=open(path+'trend_psdsum_icea.dat','w')
    outfile1=open(path+'trend_psdsum_ice_monthly.dat','w')
    outfile2=open(path+'trend_psdsum_ice_anual.dat','w')
    N=377
    x=np.reshape(data,(N,480))
    a=0
    b=480
    for i in nodes:
        print (i)
        x1=x[i]

        x2=np.arange(480)
        slope, intercept, r_value, p_value, std_err = stats.linregress(x2[:],x1[:])
        print (i,slope,r_value)
        y1=np.reshape(x1,(40,12))
        y2=np.reshape(x2,(40,12))
        cut1=np.std(x1)
        cut2=np.mean(x1)
        outfile.write('%d %.6f %.6f %.6f %.6f %.6f %.6f %.6f\n'%(i,r_value,p_value,slope,intercept,std_err,cut1,cut2))
        outfile.flush()
        z1=[np.mean(y1[i]) for i in range(40)]
        z2=np.arange(40)
        cut1=np.std(z1)
        cut2=np.mean(z1)
        slope, intercept, r_value, p_value, std_err = stats.linregress(z2,z1)
        outfile2.write('%d %.6f %.6f %.6f %.6f %.6f %.6f %.6f \n'%(i,r_value,p_value,slope,intercept,std_err,cut1,cut2))
        outfile2.flush()        
        
        for j in range(12):
            z1=y1[:,j]
            z2=np.arange(40)
            cut1=np.std(z1)
            cut2=np.mean(z1)
            slope, intercept, r_value, p_value, std_err = stats.linregress(z2[:],z1[:])
            outfile1.write('%d %.6f %.6f %.6f %.6f %.6f %.6f %.6f\n'%(i,r_value,p_value,slope,intercept,std_err,cut1,cut2))
            outfile1.flush()
    outfile.close()
    outfile1.close() 
    outfile2.close()   
   
        
def trend_autocorr():
    path='/home/meng/bupt_data/data/seaice/'
    data=np.loadtxt(path+'psd_sum_t850.dat')#reshape(8040,480)
#    data=np.loadtxt(path+'autocorr.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'autocorr_ice.dat')#reshape(480,377)
#    data=np.loadtxt(path+'degrees_ICET.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'degrees_ICET_neg.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'degreeabs_ICET.dat')   #reshape(480,8040)

    ao=np.loadtxt(path+'AO.dat')
    aoi=ao[:,2][360:840]    
    outfile=open(path+'trend_psdsum850.dat','w')
    outfile1=open(path+'trend_psdsum850_monthly.dat','w')
    outfile2=open(path+'trend_psdsum850_anual.dat','w')
    N=8040
    x=np.reshape(data,(N,480))
    a=0
    b=480
    #x=np.reshape(data,(8040,480))
    for i in range(N):
        print (i)
        x1=x[i]
        x2=np.arange(480)
        slope, intercept, r_value, p_value, std_err = stats.linregress(x2[:],x1[:])
        print (i,slope,r_value)
        y1=np.reshape(x1,(40,12))
        y2=np.reshape(x2,(40,12))
        outfile.write('%d %.6f %.6f %.6f %.6f %.6f \n'%(i,r_value,p_value,slope,intercept,std_err))
        outfile.flush()
        z1=[np.mean(y1[i]) for i in range(40)]
        z2=[np.mean(y2[i]) for i in range(40)]
        slope, intercept, r_value, p_value, std_err = stats.linregress(z1,z2)
        outfile2.write('%d %.6f %.6f %.6f %.6f %.6f \n'%(i,r_value,p_value,slope,intercept,std_err))
        outfile2.flush()        
        
        for j in range(12):
            z1=y1[:,j]
            z2=np.arange(40)
            slope, intercept, r_value, p_value, std_err = stats.linregress(z2[:],z1[:])
            outfile1.write('%d %.6f %.6f %.6f %.6f %.6f \n'%(i,r_value,p_value,slope,intercept,std_err))
            outfile1.flush()
    outfile.close()
    outfile1.close() 
    outfile2.close()
        
def trend_wind():
    path='/home/meng/bupt_data/data/seaice/'
#    data=np.loadtxt(path+'psd_sum_t850.dat')#reshape(8040,480)
    data=np.loadtxt(path+'monthly_ano_geo850.nc')
#    data=np.loadtxt(path+'autocorr_ice.dat')#reshape(480,377)
#    data=np.loadtxt(path+'degrees_ICET.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'degrees_ICET_neg.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'degreeabs_ICET.dat')   #reshape(480,8040)
    a=156
    b=240
    ao=np.loadtxt(path+'AO.dat')
    aoi=ao[:,2][360:840]    
    outfile=open(path+'trend_geo850.dat','w')
    outfile1=open(path+'trend_geo850_monthly.dat','w')
    outfile2=open(path+'trend_geo850_anual.dat','w')
    N=8040
    x=np.reshape(data,(N,492))
    #x=np.reshape(data,(8040,480))
    for i in range(N):
        print (i)
        x1=x[i][12:]
        x2=np.arange(480)
        slope, intercept, r_value, p_value, std_err = stats.linregress(x2[:],x1[:])
        print (i,slope,r_value)
        y1=np.reshape(x1,(40,12))
        y2=np.reshape(x2,(40,12))
        outfile.write('%d %.6f %.6f %.6f %.6f %.6f \n'%(i,r_value,p_value,slope,intercept,std_err))
        outfile.flush()
        z1=[np.mean(y1[i]) for i in range(40)]
        z2=[np.mean(y2[i]) for i in range(40)]
        slope, intercept, r_value, p_value, std_err = stats.linregress(z1,z2)
        outfile2.write('%d %.6f %.6f %.6f %.6f %.6f \n'%(i,r_value,p_value,slope,intercept,std_err))
        outfile2.flush()        

        
        for j in range(12):
            z1=y1[:,j]
            z2=np.arange(40)
            slope, intercept, r_value, p_value, std_err = stats.linregress(z2,z1)
            outfile1.write('%d %.6f %.6f %.6f %.6f %.6f \n'%(i,r_value,p_value,slope,intercept,std_err))
            outfile1.flush()
    outfile.close()
    outfile1.close() 
    outfile2.close()
def trend_degree():
    path='/home/meng/bupt_data/data/seaice/'
#    data=np.loadtxt(path+'psd_sum_t850.dat')#reshape(8040,480)
#    data=np.loadtxt(path+'autocorr.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'autocorr_ice.dat')#reshape(480,377)
#    data=np.loadtxt(path+'degrees_ICET.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'degrees_ICET_neg.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'degreeabs_ICET.dat')   #reshape(480,8040)
    data=np.loadtxt(path+'degrees_60N.dat')
    ao=np.loadtxt(path+'AO.dat')
    aoi=ao[:,2][360:840]    
    outfile=open(path+'trend_cpost850.dat','w')
    outfile1=open(path+'trend_cpost850_monthly.dat','w')
    N=8040
    x=np.reshape(data[:,1],(480,N))
    #x=np.reshape(data,(8040,480))
    for i in range(N):
        print (i)
        x1=x[:,i]
        x2=np.arange(480)
        slope, intercept, r_value, p_value, std_err = stats.linregress(x2,x1)
        print (i,slope,r_value)
        y1=np.reshape(x1,(40,12))
        y2=np.reshape(x2,(40,12))
        outfile.write('%d %.6f %.6f %.6f %.6f %.6f \n'%(i,r_value,p_value,slope,intercept,std_err))
        outfile.flush()
        
        for j in range(12):
            z1=y1[:,j]
            z2=np.arange(40)
            slope, intercept, r_value, p_value, std_err = stats.linregress(z2,z1)
            outfile1.write('%d %.6f %.6f %.6f %.6f %.6f \n'%(i,r_value,p_value,slope,intercept,std_err))
            outfile1.flush()
    outfile.close()
    outfile1.close() 




    data=np.loadtxt(path+'trend_wneg.dat')
    px=data[:,2]
    nodes0=np.where(px<0.05)[0]
    rx=data[:,1]
    nodes1=np.where(rx<0)[0]
    nodes=np.intersect1d(nodes0,nodes1)
    
def plot_trend_autocorr():
    path='/home/meng/bak_bupt/newproj/data/'
    data1=np.loadtxt(path+'trend_ogl_anual.dat')
    data2=np.loadtxt(path+'trend_ogl_monthly.dat')
    regrid=np.loadtxt(path+'regridcos2.5d_global.dat')
    #regrid=np.loadtxt(path+'/data/seaice/regridcos2.5d_global.dat')
    regrid2=np.loadtxt(path+'nonzeroicenodes.dat')
    data=data1
    ax=plt.plot()
    nodes=np.arange(8040)
    m = Basemap(projection='robin',lon_0=-180,resolution='c')# draw coastlines, country boundaries, fill continents.
    m.drawcoastlines(linewidth = 3)
    
    m.drawparallels(np.arange(-90.,120.,15.),labels=[True,True,True,True],fontsize=34,linewidth=2)
    m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True],fontsize=34,linewidth=2)
           
    lats1=np.array(regrid[:,1][nodes])
    lons1=np.array(regrid[:,2][nodes])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    color=data[:,1]
    m.scatter(x,y,200,marker='o',c=color,cmap='bwr')
#    m.scatter(x,y,200,marker='o',c=color,cmap='bwr_r')          
    cb=plt.colorbar(fraction=0.025,pad=0.06)
    cb.set_label(label='slope', size=34, weight='bold')
    cb.ax.tick_params(labelsize=34)
    a=abs(min(color))
    b=abs(max(color))
    c=max(a,b)    
    plt.clim(-c,c)
    signodes=[nodes[i] for i in range(len(nodes)) if (data[:,2][i]<0.05)]
    print (len(signodes))
    lats1=np.array(regrid[:,1][signodes])
    lons1=np.array(regrid[:,2][signodes])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    m.scatter(x,y,200,marker='x',c='k')
       # ax.colorbar(im, fraction=0.046, pad=0.04)  
        #plt.colorbar() 
    plt.title('ogl_trend',fontsize=34) #annual
      
    
    figure = plt.gcf() # get current figure
                # 
    figure.set_size_inches(30, 12)
        #plt.savefig("/home/meng/fig/community_"+str(yy)+".png")     
    plt.savefig("/home/meng/fig/trend_ogl.png")  
    
def trend_extrem():
    path='/home/meng/bupt_data/data/seaice/'
    data=np.loadtxt(path+'psd_sum_t850.dat')#reshape(8040,480)
    #data=np.loadtxt(path+'T850_extrems_monthly.dat')#reshape(8040,480)
#    data=np.loadtxt(path+'T850_extrem_num.dat')#reshape(377,480)

#    data=np.loadtxt(path+'degrees_ICET.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'degrees_ICET_neg.dat')#reshape(480,8040)
#    data=np.loadtxt(path+'degreeabs_ICET.dat')   #reshape(480,8040)

    x=data
    x=np.reshape(x,(8040,480))
    outfile=open(path+'trend_psdsum.dat','w')
    outfile1=open(path+'trend_psdsum_monthly.dat','w')
    
    #x=np.reshape(data,(8040,480))
    for i in range(8040):
       # print (i)
        x1=x[i]
        x2=np.arange(480)
        slope, intercept, r_value, p_value, std_err = stats.linregress(x2,x1)
        print (i,slope,r_value)
        y1=np.reshape(x1,(40,12))
        y2=np.reshape(x2,(40,12))
        outfile.write('%d %.6f %.6f %.6f %.6f %.6f \n'%(i,r_value,p_value,slope,intercept,std_err))
        outfile.flush()
        
        for j in range(12):
            z1=y1[:,j]
            z2=np.arange(40)
            slope, intercept, r_value, p_value, std_err = stats.linregress(z2,z1)
            outfile1.write('%d %.6f %.6f %.6f %.6f %.6f \n'%(i,r_value,p_value,slope,intercept,std_err))
            outfile1.flush()
    outfile.close()
    outfile1.close() 
    
    

def plot_trend_psdsum():
    path='/home/meng/bupt_data/data/seaice/'
    data=np.loadtxt(path+'trend_psdsum.dat')
    regrid=np.loadtxt(path+'regridcos2.5d_global.dat')
    #regrid=np.loadtxt(path+'/data/seaice/regridcos2.5d_global.dat')
    regrid2=np.loadtxt(path+'nonzeroicenodes.dat')
    ax=plt.plot()
    nodes=np.arange(8040)
    m = Basemap(projection='robin',lon_0=0,resolution='c')# draw coastlines, country boundaries, fill continents.
    m.drawcoastlines(linewidth = 3)
    
    m.drawparallels(np.arange(-90.,120.,15.),labels=[True,True,True,True],fontsize=34,linewidth=2)
    m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True],fontsize=34,linewidth=2)
           
    lats1=np.array(regrid[:,1][nodes])
    lons1=np.array(regrid[:,2][nodes])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    color=data[:,3]
    m.scatter(x,y,200,marker='o',c=color,cmap='bwr')
#    m.scatter(x,y,200,marker='o',c=color,cmap='bwr_r')          
    cb=plt.colorbar(fraction=0.025,pad=0.06)
    cb.set_label(label='slope', size=34, weight='bold')
    cb.ax.tick_params(labelsize=34)
    a=abs(min(color))
    b=abs(max(color))
    c=max(a,b)    
    plt.clim(-c,c)
    signodes=[nodes[i] for i in range(len(nodes)) if (data[:,2][i]<0.05)]
    print (len(signodes))
    lats1=np.array(regrid[:,1][signodes])
    lons1=np.array(regrid[:,2][signodes])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    m.scatter(x,y,200,marker='x',c='k')
       # ax.colorbar(im, fraction=0.046, pad=0.04)  
        #plt.colorbar() 
    plt.title('psdsum_trend',fontsize=34) #annual
      
    
    figure = plt.gcf() # get current figure
                # 
    figure.set_size_inches(30, 12)
        #plt.savefig("/home/meng/fig/community_"+str(yy)+".png")     
    plt.savefig("/home/meng/fig/psdsum_trend.png")      

def plot_trend_degree():
    path='/home/meng/bupt_data/data/seaice/'
    data=np.loadtxt(path+'trend_cpost850.dat')
    regrid=np.loadtxt(path+'regridcos2.5d_global.dat')
    #regrid=np.loadtxt(path+'/data/seaice/regridcos2.5d_global.dat')
    regrid2=np.loadtxt(path+'nonzeroicenodes.dat')
    ax=plt.plot()
    nodes=np.arange(8040)
    m = Basemap(projection='robin',lon_0=0,resolution='c')# draw coastlines, country boundaries, fill continents.
    m.drawcoastlines(linewidth = 3)
    
    m.drawparallels(np.arange(-90.,120.,15.),labels=[True,True,True,True],fontsize=34,linewidth=2)
    m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True],fontsize=34,linewidth=2)
           
    lats1=np.array(regrid[:,1][nodes])
    lons1=np.array(regrid[:,2][nodes])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    color=data[:,3]
    m.scatter(x,y,200,marker='o',c=color,cmap='bwr')
#    m.scatter(x,y,200,marker='o',c=color,cmap='bwr_r')          
    cb=plt.colorbar(fraction=0.025,pad=0.06)
    cb.set_label(label='slope', size=34, weight='bold')
    cb.ax.tick_params(labelsize=34)
    a=abs(min(color))
    b=abs(max(color))
    c=max(a,b)    
    plt.clim(-c,c)
    signodes=[nodes[i] for i in range(len(nodes)) if (data[:,2][i]<0.05)]
    print (len(signodes))
    lats1=np.array(regrid[:,1][signodes])
    lons1=np.array(regrid[:,2][signodes])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    m.scatter(x,y,200,marker='x',c='k')
       # ax.colorbar(im, fraction=0.046, pad=0.04)  
        #plt.colorbar() 
    plt.title('wneg_trend',fontsize=34) #annual
      
    
    figure = plt.gcf() # get current figure
                # 
    figure.set_size_inches(30, 12)
        #plt.savefig("/home/meng/fig/community_"+str(yy)+".png")     
    plt.savefig("/home/meng/fig/wneg_trend.png")          

def plot_trend_wind():
    path='/home/meng/bupt_data/data/seaice/'
    data=np.loadtxt(path+'trend_U850a.dat')
    regrid=np.loadtxt(path+'regridcos2.5d_global.dat')
    #regrid=np.loadtxt(path+'/data/seaice/regridcos2.5d_global.dat')
    regrid2=np.loadtxt(path+'nonzeroicenodes.dat')
    ax=plt.plot()
    nodes=np.arange(8040)
    m = Basemap(projection='robin',lon_0=0,resolution='c')# draw coastlines, country boundaries, fill continents.
    m.drawcoastlines(linewidth = 3)
    
    m.drawparallels(np.arange(-90.,120.,15.),labels=[True,True,True,True],fontsize=34,linewidth=2)
    m.drawmeridians(np.arange(0.,360.,60.),labels=[False,False,False,True],fontsize=34,linewidth=2)
           
    lats1=np.array(regrid[:,1][nodes])
    lons1=np.array(regrid[:,2][nodes])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    color=data[:,1]
    m.scatter(x,y,200,marker='o',c=color,cmap='bwr')
#    m.scatter(x,y,200,marker='o',c=color,cmap='bwr_r')          
    cb=plt.colorbar(fraction=0.025,pad=0.06)
    cb.set_label(label='r', size=34, weight='bold')
    cb.ax.tick_params(labelsize=34)
    a=abs(min(color))
    b=abs(max(color))
    c=max(a,b)    
    plt.clim(-c,c)
    signodes=[nodes[i] for i in range(len(nodes)) if (data[:,2][i]<0.05)]
    print (len(signodes))
    lats1=np.array(regrid[:,1][signodes])
    lons1=np.array(regrid[:,2][signodes])
    x, y = m(lons1,lats1)
    
        #lats1=np.array(lats1)
        #lons1=np.array(lons1)
    m.scatter(x,y,200,marker='x',c='k')
       # ax.colorbar(im, fraction=0.046, pad=0.04)  
        #plt.colorbar() 
    plt.title('Vwind_trend',fontsize=34) #annual
      
    
    figure = plt.gcf() # get current figure
                # 
    figure.set_size_inches(30, 12)
        #plt.savefig("/home/meng/fig/community_"+str(yy)+".png")     
    plt.savefig("/home/meng/fig/Vwind_trend.png")     
def corrtrend():
    data1=np.loadtxt(path+'trend_psdsum.dat')
    data2=np.loadtxt(path+'trend_autocorr850.dat')
    data3=np.loadtxt(path+'trend_wpos.dat')
    data4=np.loadtxt(path+'trend_wneg.dat')
    data5=np.loadtxt(path+'trend_cmax.dat')
    data6=np.loadtxt(path+'trend_cmin.dat')
    data7=np.loadtxt(path+'trend_T850extremP.dat')
    data8=np.loadtxt(path+'trend_T850extremN.dat')
    x=data6[:,1]
    y=data7[:,1]
    rs=pearsonr(x[4020:],y[4020:])
    rn=pearsonr(x[:4020],y[:4020])
    print (rn,rs)
    


def trend_shuffle():
    path='/home/meng/bupt_data/data/seaice/'

    outfile=open(path+'trend_wneg_syICE_syT.dat','w')
    for sy in range(1,101):
        data1=np.loadtxt(path+"degrees_ICET_syICE"+str(sy)+".dat")
        data2=np.loadtxt(path+"degrees_ICET_sy_"+str(sy)+"_pn.dat")
        n1=0
        n2=0
        m1=0
        m2=0
        x=np.reshape(data1[:,1],(480,8040))
        y=np.reshape(data2[:,2],(480,8040))
        #x=np.reshape(data,(8040,480))
        for i in range(8040):
           # print (i)
            x1=x[:,i]
            x2=np.arange(480)
            slope, intercept, r_value, p_value, std_err = stats.linregress(x2,x1)
            if(p_value<0.05):
                if(i<4020):
                    n1+=1
                else:
                    n2+=1
            x1=y[:,i]
            x2=np.arange(480)
            slope, intercept, r_value, p_value, std_err = stats.linregress(x2,x1)
            if(p_value<0.05):
                if(i<4020):
                    m1+=1
                else:
                    m2+=1
        print (sy,n1,n2,m1,m2)
        outfile.write('%d %d %d %d \n'%(n1,n2,m1,m2))
        outfile.flush()
    outfile.close()
                        
def plot_sigtrend():
    data=np.loadtxt(path+'trend_wneg_syICE_syT.dat')
    stnx=data[:,0]#shuffle temperature north part
    stsx=data[:,1]
    sinx=data[:,2]
    sisx=data[:,3]           
    data0=np.loadtxt(path+'trend_wneg.dat')
    nodes=[i for i in range(8040) if data0[:,2][i]<0.05]
    nodesn=[i for i in nodes if (i<4020)]
    nodess=[i for i in nodes if (i>4019)]
    n=len(nodesn)
    m=len(nodess)
    print (n,m)
    
    stxn,styn=pdf1(stnx,10)
    stxs,stys=pdf1(stsx,10)
    sixn,siyn=pdf1(sinx,10)
    sixs,siys=pdf1(sisx,10)    
    
  
    plt.subplot(121)
    plt.plot(stxn,styn,color='orange',linewidth=4,label='Shuffle T')
    plt.plot(sixn,siyn,color='blue',linewidth=4,label='Shuffle Ice')
    nt=np.sort(stnx)[95]
    ni=np.sort(sinx)[95]
    plt.axvline(x=nt,color='green')
    plt.axvline(x=ni,color='green',linestyle='dashed')
    plt.axvline(x=n,color='r',linewidth=4)
    plt.title('north',fontsize=24)
    plt.legend(fontsize=24)
    plt.xticks(fontsize=24)
    plt.yticks(fontsize=24)
    plt.xlabel('N',fontsize=24)
    plt.ylabel('PDF',fontsize=24)
   # plt.legend(fontsize=24)
    plt.annotate('(a)', xy=(-0.1,1.0), xycoords='axes fraction', fontsize=28 ,
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom') 
    plt.subplot(122)
    plt.plot(stxs,stys,color='orange',linewidth=4)
    plt.plot(sixs,siys,color='blue',linewidth=4)
    st=np.sort(stsx)[95]
    si=np.sort(sisx)[95]
    plt.axvline(x=st,color='green')
    plt.axvline(x=si,color='green',linestyle='dashed')
    plt.axvline(x=m,color='r',linewidth=4)
    plt.title('south',fontsize=24)    
    plt.xticks(fontsize=24)
    plt.yticks(fontsize=24)
    plt.xlabel('N',fontsize=24)
    plt.ylabel('PDF',fontsize=24)
   # plt.legend(fontsize=24)
    plt.annotate('(b)', xy=(-0.1,1.0), xycoords='axes fraction', fontsize=28 ,
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom') 
    
    plt.subplots_adjust(top = 0.95, bottom = 0.08, right = 0.9, left = 0.1, 
                hspace = 0.2, wspace = 0.3)  
    figure = plt.gcf() # get current figure
                # 
    figure.set_size_inches(20, 8)
        #plt.savefig("/home/meng/fig/community_"+str(yy)+".png")     
    plt.savefig("/home/meng/fig/PDF_wneg_trendN.png")         
  
    
  
    
  
    
    ax=plt.subplot(223)
    xmajorLocator = MultipleLocator(0.02) #将x主刻度标签设置为20的倍数
    xmajorFormatter = FormatStrFormatter('%.2f') #设置x轴标签文本的格式
    ymajorLocator = MultipleLocator(0.1) #将y轴主刻度标签设置为0.5的倍数
    ymajorFormatter = FormatStrFormatter('%.2f') #设置y轴标签文本的格式
    #设置主刻度标签的位置,标签文本的格式
    ax.xaxis.set_major_locator(xmajorLocator)
    ax.xaxis.set_major_formatter(xmajorFormatter)
    ax.yaxis.set_major_locator(ymajorLocator)
    ax.yaxis.set_major_formatter(ymajorFormatter)
    
    #修改次刻度
    xminorLocator = MultipleLocator(0.01) #将x轴次刻度标签设置为5的倍数
    yminorLocator = MultipleLocator(0.05) #将此y轴次刻度标签设置为0.1的倍数
    #设置次刻度标签的位置,没有标签文本格式
    ax.xaxis.set_minor_locator(xminorLocator)
    ax.yaxis.set_minor_locator(yminorLocator) 
    ax.tick_params(which='both', width=4)
    ax.tick_params(which='major', length=9)   
   
    x1=data[:,0][:4020]
    xd=np.reshape(datad[:,0],(100,8040))
    xa=max(x1)
    xb=max(datad[:,0])
    binx=np.linspace(0,max(xa,xb),100)
    for i in range(100):
        xx,yy=pdf1(xd[i][:4020],binx)   
        xxx=[i for i in range(len(xx)) if(yy[i]>0)]
        xxx=np.array(xxx)
        xx=np.array(xx)
        yy=np.array(yy)
        plt.plot(xx[xxx],yy[xxx],'--',color='gray')
        x=np.zeros(8040)
        y=np.arange(4020)
        for i in range(480):
            np.random.shuffle(y)
            n=numN[:,0][i]
            n=int(n)
            y1=np.array(y[:n])
            x[y1]+=1/480.
        xx,yy=pdf1(x[:4020],binx) 
        xxx=[i for i in range(len(xx)) if(yy[i]>0)]
        xxx=np.array(xxx)
        xx=np.array(xx)
        yy=np.array(yy)
        plt.plot(xx[xxx],yy[xxx],'--',color='royalblue')    
    xx,yy=pdf1(x1,binx) 
    xxx=[i for i in range(len(xx)) if(yy[i]>0)]
    xxx=np.array(xxx)
    xx=np.array(xx)
    yy=np.array(yy)
    plt.plot(xx[xxx],yy[xxx],'r',label='real',linewidth=5)
    # xx,yy=pdf1(x[0],binx)
    # xxx=[i for i in range(len(xx)) if(yy[i]>0)]
    # xxx=np.array(xxx)
    # xx=np.array(xx)
    # yy=np.array(yy)
    # plt.plot(xx[xxx],yy[xxx],'--',color='gray',label='shuffle')   
    plt.xticks(fontsize=24)
    plt.yticks(fontsize=24)
    plt.xlabel('Chance of Sig W per north node',fontsize=24)
    plt.ylabel('PDF',fontsize=24)
   # plt.legend(fontsize=24)
    plt.annotate('(c)', xy=(-0.1,1.0), xycoords='axes fraction', fontsize=28 ,
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom') 

    ax=plt.subplot(224)
    xmajorLocator = MultipleLocator(0.02) #将x主刻度标签设置为20的倍数
    xmajorFormatter = FormatStrFormatter('%.2f') #设置x轴标签文本的格式
    ymajorLocator = MultipleLocator(0.1) #将y轴主刻度标签设置为0.5的倍数
    ymajorFormatter = FormatStrFormatter('%.2f') #设置y轴标签文本的格式
    #设置主刻度标签的位置,标签文本的格式
    ax.xaxis.set_major_locator(xmajorLocator)
    ax.xaxis.set_major_formatter(xmajorFormatter)
    ax.yaxis.set_major_locator(ymajorLocator)
    ax.yaxis.set_major_formatter(ymajorFormatter)
    
    #修改次刻度
    xminorLocator = MultipleLocator(0.01) #将x轴次刻度标签设置为5的倍数
    yminorLocator = MultipleLocator(0.05) #将此y轴次刻度标签设置为0.1的倍数
    #设置次刻度标签的位置,没有标签文本格式
    ax.xaxis.set_minor_locator(xminorLocator)
    ax.yaxis.set_minor_locator(yminorLocator) 
    ax.tick_params(which='both', width=4)
    ax.tick_params(which='major', length=9)   

    x1=data[:,0][4020:]
    
    xd=np.reshape(datad[:,0],(100,8040))
    xa=max(x1)
    xb=max(datad[:,0])
    binx=np.linspace(0,max(xa,xb),100)
    for i in range(100):
        xx,yy=pdf1(xd[i][4020:],binx)   
        xxx=[i for i in range(len(xx)) if(yy[i]>0)]
        xxx=np.array(xxx)
        xx=np.array(xx)
        yy=np.array(yy)
        plt.plot(xx[xxx],yy[xxx],'--',color='gray')
        x=np.zeros(8040)
        y=np.arange(4020,8040)
        for i in range(480):
            np.random.shuffle(y)
            n=numS[:,0][i]
            n=int(n)
            y1=np.array(y[:n])
            x[y1]+=1/480.
        xx,yy=pdf1(x[4020:],binx) 
        xxx=[i for i in range(len(xx)) if(yy[i]>0)]
        xxx=np.array(xxx)
        xx=np.array(xx)
        yy=np.array(yy)
        plt.plot(xx[xxx],yy[xxx],'--',color='royalblue')    
    xx,yy=pdf1(x1,binx) 
    xxx=[i for i in range(len(xx)) if(yy[i]>0)]
    xxx=np.array(xxx)
    xx=np.array(xx)
    yy=np.array(yy)
    plt.plot(xx[xxx],yy[xxx],'r',label='real',linewidth=5)
    # xx,yy=pdf1(x[0],binx)
    # xxx=[i for i in range(len(xx)) if(yy[i]>0)]
    # xxx=np.array(xxx)
    # xx=np.array(xx)
    # yy=np.array(yy)
    # plt.plot(xx[xxx],yy[xxx],'--',color='gray',label='shuffle')   
    
    plt.xticks(fontsize=24)
    plt.yticks(fontsize=24)
    plt.xlabel('Chance of Sig W per south node',fontsize=24)
    plt.ylabel('PDF',fontsize=24)
   # plt.legend(fontsize=24)
    plt.annotate('(d)', xy=(-0.1,1.0), xycoords='axes fraction', fontsize=28 ,
                         xytext=(0, -12), textcoords='offset points',color='k',rotation=0,
                         ha='left', va='bottom') 
    
    plt.subplots_adjust(top = 0.95, bottom = 0.08, right = 0.9, left = 0.1, 
                hspace = 0.2, wspace = 0.2)  
    figure = plt.gcf() # get current figure
                # 
    figure.set_size_inches(22, 16)
        #plt.savefig("/home/meng/fig/community_"+str(yy)+".png")     
    plt.savefig("/home/meng/fig/PDF_60N_Sig_Chance.png")     
    
    